#include "info.h"
#include "a_pickups.h"
#include "d_player.h"
#include "gstrings.h"
#include "p_local.h"

// Blue key card ------------------------------------------------------------

//Duke4Ever! [CTF] Blue Card Flags and States modified

class ABlueCard : public AKey
{
	DECLARE_ACTOR (ABlueCard, AKey)
protected:
	virtual keytype_t GetKeyType ()
	{
		return it_bluecard;
	}
	virtual const char *PickupMessage ()
	{
		return GStrings(GOTBLUECARD);
	}
};

FState ABlueCard::States[] =
{
	#define S_CARDB 0
	S_NORMAL (BKEY, 'A',   10, NULL 	, &States[S_CARDB+1]),
	S_BRIGHT (BKEY, 'B',   10, NULL 	, &States[S_CARDB]),
	
	#if __CTF__		//CTF_FIX
		#define S_CFB (S_CARDB+2)
		S_NORMAL (BFLA, 'A',   5, NULL 		, &States[S_CFB+1]),
		S_NORMAL (BFLA, 'B',   5, NULL 		, &States[S_CFB+2]),
		S_NORMAL (BFLA, 'C',   5, NULL 		, &States[S_CFB+3]),
		S_NORMAL (BFLA, 'D',   5, NULL 		, &States[S_CFB+4]),
		S_NORMAL (BFLA, 'E',   5, NULL 		, &States[S_CFB+5]),
		S_NORMAL (BFLA, 'F',   5, NULL 		, &States[S_CFB+6]),
		S_NORMAL (BFLA, 'G',   5, NULL 		, &States[S_CFB+7]),
		S_NORMAL (BFLA, 'H',   5, NULL 		, &States[S_CFB+8]),
		S_NORMAL (BFLA, 'I',   5, NULL 		, &States[S_CFB+9]),
		S_NORMAL (BFLA, 'J',   5, NULL 		, &States[S_CFB+10]),
		S_NORMAL (BFLA, 'K',   5, NULL 		, &States[S_CFB+11]),
		S_NORMAL (BFLA, 'L',   5, NULL 		, &States[S_CFB+12]),
		S_NORMAL (BFLA, 'M',   5, NULL 		, &States[S_CFB+13]),
		S_NORMAL (BFLA, 'N',   5, NULL 		, &States[S_CFB+14]),
		S_NORMAL (BFLA, 'O',   5, NULL 		, &States[S_CFB+15]),
		S_NORMAL (BFLA, 'P',   5, NULL 		, &States[S_CFB]),
		#define S_CFB2 (S_CFB+16)
		S_NORMAL (BFRN, 'A',   4, NULL 		,&States[S_CFB2+0])
	#endif
};

//Duke4Ever [CTF] - States for Flag Sprites

IMPLEMENT_ACTOR (ABlueCard, Doom, 5, 85)
	PROP_RadiusFixed (20)
	PROP_HeightFixed (16)
	#if __CTF__		//CTF_FIX
		PROP_Flags (MF_SPECIAL|MF_NOTDMATCH|MF_INCTF)
		PROP_SpawnState (S_CARDB)
		PROP_SeeState (S_CFB)
		PROP_PainState (S_CFB2)
	#else
		PROP_Flags (MF_SPECIAL|MF_NOTDMATCH)
		PROP_SpawnState (0)
	#endif
END_DEFAULTS

// Yellow key card ----------------------------------------------------------

class AYellowCard : public AKey
{
	DECLARE_ACTOR (AYellowCard, AKey)
protected:
	virtual keytype_t GetKeyType ()
	{
		return it_yellowcard;
	}
	virtual const char *PickupMessage ()
	{
		return GStrings(GOTYELWCARD);
	}
};

FState AYellowCard::States[] =
{
	S_NORMAL (YKEY, 'A',   10, NULL 				, &States[1]),
	S_BRIGHT (YKEY, 'B',   10, NULL 				, &States[0])
};

IMPLEMENT_ACTOR (AYellowCard, Doom, 6, 87)
	PROP_RadiusFixed (20)
	PROP_HeightFixed (16)
	PROP_Flags (MF_SPECIAL|MF_NOTDMATCH)

	PROP_SpawnState (0)
END_DEFAULTS

// Red key card -------------------------------------------------------------

//Duke4Ever! [CTF] Red Card Flags and States modified

class ARedCard : public AKey
{
	DECLARE_ACTOR (ARedCard, AKey)
protected:
	virtual keytype_t GetKeyType ()
	{
		return it_redcard;
	}
	virtual const char *PickupMessage ()
	{
		return GStrings(GOTREDCARD);
	}
};

FState ARedCard::States[] =
{
	#define S_CARDR 0
	S_NORMAL (RKEY, 'A',   10, NULL 	, &States[S_CARDR+1]),
	S_BRIGHT (RKEY, 'B',   10, NULL 	, &States[S_CARDR]),
	#if __CTF__		//CTF_FIX
		#define S_CFR (S_CARDR+2)
		S_NORMAL (RFLA, 'A',   5, NULL 	, &States[S_CFR+1]),
		S_NORMAL (RFLA, 'B',   5, NULL 	, &States[S_CFR+2]),
		S_NORMAL (RFLA, 'C',   5, NULL 	, &States[S_CFR+3]),
		S_NORMAL (RFLA, 'D',   5, NULL 	, &States[S_CFR+4]),
		S_NORMAL (RFLA, 'E',   5, NULL 	, &States[S_CFR+5]),
		S_NORMAL (RFLA, 'F',   5, NULL 	, &States[S_CFR+6]),
		S_NORMAL (RFLA, 'G',   5, NULL 	, &States[S_CFR+7]),
		S_NORMAL (RFLA, 'H',   5, NULL 	, &States[S_CFR+8]),
		S_NORMAL (RFLA, 'I',   5, NULL 	, &States[S_CFR+9]),
		S_NORMAL (RFLA, 'J',   5, NULL 	, &States[S_CFR+10]),
		S_NORMAL (RFLA, 'K',   5, NULL 	, &States[S_CFR+11]),
		S_NORMAL (RFLA, 'L',   5, NULL 	, &States[S_CFR+12]),
		S_NORMAL (RFLA, 'M',   5, NULL 	, &States[S_CFR+13]),
		S_NORMAL (RFLA, 'N',   5, NULL 	, &States[S_CFR+14]),
		S_NORMAL (RFLA, 'O',   5, NULL 	, &States[S_CFR+15]),
		S_NORMAL (RFLA, 'P',   5, NULL 	, &States[S_CFR]),
		#define S_CFR2 (S_CFR+16)
		S_NORMAL (RFRN, 'A',   4, NULL 	,&States[S_CFR2+0])
	#endif
};

//Duke4Ever [CTF] - States for Flag Sprites

IMPLEMENT_ACTOR (ARedCard, Doom, 13, 86)
	PROP_RadiusFixed (20)
	PROP_HeightFixed (16)
	#if __CTF__		//CTF_FIX
		PROP_Flags (MF_SPECIAL|MF_NOTDMATCH|MF_INCTF)
		PROP_SpawnState (S_CARDR)
		PROP_SeeState (S_CFR)
		PROP_PainState (S_CFR2)
	#else
		PROP_Flags (MF_SPECIAL|MF_NOTDMATCH)
		PROP_SpawnState (0)
	#endif
END_DEFAULTS

// Blue skull key -----------------------------------------------------------

class ABlueSkull : public AKey
{
	DECLARE_ACTOR (ABlueSkull, AKey)
protected:
	virtual keytype_t GetKeyType ()
	{
		return it_blueskull;
	}
	virtual const char *PickupMessage ()
	{
		return GStrings(GOTBLUESKUL);
	}
};

FState ABlueSkull::States[] =
{
	S_NORMAL (BSKU, 'A',   10, NULL 				, &States[1]),
	S_BRIGHT (BSKU, 'B',   10, NULL 				, &States[0])
};

IMPLEMENT_ACTOR (ABlueSkull, Doom, 40, 90)
	PROP_RadiusFixed (20)
	PROP_HeightFixed (16)
	PROP_Flags (MF_SPECIAL|MF_NOTDMATCH)

	PROP_SpawnState (0)
END_DEFAULTS

// Yellow skull key ---------------------------------------------------------

class AYellowSkull : public AKey
{
	DECLARE_ACTOR (AYellowSkull, AKey)
protected:
	virtual keytype_t GetKeyType ()
	{
		return it_yellowskull;
	}
	virtual const char *PickupMessage ()
	{
		return GStrings(GOTYELWSKUL);
	}
};

FState AYellowSkull::States[] =
{
	S_NORMAL (YSKU, 'A',   10, NULL 				, &States[1]),
	S_BRIGHT (YSKU, 'B',   10, NULL 				, &States[0])
};

IMPLEMENT_ACTOR (AYellowSkull, Doom, 39, 88)
	PROP_RadiusFixed (20)
	PROP_HeightFixed (16)
	PROP_Flags (MF_SPECIAL|MF_NOTDMATCH)

	PROP_SpawnState (0)
END_DEFAULTS

// Red skull key ------------------------------------------------------------

class ARedSkull : public AKey
{
	DECLARE_ACTOR (ARedSkull, AKey)
protected:
	virtual keytype_t GetKeyType ()
	{
		return it_redskull;
	}
	virtual const char *PickupMessage ()
	{
		return GStrings(GOTREDSKUL);
	}
};

FState ARedSkull::States[] =
{
	S_NORMAL (RSKU, 'A',   10, NULL 				, &States[1]),
	S_BRIGHT (RSKU, 'B',   10, NULL 				, &States[0])
};

IMPLEMENT_ACTOR (ARedSkull, Doom, 38, 89)
	PROP_RadiusFixed (20)
	PROP_HeightFixed (16)
	PROP_Flags (MF_SPECIAL|MF_NOTDMATCH)

	PROP_SpawnState (0)
END_DEFAULTS
