// Emacs style mode select	 -*- C++ -*- 
//-----------------------------------------------------------------------------
//
// $Id:$
//
// Copyright (C) 1993-1996 by id Software, Inc.
//
// This source is available for distribution and/or modification
// only under the terms of the DOOM Source Code License as
// published by id Software. All rights reserved.
//
// The source is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// FITNESS FOR A PARTICULAR PURPOSE. See the DOOM Source Code License
// for more details.
//
// $Log:$
//
// DESCRIPTION:
//		Ticker.
//
//-----------------------------------------------------------------------------


#include "z_zone.h"
#include "actor.h"
#include "p_local.h"
#include "p_effect.h"
#include "p_acs.h"
#include "c_console.h"
#include "b_bot.h"
#include "doomstat.h"
#include "sbar.h"

// [NightFang] - client/server stuff
#include "cl_main.h"
#if __CTF__
//duke
//==
#include "ctf.h"
//== end
#endif


extern constate_e ConsoleState;
extern gamestate_t wipegamestate;
extern int timeleft;

// [NightFang] - we gotta have these here for player prediction
void		P_XYMovement (AActor *mo, bool bForceSlide);
void		P_ZMovement (AActor *mo);
void		P_CalcHeight (player_t *player);
void		P_SetupPsprites (player_t *player);

//
// P_Ticker
//
void P_Ticker (void)
{
	int i;

	// run the tic
	if (paused)
		return;

	// [NightFang]- Dont process anything if the connection is lagging/gone
	if (zd_serverlagging || !players[consoleplayer].mo)
		return;

	P_ResetSightCounters (false);

	// pause if in menu or console and at least one tic has been run
	
	if ( zd_localplay 
		 && !netgame
		 && (menuactive || ConsoleState == c_down || ConsoleState == c_falling)
		 && !demoplayback
		 && !demorecording
		 && players[consoleplayer].viewz != 1
		 && wipegamestate == gamestate)
	{
		return;
	}

	if (!bglobal.freeze)
	{
		P_ThinkParticles ();	// [RH] make the particles think
	}
	StatusBar->Tick ();		// [RH] moved this here

	for (i = 0; i<MAXPLAYERS; i++)
	{
		// [NightFang] - i've my way, my own waaay!
		//if (playeringame[i])// &&
		///*Added by MC: Freeze mode.*/!(bglobal.freeze && players[i].isbot))
		if (i == consoleplayer && !zd_localplay)
			continue;

		if (playeringame[i])
			P_PlayerThink (&players[i]);
	}

	level.Tick ();			// [RH] let the level tick
	DThinker::RunThinkers ();

	//if added by MC: Freeze mode.
	if (!bglobal.freeze)
	{
		P_UpdateSpecials ();
	}

	P_RunEffects ();	// [RH] Run particle effects

	#if __CTF__
		if (ctf)
		{
			for (i = 0; i<MAXPLAYERS; i++)
			{
				if (!playeringame[i])
					continue;
				for (int j=maxteams-1; j>=0; j--)
				{
					if (i==ctf_carrier_id[j])
						CTF_Update_Flag_Pos(j);
				}
			}
		}
	#endif

	// for par times
	level.time++;

	if (timeleft>0) timeleft--;
}
