#include <stdio.h>
#include <conio.h>
//#include "minilzo.h"
#include "doomdef.h"
#include "doomstat.h"
#include "gstrings.h"
#include "d_player.h"
#include "c_cvars.h"
#include "c_dispatch.h"
#include "c_bind.h"
#include "c_console.h"
#include "p_local.h"
#include "i_system.h"
#include "g_game.h"
#include "gstrings.h"

// [NightFang] - included 4
#include "a_doomglobal.h"
#include "a_sharedglobal.h"
#include "m_random.h"
#include "w_wad.h"
#include "p_effect.h"

#include "a_action.h"
#include "s_sound.h"
#include "m_argv.h"
#include "cmdlib.h"
#include "version.h"
#include "m_misc.h"
#include "gi.h"
#include "stats.h"


// [NightFang] - both of these are needed by zdaemon
#include "s_sndseq.h"
#include "sbar.h"
#include "cl_main.h"


extern		int		zd_demolasttic;
bool		net_demorecording;
bool		net_demoplayback;

FILE		*demofile;

int			demoreadcount;
bool		demofinishread;


CCMD(netrecord)
{
	char buf[MAX_PATH+1];

	// Not on the fly, I'm too lazy to re-gather all the data
	if (gamestate == GS_LEVEL)
	{
		Printf("Cannot begin recording when you're in a game already.\n");
		return;
	}
	
	// No filename supplied?
	if (argv.argc() <= 1)
	{
		Printf("\nnetrecord: Queues a demo to record apon next server connected to.\nUsage: netrecord <file>\n");
		return;
	}
	sprintf(buf,"%s.%d.zdo", argv[1], VERSION);
	FixPathSeperator(buf);
	ZD_StartDemoRecording(buf);
}


CCMD(stoprecord)
{
	if (demofile)
	{
		ZD_StopDemoRecording(msg_read);
		Printf("Recording Stopped.\n");
		return;
	}
	net_demorecording = net_demoplayback = false;
	Printf("\nnetstoprecord: No demo recorded.\n");
	return;
}

CCMD(netplay)
{
	if (demofile)
	{ 
		Printf("Already recording/playing a demo. Stop this one first.\n"); 
		return; 
	}
	if (argv.argc() <= 1)
	{
		Printf("\nnetplay: Plays a demo previously recorded.\nUsage: netplay <file>\n");
		return;
	}
	Printf("Loading demo: %s\n", argv[1]);
	ZD_LoadDemo(argv[1]);
}

CCMD(stopdemo)
{
	if (net_demorecording || !net_demoplayback)
	{
		Printf("You arent even playing a demo!\n");
		return;
	}
	ZD_StopDemoPlayback();
	Printf("Playback stopped.\n");
}



//
// ZD_StartDemoRecording
//

void	ZD_StartDemoRecording(char *fname)
{
	net_demorecording = true;
	net_demoplayback = false;

	Printf("Queued demo %s\n", fname);

	// First off, open up our file
	demofile = fopen(fname, "w+b");

	if (!demofile)
	{
		Printf("Error! Cannot create file '%s'.\n",fname);
		net_demorecording = false;
		net_demoplayback = false;
	}
	
	net_demorecording = true;
	demofinishread = false;
}



//
// ZD_CapturePacket
//

EXTERN_CVAR (Float,	autoaim);
EXTERN_CVAR (String,	name);
EXTERN_CVAR (Color,	color);
EXTERN_CVAR (String,	skin);
EXTERN_CVAR (Int,		team);
EXTERN_CVAR (String,	gender);
EXTERN_CVAR (Bool,		neverswitchonpickup);
EXTERN_CVAR (Float,	movebob);
EXTERN_CVAR (Float,	stillbob);


void ZD_CapturePacket(sizebuf_t	buf)
{
	fwrite(&buf.cursize, sizeof(int), 1, demofile);
	fwrite(buf.data, 1, buf.cursize, demofile);

	SZ_Clear(&buf);

}

void ZD_CheckPacket(sizebuf_t buf, int size)
{
	if (buf.cursize + size >= buf.maxsize)
	{
		Printf("packet too big!\n");
		ZD_CapturePacket(buf);
	}
}

//
// ZD_StartCapture
// 

void ZD_StartCapture(sizebuf_t buf, bool capturecmd)
{
	SZ_Clear(&buf);
	fixed_t	x,y,z,momx,momy,momz;

	if (players[consoleplayer].mo)
	{
		x = players[consoleplayer].mo->x;
		y = players[consoleplayer].mo->y;
		z = players[consoleplayer].mo->z;
		momx = players[consoleplayer].mo->momx;
		momy = players[consoleplayer].mo->momy;
		momz = players[consoleplayer].mo->momz;
	}

	// Capture local player movement?
	if (capturecmd)
	{
		ZD_CheckPacket(buf, 18+24);
		
		ZD_WriteByte(&buf, zddemo_capture);
		ZD_WriteLong(&buf, gametic);
		ZD_WriteByte(&buf, players[consoleplayer].cmd.ucmd.buttons);
		
		ZD_WriteWord(&buf, players[consoleplayer].cmd.ucmd.pitch);
		ZD_WriteWord(&buf, players[consoleplayer].cmd.ucmd.yaw);
		ZD_WriteWord(&buf, players[consoleplayer].cmd.ucmd.forwardmove);
		ZD_WriteWord(&buf, players[consoleplayer].cmd.ucmd.sidemove);
		ZD_WriteWord(&buf, players[consoleplayer].cmd.ucmd.upmove);
		ZD_WriteWord(&buf, players[consoleplayer].cmd.ucmd.roll);

		ZD_WriteLong(&buf, x);
		ZD_WriteLong(&buf, y);
		ZD_WriteLong(&buf, z);
		ZD_WriteLong(&buf, momx);
		ZD_WriteLong(&buf, momy);
		ZD_WriteLong(&buf, momz);

		
		if (players[consoleplayer].pendingweapon != wp_nochange)
		{
			ZD_CheckPacket(buf, 2);
			ZD_WriteByte(&buf, zddemo_switchweapon);
			ZD_WriteByte(&buf, (byte)players[consoleplayer].pendingweapon);
		}

	}

	ZD_CapturePacket(buf);
}

//
// ZD_EndCapture
//

void ZD_EndCapture (sizebuf_t buf)
{

	SZ_Clear(&buf);

	if (demo_localinfo)
	{
		player_t*	player = &players[consoleplayer];

		char	pname[MAXPLAYERNAME];
		char	pskin[64];

		strncpy (pname, name, MAXPLAYERNAME);
		strncpy (pskin, skin, 64);

		ZD_CheckPacket(buf, 8+strlen(pname)+strlen(pskin));

		ZD_WriteByte(&buf, zddemo_localuserinfo);
		ZD_WriteString(&buf, pname);
		ZD_WriteByte(&buf, D_GenderToInt (gender));
		ZD_WriteLong(&buf, color);
		ZD_WriteString(&buf, pskin);

		demo_localinfo = false;
	}


	// Toss a signal ending the packet capture
	ZD_CheckPacket(buf, 1);
	ZD_WriteByte(&buf, zddemo_endcapture);

	ZD_CapturePacket(buf);
}


//
// ZD_StopDemoRecording
//

void ZD_StopDemoRecording(sizebuf_t	buf)
{
	ZD_WriteByte(&buf, zddemo_enddemo);

	fwrite(&buf.cursize, sizeof(int), 1, demofile);
	fwrite(buf.data, 1, buf.cursize, demofile);

	if (demofile)
	{
		fclose(demofile);
		demofile = NULL;
	}

	net_demorecording = false;
	net_demoplayback = false;
}


//
// ZD_LoadDemo
// 

int demo_version = VERSION;

void ZD_LoadDemo(char *name)
{
	char *p,jnk[512];

	if (net_demorecording)
	{
		Printf("You are currently recording a demo. Stop recording first.\n");
		return;
	}

	net_demorecording = false;
	net_demoplayback = true;
	demofinishread = false;

	strcpy(jnk,name);
	FixPathSeperator(jnk);

	demofile = fopen(jnk, "rb");

	if (!demofile)
	{ 
		Printf("Unable to load demo %s\n", jnk);
		return;
	}

	demo_version = VERSION;
	if ( (p = strrchr(jnk,'.')) != NULL )
	{
		*p = '\0';
		if ( (p=strrchr(jnk,'.')) != NULL )
		{
			if		(!strcmp(p,".100"))	demo_version = 100;
			else if	(!strcmp(p,".101"))	demo_version = 100;
			else if	(!strcmp(p,".102"))	demo_version = 100;
			else if	(!strcmp(p,".103"))	demo_version = 100;
			else if	(!strcmp(p,".104"))	demo_version = 100;
			else if	(!strcmp(p,".105"))	demo_version = 105;
		}
	}
	Printf("Demo Version: %d\n",demo_version);

	zd_netstate = ZD_NOTHING;
	zd_localplay = false;
	gameaction = ga_fullconsole;

	Printf("Demo is now local.\n");

	// Number of bytes to determine how far we are into the file
	demoreadcount = 0;
}


//
// ZD_FindDemoPacket
// 

void ZD_FindDemoPacket(void)
{
	int		size;
	bool	error;			 //Kilgore: error handling

	demofinishread = false;

	zd_lastservertic = gametic;
	error = false;
	while (!demofinishread)
	{
		// Clear the read-buffer & readcount
		SZ_Clear(&msg_read);
	
		msg_read.readcount = 0;

		// Get packet size
		if (fread(&size, sizeof(int), 1, demofile) != 1)
		{
			Printf("ERROR: PREMATURE END OF DEMO FILE\n"); 
			error = true;
		}
		else  if (size<0)
		{
			Printf("ERROR: CORRUPTED DEMO FILE: NEGATIVE PACKET SIZE\n"); 
			error = true;
		}
		else if (size>sizeof(msg_read.data))
		{
			Printf("ERROR: CORRUPTED DEMO FILE: TOO LARGE PACKET\n"); 
			error = true;
		}
		else if (size>0  &&  fread(&msg_read.data,1,size,demofile) != (size_t)size)
		{
			Printf("ERROR: PREMATURE END OF DEMO FILE\n"); 
			error = true;
		}
		else
		{
			msg_read.cursize = size;			// Setup the read buffer
		}

		if (error)				//Kilgore: make it finish gracefully
		{
			msg_read.data[0] = zddemo_enddemo;
			msg_read.cursize = 1;
		}

		demoreadcount++;

		// Parse the packet that was just streamed from the buffer
		//ZD_ReadPacketHeader();
		ZD_ParsePacket();
	}

	demofinishread = false;
}


//
// ZD_StopDemoPlayback
//

void ZD_StopDemoPlayback(void)
{
	// Close the file
	fclose(demofile);
	demofile = NULL;

	// Full console
	gameaction = ga_fullconsole;

	// Declare gamestate varibles
	net_demoplayback = false;
	net_demorecording = false;
	zd_localplay = true;
}


