#include <stdio.h>
#include <conio.h>
#include "doomdef.h"
#include "doomstat.h"
#include "gstrings.h"
#include "d_player.h"
#include "c_cvars.h"
#include "c_dispatch.h"
#include "c_bind.h"
#include "c_console.h"
#include "p_local.h"
#include "i_system.h"
#include "g_game.h"
#include "gstrings.h"

// [NightFang] - included 4
#include "a_doomglobal.h"
#include "a_sharedglobal.h"
#include "m_random.h"
#include "w_wad.h"
#include "p_effect.h"
#include "templates.h"

#include "a_action.h"
#include "s_sound.h"
#include "m_argv.h"
#include "cmdlib.h"
#include "version.h"
#include "m_misc.h"
#include "gi.h"
#include "stats.h"

// [NightFang] - both of these are needed by zdaemon
#include "s_sndseq.h"
#include "cl_main.h"
#include "sbar.h"
#include "v_video.h"
#include "chatlog.h"
#if __CTF__
//duke
//==
#include "actor.h"
#include "ctf.h"
//== end
#endif

bool		zd_localplay;
bool		rcon_access;
bool		demo_localinfo;
int			zd_demolasttic;
int			zd_netstate;		// Network status (connected, connecting..? etc)
int			zd_inbytes;
int			zd_outbytes;
int			difftics;
int			zd_uncompressedinbytes,zd_uncompressedoutbytes;
int			zd_lastservertic;	// Last time we heard from the server
int			zd_motdtics;		// MOTD tics
DHUDMessage	*zd_motd;			// MOTD message

int			addr_timeout;		// Number of tics until our attempt will timeout
int			need_reborn;

int			packetseq[256];
byte		packetnum;

int			zd_servertimeout;
bool		zd_serverlagging;
bool		zd_clientlagging;
int			zd_lasttic;
int			zd_level;

sizebuf_t	localbuf;			// Local buffer for the client
ticcmd_t	zd_localcmds[MAXSAVETICS];
netadr_t	remoteaddr;			

// External functions for this file only
void	A_RestoreSpecialDoomThing (AActor *self);
void	A_RestoreSpecialPosition (AActor *self);
void	G_QueueBody (AActor *body);
void	P_CalcHeight (player_t *player);
void	M_StartMessage (const char *string, void (*routine)(int), bool input);

CVAR (String, password, NULL, CVAR_ARCHIVE)
//CVAR (Int, maxrate,		1500, CVAR_ARCHIVE|CVAR_USERINFO)
EXTERN_CVAR (Float, sv_gravity)
EXTERN_CVAR (Float, sv_aircontrol)
EXTERN_CVAR (Int, timelimit)
EXTERN_CVAR (Bool, chaseview)
EXTERN_CVAR (Bool, cl_showsprees)
EXTERN_CVAR (Bool, cl_showmultikills)

extern int	timeleft;		// in ticks

CUSTOM_CVAR (Int, zd_useskins, 1, CVAR_ARCHIVE)
{
	int			i, use_skins;
	player_t	*p;

	use_skins = self;
	for (i=0; i<MAXPLAYERS; i++)
	{
		if (!playeringame[i]) continue;
		p = players+i;
		p->userinfo.actual_skin =	(zd_useskins) ?	p->userinfo.requested_skin :
									(p->isbot) ?	R_FindSkin("zbot") :
													R_FindSkin("base") ;
		p->skin = &skins[p->userinfo.actual_skin];
		if (p->mo) p->mo->sprite = p->skin->sprite;
	}
}

void	STACK_ARGS Network_Error(char	*s,...)
{
	I_FatalError(s);
}

CCMD(rcon_password)
{
	if (argv.argc() > 1)
	{
		if (zd_localplay)
		{ Printf("rcon_password: You need to be connected first.\n"); return; }

		ZD_WriteByte(&localbuf, cl_requestrcon);
		ZD_WriteString(&localbuf, argv[1]);

		Printf("rcon_password: Request sent\n");
	}
	else
		Printf("rcon_password: Requests access to the server console\nusage: rcon_password <password>\n");
}

CCMD(rcon)
{
	char		str[1024];
	char		append[256];

	if (!rcon_access)
	{ Printf("rcon: You do not have access\n"); return; }

	if (zd_localplay)
	{ Printf("rcon: You need to be connected first\n"); return; }

	if (argv.argc() > 1)
	{
		memset(str, 0, 1024);
		memset(append, 0, 256);
		int last = argv.argc()-1;
		for (int i = 1; i <= last; ++i)
		{
			sprintf(append, "%s ", argv[i]);
			strcat(str, append);
		}
	
		// Alright, enviorment is correct, the string has been built
		// SEND IT!
		ZD_WriteByte(&localbuf, cl_rconcmd);
		ZD_WriteString(&localbuf, str);
	}
	else
		Printf("rcon: Sends a console command for the server to execute\nusage: rcon <command>\n");
		
}


CCMD(netstate)
{
	Printf("Gameplay is %s.\n", (zd_localplay) ? "local" : "remote" );
}


// CONNECT command
CCMD(connect)
{
	if (argv.argc() > 1)
	{
		// First, game is no longer a local game
		Printf("Game is now remote.\n");

		zd_localplay = false;

		NET_StringToAdr (argv[1], &remoteaddr);
		
		if (!remoteaddr.port)
           I_SetPort(remoteaddr, SERVER_PORT);

		// Attempt message
		ZD_AttemptConnection();

		// Get into full console mode
		gameaction = ga_fullconsole;

		// Finally set the timeout
		addr_timeout = 15*TICRATE;

		// Set our network state
		zd_netstate = ZD_TRYCONNECTION;
	}
	else
	{
		Printf("Connect: Attempt to open a network connection\nUsage: connect <address>\n");
	}
}

CCMD(reconnect)
{
	if (remoteaddr.ip[0])
	{ 
		// In case we're already playing
		ZD_QuitNetGame();

		// Full console
		gameaction = ga_fullconsole;

		// First, game is no longer a local game
		Printf("Game is now remote.\n");

		zd_localplay = false;

		// Attempt message
		ZD_AttemptConnection();

		// Finally set the timeout
		addr_timeout = 15*TICRATE;

		// Set our network state
		zd_netstate = ZD_TRYCONNECTION;
	}
	else
	{
		Printf("You have not connected anywhere yet!\n");
	}
}



CCMD(disconnect)
{
	// Send message to the server that we're disconnecting
	ZD_QuitNetGame();
	ZD_ResetPlayerArray();

	// Get back into full console mode
	gameaction = ga_fullconsole;

	// Then, game is no longer a local game
	Printf("Game is now local.\n");
}

int		zdbin,zdbout,zduin,zduout;

ADD_STAT(net, out)
{
	if (!(gametic % TICRATE))
	{
		zdbin = zd_inbytes;
		zdbout = zd_outbytes;
		zduin = zd_uncompressedinbytes;
		zduout = zd_uncompressedoutbytes;
		zd_inbytes = zd_outbytes = zd_uncompressedinbytes = zd_uncompressedoutbytes = 0;
	}
	sprintf(out, "In Bytes: %d Out Bytes: %d  Tics: %d", zdbin, zdbout, difftics);
}


ADD_STAT(me, out)
{
	sprintf(out, "State: %d   Weapon: %d", players[consoleplayer].playerstate, players[consoleplayer].readyweapon, gamestate);
}

#if __CTF__
//duke
//==

static void CTF_Fix_Flag_Behavior(void)
{
	int		i;
	AActor	*mo;

	for (i=maxteams-1; i>=0; i--)
	{
		if ( ctf_state[i]==CTF_FS_TAKEN || ctf_state[i]==CTF_FS_DROPPED )
		{
			if ( (mo = ctf_flag_mo[i]) != NULL )
			{
				mo->flags |= MF_NOCLIP | MF_NOBLOCKMAP | MF_DROPOFF;
				mo->flags &= ~MF_SOLID;
				mo->flags2 |= MF2_PASSMOBJ;
			}
		}
	}
}

typedef struct {
	int			 spec_evt_id;
	const char	*msg;
	EColorRange	color;
} evt_info;

void ZD_ctf_event(void)
{
	int			i, ctf_evt_id, nteams, v, new_state[NUM_TEAMS], new_carrier[NUM_TEAMS];
	evt_info	*pei;
	bool		is_sane;
	DHUDMessage	*mmsg;
	static evt_info ei[18] = {
		{	-1,					NULL,					CR_WHITE	},
		{	SE_RED_TAKEN,		"RED FLAG TAKEN",		CR_WHITE	},
		{	SE_RED_DROPPED,		"RED FLAG DROPPED",		CR_BRICK	},
		{	SE_RED_RETURNED,	"RED FLAG RETURNED",	CR_GREEN	},
		{	SE_RED_SCORES,		"RED TEAM SCORES",		CR_GOLD		},
		{	SE_BLUE_TAKEN,		"BLUE FLAG TAKEN",		CR_WHITE	},
		{	SE_BLUE_DROPPED,	"BLUE FLAG DROPPED",	CR_BRICK	},
		{	SE_BLUE_RETURNED,	"BLUE FLAG RETURNED",	CR_GREEN	},
		{	SE_BLUE_SCORES,		"BLUE TEAM SCORES",		CR_GOLD		},
		{	SE_ASSIST,			"ASSIST",				CR_WHITE	},
		{	SE_GREEN_TAKEN,		"GREEN FLAG TAKEN",		CR_WHITE	},
		{	SE_GREEN_DROPPED,	"GREEN FLAG DROPPED",	CR_BRICK	},
		{	SE_GREEN_RETURNED,	"GREEN FLAG RETURNED",	CR_GREEN	},
		{	SE_GREEN_SCORES,	"GREEN TEAM SCORES",	CR_GOLD		},
		{	SE_WHITE_TAKEN,		"WHITE FLAG TAKEN",		CR_WHITE	},
		{	SE_WHITE_DROPPED,	"WHITE FLAG DROPPED",	CR_BRICK	},
		{	SE_WHITE_RETURNED,	"WHITE FLAG RETURNED",	CR_GREEN	},
		{	SE_WHITE_SCORES,	"WHITE TEAM SCORES",	CR_GOLD		}
		};

	is_sane = true;

	ctf_evt_id = ZD_ReadByte();
	if (ctf_evt_id<0 || ctf_evt_id>17)
		is_sane = false;

	nteams = maxteams;
	for (i=0; i<nteams; i++)
	{
		v = ZD_ReadByte();
		if (v<0 || v>3)
			is_sane = false;
		new_state[i] = v;
	}
	for (i=0; i<nteams; i++)
		new_carrier[i]	= ZD_ReadShort();

	// sanity check.
	if (!is_sane)
		return;

	// copy data over.
	memcpy(ctf_state,new_state,sizeof(new_state));
	memcpy(ctf_carrier_id,new_carrier,sizeof(new_carrier));

	CTF_Fix_Flag_Behavior();

	if (ctf_evt_id)			// show message.
	{
		pei = ei + ctf_evt_id;
		if (pei->spec_evt_id!=SE_ASSIST || consoleplayer==displayplayer)
		{
			screen->SetFont(BigFont);
			mmsg = new DHUDMessageFadeOut(pei->msg, 1.5f, 0.2f,pei->color, 3.f, 0.5f);
			StatusBar->AttachMessage (mmsg,'CTFE');
			ZD_SpecialEvent(consoleplayer,pei->spec_evt_id,0);
		}
	}
}

void ZD_ctf_state(void)
{
	int i, n, new_state[NUM_TEAMS];

	n = maxteams;
	for (i=0; i<n; i++)
		new_state[i] = ZD_ReadByte();
	for (i=0; i<n; i++)
		ctf_carrier_id[i] = ZD_ReadShort();

	for (i=0; i<n; i++)
	{
		if (new_state[i]<0 || new_state[i]>3)
			memset(new_state,0,sizeof(new_state));
	}
	memcpy(ctf_state,new_state,sizeof(new_state));

	CTF_Fix_Flag_Behavior();
}

//== end
#endif

void ZD_VerifyReconnect (int ch)
{
	if (ch == 'y')
	{
		C_DoCommand("reconnect");
		return;
	}
	D_StartTitle();
}

void ZD_QueryReconnect(void)
{
	M_StartMessage ("Your connection has been lost.\nAttempt to reconnect?\n\n(Y)es  (N)o", ZD_VerifyReconnect, true);
}

void ZD_VerifyEndDemo (int ch)
{
	D_SetupUserInfo();
	D_StartTitle();

}

void ZD_DemoEndMessage(void)
{
	M_StartMessage("Replay has ended. Press the use key.", ZD_VerifyEndDemo, true);
}

void ZD_EndGameKicked(void)
{
	char		str[1024];
	char		*reason = ZD_ReadString();

	zd_netstate = ZD_NOTHING;
	sprintf(str, "You have been kicked from the server.");
	M_StartMessage(str, ZD_VerifyEndDemo, true);
}


void ZD_CheckMissedPacket(void)
{
	int    sequence;
	short  size;

	sequence = ZD_ReadLong();
	size = ZD_ReadShort();

	for (int n=0; n<256; n++)
	{
		// skip a duplicated packet
		if (packetseq[n] == sequence)
		{
			for (int i=0; i<size; i++)
			{ ZD_ReadByte(); }

			//Printf("%d is a duplicate packet!\n", sequence);

			return;
		}
	}
}

// 
// ZD_ReadPacketHeader
//
void ZD_ReadPacketHeader(void)
{
	ZD_ReadByte();	// sv_header
	int sequence = ZD_ReadLong();
	
	if (!net_demoplayback)
	{
		ZD_WriteByte(&localbuf, cl_ack);
		ZD_WriteLong(&localbuf, sequence);
	}

	packetseq[packetnum] = sequence;
	packetnum++;
}

//
// ZD_WaitForServer - Just calculates server timeout time
//

void ZD_WaitForServer(void)
{
	// We've got to be actually playing
	if (difftics >= TICRATE*3 && players[consoleplayer].playerstate != PST_WATCHING)
		zd_clientlagging = true;
	else
		zd_clientlagging = false;

	if (gametic - zd_lastservertic >= (TICRATE*35)*2)
	{
		if (!zd_serverlagging)
		{
			// Yes, the server is lagging, wait for 10 seconds before declaring a timeout
			zd_serverlagging = true;
			zd_servertimeout = 10*TICRATE;
			return;
		}

		zd_servertimeout--;

		if (zd_servertimeout <= 0)
		{
			// Send quit signal, why...?
			ZD_QuitNetGame();

			// Output and reset.
			Printf("\nConnection lost.\n\n");
			zd_serverlagging = false;
			zd_servertimeout = 0;


			ZD_QueryReconnect();
		}
	}
}

void STACK_ARGS DoConsoleAtExit();

//
// ZD_QuitNetGame
//
void ZD_QuitNetGame(void)
{
	DoConsoleAtExit();

	// Not connected
	if (zd_netstate != ZD_NOTHING)
	{
			
		ZD_WriteByte(&localbuf, CONNECT_QUIT);
		ZD_LaunchPacket(localbuf, remoteaddr);
		SZ_Clear(&localbuf);
	}

	// Reset network state
	zd_netstate = ZD_NOTHING;
	
	zd_localplay = true;
	
	Printf("Game is now local.\n");
}

//
// ZD_ResetPlayerArray
// 

void ZD_ResetPlayerArray(void)
{
		// Reset the player array
	memset (playeringame, 0, sizeof(playeringame));

	// We are now the sole and only consoleplayer!
	consoleplayer = 0;
	playeringame[consoleplayer] = true;
	D_SetupUserInfo();
	update_rank_spread_info();
}

//
// ZD_ResetGametic 
// 

void ZD_ResetGametic(void)
{

}


//
// ZD_MoveThing - 
//


void ZD_MoveThing(AActor *mobj, fixed_t x, fixed_t y, fixed_t z)
{

   if (!mobj || gamestate != GS_LEVEL)
	   return;
   
   mobj->SetOrigin(x,y,z);

   // ZDaemon
   //mobj->last_recieved = gametic;
   //mobj->active = true;
}



//
// ZD_AttemptConnection - Will keep trying an address until timed out
//

void ZD_AttemptConnection(void)
{
	UCVarValue	pswd = password.GetGenericRep (CVAR_String);

	if (addr_timeout <= 0)
		return;

	zd_serverlagging = false;
	zd_clientlagging = false;
	difftics = 0;

	// A connection to the server has been established, we need to send
	// our userinfo down before beginning any further
	if (zd_netstate == ZD_CONNECTING && addr_timeout > 0)
	{
		addr_timeout--;

		// Connection timed out
		if (addr_timeout==0)
		{
			Printf("Unable to connect.\n");
			return;
		}
		
		if (gametic % (TICRATE*2))
			return;

		memset(packetseq, -1, sizeof(packetseq) );
		packetnum = 0;
	
		//for (int i=0; i<MAXPLAYERS; i++)
		//{ playeringame[i] = false; }

		ZD_WriteByte(&localbuf, CONNECT_GETDATA);
		ZD_SendUserInfo();
		ZD_LaunchPacket(localbuf, remoteaddr);
		SZ_Clear(&localbuf);
		Printf("Requesting gamestate\n");
		return;
	}

	// Clear out any playeringame varibles so that loading up another
	// level wont screw things up
	int		i;
	for (i=0; i<MAXPLAYERS; i++)
	{ 
		playeringame[i] = false;
	}
	consoleplayer = 0;
	update_rank_spread_info();

	addr_timeout--;

	// Connection timed out
	if (addr_timeout==0)
	{
		Printf("Unable to connect.\n");
		return;
	}
	
	if ((gametic % (TICRATE*2)))
		return;
		
	
	Printf("Request Challenge: %s\n", NET_AdrToString (&remoteaddr));

	ZD_WriteByte(&localbuf, CONNECT_CHALLENGE);

	#if	VER107
		ZD_WriteByte(&localbuf, 248);		//Kilgore: beta testing (HSDEBUG)
	#else
		ZD_WriteByte(&localbuf, VERSION);
	#endif

	ZD_WriteByte(&localbuf, zd_level);
	ZD_WriteString(&localbuf, pswd.String);

	WC_Send_Names_Checksums(&localbuf);				//Raider: send the wad names & checksums

	ZD_LaunchPacket(localbuf, remoteaddr);
	SZ_Clear(&localbuf);
}


//
// ZD_Error - Errors that require a terminating connection
//

void ZD_Error(char *text)
{
	// Reset network state
	zd_netstate = ZD_NOTHING;
	
	// Get back into full console mode
	gameaction = ga_fullconsole;

	// Then, game is no longer a local game
	Printf("\n%s\n", text);

	zd_localplay = true;
	Printf("Game is now local due to error.\n");
}

//
// ZD_Kicked - Someone's been naughty
//
void ClearConsole (void);
void ZD_Kicked(void)
{
	char		*reason = ZD_ReadString();

	ClearConsole();
	// Reset network state
	zd_netstate = ZD_NOTHING;
	zd_localplay = true;
	
	// Get back into full console mode
	gameaction = ga_fullconsole;

	// Then, game is no longer a local game
	Printf("Server has tossed your connection attempt into the cold void.\n\n%s\n", reason);
}


//
// ZD_SendCmd
//
void ZD_SendCmd(void)
{		
	ticcmd_t *cmd;
	//int		 i;

	if (gametic < 1 || zd_localplay || (gamestate != GS_LEVEL && gamestate != GS_INTERMISSION))
		return;

	if (!players[consoleplayer].mo)
		return;

	//if (difftics == 0) difftics = 1;

	
	//cmd = &zd_localcmds[gametic%MAXSAVETICS];

	ZD_WriteByte(&localbuf, cl_clientmove);
	ZD_WriteLong(&localbuf, gametic);
	

	//////////////////////////////////////////////////////////////////////////

	/*cmd = &zd_localcmds[(gametic-1) % MAXSAVETICS];		
	ZD_WriteByte(&localbuf, cmd->ucmd.buttons);
	ZD_WriteWord(&localbuf, cmd->ucmd.forwardmove);
	ZD_WriteWord(&localbuf, cmd->ucmd.sidemove);
	ZD_WriteWord(&localbuf, cmd->ucmd.upmove);
	if (cmd->ucmd.buttons & BT_ATTACK)
	{ ZD_WriteByte(&localbuf, players[consoleplayer].readyweapon); }*/

	////////////////////////////////////////////////////////////////////////

	cmd = &players[consoleplayer].cmd;
	ZD_WriteByte(&localbuf, cmd->ucmd.buttons);
	//ZD_WriteWord(&localbuf, cmd.ucmd.pitch);
	
	//Duke4Ever changed this to fix freelook:
	//ZD_WriteWord(&localbuf, players[consoleplayer].mo->pitch);
	ZD_WriteWord(&localbuf, cmd->ucmd.pitch);
	
	ZD_WriteWord(&localbuf, cmd->ucmd.yaw);
	ZD_WriteWord(&localbuf, cmd->ucmd.forwardmove);
	ZD_WriteWord(&localbuf, cmd->ucmd.sidemove);
	ZD_WriteWord(&localbuf, cmd->ucmd.upmove);
	ZD_WriteWord(&localbuf, cmd->ucmd.roll);

	if (gamestate != GS_LEVEL) // intermission or something
		ZD_WriteLong(&localbuf, 0);	// angle
	else
		ZD_WriteLong(&localbuf, players[consoleplayer].mo->angle);

		// Attack button
	if (cmd->ucmd.buttons & BT_ATTACK)
	{ ZD_WriteByte(&localbuf, players[consoleplayer].readyweapon); }

	// Kill the MOTD message
	if (zd_motdtics)
	{
		if (cmd->ucmd.buttons & BT_ATTACK || cmd->ucmd.buttons & BT_USE)
			StatusBar->DetachMessage(zd_motd);
	}

	ZD_LaunchPacket(localbuf, remoteaddr);
	SZ_Clear(&localbuf);
}



//
// ZD_SendUserInfo - Sends the server user information

EXTERN_CVAR (Float,	autoaim);
EXTERN_CVAR (String,	name);
EXTERN_CVAR (Color,	color);
EXTERN_CVAR (String,	skin);
EXTERN_CVAR (Int,		team);
EXTERN_CVAR (String,	gender);
EXTERN_CVAR (Bool,		neverswitchonpickup);
EXTERN_CVAR (Float,	movebob);
EXTERN_CVAR (Float,	stillbob);

void ZD_SendUserInfo(void)
{
	char	pname[MAXPLAYERNAME];
	char	pskin[64];

	strncpy (pname, name, MAXPLAYERNAME);
	strncpy (pskin, skin, 64);

	// This is actually a much better way to do this, it grabs
	// the varibles straight from the cvar values and not
	// what the consoleplayer has.
	ZD_WriteByte(&localbuf, cl_userinfo);
	ZD_WriteString(&localbuf, pname);
	ZD_WriteByte(&localbuf, team);		//Kilgore
	ZD_WriteByte(&localbuf, D_GenderToInt (gender));
	ZD_WriteLong(&localbuf, color);

	//ZD_WriteLong(&localbuf, abs ((int)(autoaim * (float)ANGLE_1)));
	players[consoleplayer].userinfo.aimdist = (autoaim > 35.f || autoaim < 0.f) ?
							ANGLE_1*35 : abs ((int)(autoaim * (float)ANGLE_1));
	
	ZD_WriteLong(&localbuf, players[consoleplayer].userinfo.aimdist);

	ZD_WriteString(&localbuf, pskin);

	ZD_WriteByte(&localbuf, (players[consoleplayer].userinfo.neverswitch) ? 10 : 0);

	//ZD_WriteLong(&localbuf, maxrate);

	// Capture usercmd
	if (net_demorecording)
		demo_localinfo = true;
}

extern int demo_version;

//
// ZD_GetUserInfo - Gets userinfo for another client (other than us)
//

void ZD_GetUserInfo(void)
{

    player_t	*p;
	char		*str;
	int			t;
	int			pnum;
	int			old_team;
	
	pnum = ZD_ReadByte();
    p = &players[pnum];

	// Players name
	str = ZD_ReadString();
	if (strlen(str) > MAXPLAYERNAME)
		str[MAXPLAYERNAME] = '\0';
	//stringupr(str);
	strcpy(p->userinfo.netname, str);

	if (net_demoplayback && demo_version==100)		//Kilgore: handle older demos
	{
		p->userinfo.team = NUM_TEAMS-1;
		memset(p->net_address.ip,0,sizeof(p->net_address.ip));
		p->net_address.port = 0;
	}
	else
	{
		//Kilgore: read team with the last one being the default
		old_team = p->userinfo.team;
		t = ZD_ReadByte();
		if (t<0 || t>=NUM_TEAMS) t = NUM_TEAMS-1;
		p->userinfo.team = t;

		ZD_ReadBytes(p->net_address.ip,sizeof(p->net_address.ip));		//Kilgore
		p->net_address.port = ZD_ReadWord();							//Kilgore
	}

    // Other info
	p->userinfo.gender = ZD_ReadByte();
    p->userinfo.color = ZD_ReadLong();

	// Build translation tables, always gotta do this
	R_BuildPlayerTranslation (pnum, p->userinfo.color);
    
	// Make sure the skin is valid
	p->userinfo.requested_skin = R_FindSkin(ZD_ReadString());

#if 1	//HSDEBUGB
	p->userinfo.actual_skin =	(zd_useskins) ?		p->userinfo.requested_skin :
								(p->isbot) ?		R_FindSkin("zbot") :
													R_FindSkin("base") ;
#else
	p->userinfo.actual_skin = p->userinfo.requested_skin;
#endif

	if (teamplay)		//Kilgore
	{
		// Stop spying on another player if he changes team 
		// in teamplay mode (and when we are actually participating and not
		// spectating and also when not in demo mode).
		if ( old_team!=t  && 
			 pnum==displayplayer &&
			 players[consoleplayer].playerstate != PST_WATCHING && 
			 !net_demoplayback )
			G_ChangeSpy(consoleplayer);
		else if (StatusBar && pnum==displayplayer)
			StatusBar->AttachToPlayer(p);
	}
}


//
// ZD_SetupLevel - Gets map / states, everything and loads it all up
// 

static void  ZD_SetupLevel(int version, bool ignore)
{
	char	*map;
	int		total_monsters, killed_monsters, total_items, total_secrets;
	
	map = ZD_ReadString();
	if (version<107)
	{
		total_monsters = killed_monsters = total_items = total_secrets = 0;
	}
	else
	{
		total_monsters = ZD_ReadShort();
		killed_monsters = ZD_ReadShort();
		total_items = ZD_ReadShort();
		total_secrets = ZD_ReadShort();
		Printf("DEBUG: Received level %s info: %d monsters, %d items, %d secrets\n", map, level.total_monsters, level.total_items, level.total_secrets);
	}

	if (ignore)
		return;

	if (W_CheckNumForName(map) != -1)
	{
		// Start new level
		G_InitNew(map);
		zd_netstate = ZD_CONNECTED;

		// Lyfe - Dec 16
		// now that we have the map setup, we need to assign the monsters, items, secrets, etc.
		level.total_monsters = total_monsters;
		level.killed_monsters = killed_monsters;
		level.total_items = total_items;
		level.total_secrets = total_secrets;

		// Kill the console
		C_HideConsole();
	}
	else
	{
		Printf("ERROR** Dont know map %s\n", map);
	}
}

//
// ZD_FindThingById - Ripped from the old src
//
AActor* ZD_FindThingById(int id)
{
    AActor *mo;
	
    // Try normal AActors first
	TThinkerIterator<AActor> iterator;
    while ( (mo = iterator.Next() ) )
    {
		if (mo->netid == id)
    	    return mo;
    }

    return NULL;
}

//
// ZD_FindPlayerById 
//

APlayerPawn *ZD_FindPlayerById(int id)
{
	int		i;

	// Try players now
	for (i=0; i<MAXPLAYERS; i++)
	{
		if (!playeringame[i])
			continue;

		if (players[i].netid == id)
			return players[i].mo;

	}

	return NULL;
}

//
// ZD_FindSectorById
//

sector_t	*ZD_FindSectorById(int id)
{
	int		i;
	sector_t*	sec;
	for (i=0; i<numsectors; i++)
	{
		sec = &sectors[i];

		if (sec->netid == id)
			return &sectors[i];
	}

	return NULL;
}



//
// ZD_ClearID - Ripped from the old src
//
void ZD_ClearID(int id)
{
    AActor *mo;
	
    TThinkerIterator<AActor> iterator;
    while ( (mo = iterator.Next() ) )
    {
		if (mo->netid == id)
    	    mo->netid = 0;
    }

}


//
// ZD_SpawnThing
//

static void ZD_SpawnThing(void)
{
	fixed_t	x,y,z;
	int		id;
	const TypeInfo	*type;
	char	*name;
	AActor	*mo;

	x = ZD_ReadLong();
	y = ZD_ReadLong();
	z = ZD_ReadLong();
	name = ZD_ReadString();
	id = ZD_ReadShort();

	// Dont even ATTEMPT to spawn if we're not in some kinda level
	if (gamestate != GS_LEVEL)
		return;

	// This should avoid alot of confusion, if there is already a 
	// AActor occupying the netid space, then destroy that actor
	// cause its gotta be a ghost!
	mo = ZD_FindThingById(id);
	if (mo)
		mo->Destroy();

	type = TypeInfo::IFindType(name);

	if (type == NULL)
	{
		Printf("%s is not an actor!\n", name);
		return;
	}

	mo = Spawn(type, x,y,z);
	DPrintf("DEBUG: Spawned %s\n", name);
	if (mo)
	{
		mo->netid = id;
		mo->SpawnPoint[0] = x >> FRACBITS;
		mo->SpawnPoint[1] = y >> FRACBITS;
	}

	#if __CTF__		//CTF_FIX
	if (ctf)
	{
		if (!strcmp(name,"RedCard"))
			ctf_flag_mo[0] = mo;
		else if (!strcmp(name,"BlueCard"))
			ctf_flag_mo[1] = mo;
	}
	#endif
}


//
// ZD_ThingAngle
// 

void ZD_ThingAngle(void)
{
	AActor	*mo;
	int		id = ZD_ReadShort();
	fixed_t	angle = ZD_ReadLong();

	mo = ZD_FindThingById(id);

	if (!mo)		// Does not exist, problem...
		return;

	mo->angle = angle;
}


//
// ZD_ThingCorpse
// 

void ZD_ThingCorpse(void)
{
	AActor	*mo;
	int		id = ZD_ReadShort();
	FState *deadstate;

	mo = ZD_FindThingById(id);

	if (!mo)		// Should not happen...hmm
	{   //Printf("ZD_ThingCorpse: Unknown thing %d\n", id);
		return;
	}
	
	
	A_NoBlocking (mo);	// [RH] Use this instead of A_PainDie
	deadstate = mo->DeathState;
	if (deadstate != NULL)
	{
		while (deadstate->GetNextState() != NULL)
		{
			deadstate = deadstate->GetNextState();
			mo->SetStateNF (deadstate);
		}
	}
}

//
// ZD_SetMobjState
//

void ZD_SetMobjState(void)
{
	AActor	*mo;
	int		id = ZD_ReadShort();
	angle_t	angle = ZD_ReadLong();
	int		state = ZD_ReadByte();
	FState	*st;

	
	mo = ZD_FindThingById(id);

	if (gamestate != GS_LEVEL)
		return;
	
	if (!mo)	// shouldent happen...
	{	//Printf("ZD_SetMobjState: Cannot find actor %d\n", id);
		return;
	}

	if (state == STATE_SEE)
	{
		// Seestates require a sound to be played about here
		if (mo->SeeSound)
		{	
			if (mo->flags2 & MF2_BOSS)
			{ // full volume
				S_SoundID (mo, CHAN_VOICE, mo->SeeSound, 1, ATTN_SURROUND);
			}
			else
			{
				S_SoundID (mo, CHAN_VOICE, mo->SeeSound, 1, ATTN_NORM);
			}
		}
		
		st = mo->SeeState;
	}
	else if (state == STATE_SPAWN)
		st = mo->SpawnState;
	else if (state == STATE_PAIN)
		st = mo->PainState;
	else if (state == STATE_MELEE)
		st = mo->MeleeState;
	else if (state == STATE_MISSILE)
		st = mo->MissileState;
	else if (state == STATE_DEATH)
		st = mo->DeathState;
	else
	{ 
		Printf("ZD_SetMobjState: Unknown static state %d\n", state); 
		//return; 
	}

	mo->angle = angle;

	mo->SetStateNF(st);
}


//
// ZD_SetMobjState
//

void ZD_SetPlayerState(void)
{
	player_t	*pl;
	int			id = ZD_ReadByte();
	int			state = ZD_ReadByte();

	// [Danni] Bug Fix
	if (!playeringame[id])
		return;

	pl = &players[id];

	if (!pl->mo)	// shouldent happen...
	{	//Printf("ZD_SetPlayerState: Cannot find actor %d\n", id);
		return;
	}

	if (pl->mo->health <= 0 || pl->playerstate == PST_DEAD)
		return;

	//Printf("NEW PLAYER state is %d\n", id, state);

	if (state == STATE_PLAYER_IDLE)
		pl->mo->PlayIdle();
	if (state == STATE_PLAYER_SEE)
		pl->mo->PlayRunning();
	if (state == STATE_PLAYER_ATTACK)
		pl->mo->PlayAttacking();
	if (state == STATE_PLAYER_ATTACK2)
		pl->mo->PlayAttacking2();

}

//
// ZD_SetSpecificState
//

static void ZD_SetSpecificState(void)
{
	AActor	*mo;
	int		id = ZD_ReadShort();
	int		state = ZD_ReadByte();

	mo = ZD_FindThingById(id);

	if (!mo)	// shouldent happen...
	{	// dont make an issues out of this
		//Printf("ZD_SetMobjState: Cannot find actor %d\n", id);
		return;
	}

	//mo->frame = state;
}

//
// ZD_UpdatePlayer
//
static void ZD_UpdatePlayer(void)
{			
	int				pnum, state;
	int				new_x, new_y, new_z;
	long			new_momx, new_momy, new_momz;
	unsigned long	new_angle;
	byte			bits;
	player_t		*p;

	pnum = ZD_ReadByte();
	bits = ZD_ReadByte();
	if (bits & CM_X)		new_x		= ZD_ReadShort() << FRACBITS;
	if (bits & CM_Y)		new_y		= ZD_ReadShort() << FRACBITS;
	if (bits & CM_Z)		new_z		= ZD_ReadShort() << FRACBITS;
	if (bits & CM_ANGLE)	new_angle	= ZD_ReadLong();
	if (bits & CM_MOMX)		new_momx	= ZD_ReadShort() << FRACBITS;
	if (bits & CM_MOMY)		new_momy	= ZD_ReadShort() << FRACBITS;
	if (bits & CM_MOMZ)		new_momz	= ZD_ReadShort() << FRACBITS;
	state = ZD_ReadByte();

	p = &players[pnum];

	if (!playeringame[pnum] || !p->mo || gamestate != GS_LEVEL)
	{
		if (!p->mo)
		{
			//Printf("Missing player object! %d\n", pnum);
		}
		// Missed packet, we dont have this player! Request for their info
		if (!playeringame[pnum] && gamestate == GS_LEVEL)
		{
			ZD_WriteByte(&localbuf, cl_missingplayer);
			ZD_WriteByte(&localbuf, pnum);
		}
		return;
	}

	if ( (bits & CM_X) || (bits & CM_Y) || (bits & CM_Z) )
	{
		if (bits & CM_X)	p->mo->x = new_x;
		if (bits & CM_Y)	p->mo->y = new_y;
		if (bits & CM_Z)	p->mo->z = new_z;
		p->mo->PlayRunning();
	}
	
	if (bits & CM_ANGLE)	p->mo->angle = new_angle;
	if (bits & CM_MOMX)		p->mo->momx = new_momx;
	if (bits & CM_MOMY)		p->mo->momy = new_momy;
	if (bits & CM_MOMZ)		p->mo->momz = new_momz;

	// Set our last tics
	p->zd_lasttic = (net_demoplayback) ? zd_demolasttic : gametic;

	#if __CTF__
	if (ctf)
	{
		int n = maxteams;
		for (int i=0; i<n; i++)
		{
			if (pnum==ctf_carrier_id[i])
				CTF_Update_Flag_Pos(i);
		}
	}
	#endif
}


//
// ZD_SpawnPlayer
//

extern fixed_t cl_viewheight[MAXSAVETICS];
extern fixed_t cl_deltaviewheight[MAXSAVETICS];

static void ZD_SpawnPlayer(int version)
{
	int		  playernum;
	player_t *p;
	APlayerPawn *mobj;
	//AActor	 *tfog;
	fixed_t   x, y, z;
	int       id;
	angle_t   angle;
	int       i;
	byte	  spectator;
	byte 	  state;
	int		  doreborn;
	// Lyfe - Dec 16.. needed to store the values till after player init.
	int       kills, items, deathcount;

	doreborn = ZD_ReadByte();
	playernum = ZD_ReadByte();
	state = ZD_ReadByte();
	spectator = ZD_ReadByte();
	id = ZD_ReadShort();
	angle = ZD_ReadLong();
	x = ZD_ReadLong();
	y = ZD_ReadLong();
	z = ZD_ReadLong();
	// Lyfe - Dec 16
	// added grabbing of user kill/item/death count for coop usage.
	if (version<107)
	{
		kills = items = deathcount = 0;
	}
	else
	{
		kills = ZD_ReadShort();
		items = ZD_ReadShort();
		deathcount = ZD_ReadShort();
		DPrintf("DEBUG: Read user score info: %d, %d, %d\n", kills, items, deathcount);
	}

	// Level isnt loaded yet...
	if (playernum<0 || playernum >= MAXPLAYERS || gamestate != GS_LEVEL)
		return;

	playeringame[playernum] = true;
	p = &players[playernum];

	// Thats my final answer!
	p->DesiredFOV = 90.f;

	// first disassociate the corpse
	if (p->mo)
	{
		if (p->mo->health || p->playerstate != PST_DEAD)
		{
			FState	*deadstate;

			A_NoBlocking (p->mo);
			deadstate = p->mo->DeathState;
			if (deadstate != NULL)
			{
				while (deadstate->GetNextState() != NULL)
				{
					deadstate = deadstate->GetNextState();
					p->mo->SetStateNF (deadstate);
				}
			}
		}

		if (doreborn > 0)
		{
			G_QueueBody (p->mo);
			p->mo->player = NULL;
			p->mo->id = -1;
		}
		else
		{
			p->mo->Destroy();
			p->mo->player = NULL;
		}
		
	}

	p->spectator = (spectator > 0);
	p->isbot = false;

	p->cls = TypeInfo::FindType(	(gameinfo.gametype == GAME_Doom) ?		"DoomPlayer"	:
									(gameinfo.gametype == GAME_Heretic) ?	"HereticPlayer"	:
																			"FighterPlayer"	);

// [NightFang] - modified x and y coords
	mobj = static_cast<APlayerPawn *>
			(Spawn (p->cls, x, y, ONFLOORZ));

	p->mo = mobj;
	mobj->player = p;
	p->playerstate = state;
	
	// Set netid
	p->netid = id;
	p->mo->netid = id;

	if (/*state == PST_REBORN || state == PST_ENTER || */doreborn > 0)
	{
		G_PlayerReborn (playernum);
		//p->needreborn = false;
	}

	// [RH] set color translations for player sprites
	mobj->Translation = TRANSLATION(TRANSLATION_Players,playernum);
	// [NightFang] - can be a different angle sometimes
	mobj->angle = angle;
	mobj->pitch = mobj->roll = 0;
	mobj->health = p->health;

	//Added by MC: Identification (number in the players[MAXPLAYERS] array)
    mobj->id = playernum;

	// [RH] Set player sprite based on skin
	p->skin = &skins[p->userinfo.actual_skin];
	mobj->sprite = p->skin->sprite;

	p->DesiredFOV = p->FOV = 90.f;

	// [NightFang] - from p->mo
	p->camera = mobj;
	p->playerstate = PST_LIVE;
	p->refire = 0;
	p->damagecount = 0;
	p->bonuscount = 0;
	p->morphTics = 0;
	p->rain1 = NULL;
	p->rain2 = NULL;
	p->extralight = 0;
	p->fixedcolormap = 0;
	p->viewheight = VIEWHEIGHT;
	// Lyfe - Dec 16
	// added in grabbing coop scoreboard information for this player.
	p->killcount = kills;
	p->itemcount = items;
	p->secretcount = 0;
	if (version>=107)
		p->deathcount = deathcount;

	for (i=0; i<MAXSAVETICS; i++)
	{
		cl_viewheight[i] = VIEWHEIGHT;
		cl_deltaviewheight[i] = 0;
	}

	p->inconsistant = 0;
	p->attacker = NULL;
	p->BlendR = p->BlendG = p->BlendB = p->BlendA = 0.f;

	// [NightFang] - Kill any cheats
	if (playernum != consoleplayer)								p->cheats = 0;
	else if (consoleplayer==displayplayer && !net_demoplayback)	p->cheats = 0;
	else if (chaseview)											p->cheats = CF_CHASECAM;
	else														p->cheats = 0;

	p->momx = p->momy = 0;		// killough 10/98: initialize bobbing to 0.
	
	p->viewz = p->mo->z + VIEWHEIGHT;
	p->viewheight = VIEWHEIGHT;

	// setup gun psprite
	P_SetupPsprites (p);

	// give all cards in death match mode
	if (deathmatch)
	{
		for (i = 0; i < NUMKEYS; i++)
			p->keys[i] = true;
	}
	
	if (displayplayer == playernum)
		StatusBar->AttachToPlayer (p);

	// [NightFang] - Special settings for spectators
	if (p->spectator)
	{
		p->playerstate = PST_WATCHING;
		p->mo->flags2 |= (MF2_LOGRAV|MF2_CANNOTPUSH);
		p->mo->flags &= ~(MF_SOLID|MF_SHOOTABLE|MF_PICKUP);
		p->mo->flags2 &= ~(MF2_PASSMOBJ);
		p->mo->RenderStyle = STYLE_None;
		
		// Make me flat!
		p->mo->height = 0;
		p->viewheight = VIEWHEIGHT+(5*FRACUNIT);
		p->cheats |= CF_NOTARGET;
		S_Sound(CHAN_VOICE, (playernum==consoleplayer) ? "misc/teleport":"misc/admin",
			1,ATTN_NONE);
	}
	else
	{
		P_TeleportMove (mobj, mobj->x, mobj->y, mobj->z, true);
	}

	p->viewheight = VIEWHEIGHT;

	// [NightFang] - Yet more spectator stuff
	p->playerstate = (p->spectator) ? PST_WATCHING : PST_LIVE;
	
	//p->needreborn = false;

	p->FOV = 90.f;

	// [NightFang] - When we spawn, get out of any camera mode
	// Kilgore: fix various issues with the camera
	if (playernum == consoleplayer)
	{
		if (!net_demoplayback)	G_ChangeSpy(consoleplayer);
		else					G_ChangeSpy(displayplayer);
	}
	else if (playernum==displayplayer)
	{
		G_ChangeSpy(playernum);
	}

	update_rank_spread_info();
}


CCMD(con)
{
	Printf("console player is %d\n", consoleplayer);
}


CCMD(players)
{
	int i;

	for (i=0; i<MAXPLAYERS; i++)
	{
		if (!playeringame[i])		continue;
		Printf("%d - %s", i, players[i].userinfo.netname);
		if (i==consoleplayer)		Printf(" (YOU)");
		if (players[i].spectator)	Printf(" (SPECTATOR)");
		if (players[i].isbot)		Printf(" (BOT)");
		Printf("\n");
	}
}

//
// ZD_ReReSpawn - Didnt get it the first time, try again
//
static void ZD_ReReSpawn(int playernum, int state, int spectator, int doreborn)
{
	APlayerPawn *mobj;
	player_t *p;
	fixed_t   x, y, z;
	int       id;
	angle_t   angle;
	int       i;

	id = playernum;
	angle = players[playernum].mo->angle;
	x = players[playernum].mo->x;
	y = players[playernum].mo->y;
	z = players[playernum].mo->z;

	if (playernum >= MAXPLAYERS || gamestate != GS_LEVEL)
		return;

	playeringame[playernum] = true;
	p = &players[playernum];

	// Thats my final answer!
	p->DesiredFOV = 90.f;

	p->spectator = (spectator > 0);

	p->cls = TypeInfo::FindType(	(gameinfo.gametype == GAME_Doom) ?		"DoomPlayer"	:
									(gameinfo.gametype == GAME_Heretic) ?	"HereticPlayer"	:
																			"FighterPlayer"	);

	if (p->mo)
		p->mo->Destroy();

	// [NightFang] - we dont destroy the mobj, just move it
	mobj = static_cast<APlayerPawn *>
			(Spawn (p->cls, x, y, ONFLOORZ));

	p->mo = mobj;
	mobj->player = p;
	p->playerstate = state;
	
	// Set netid
	p->netid = id;
	p->mo->netid = id;

	if (doreborn)
	{
		G_PlayerReborn (playernum);
		//p->needreborn = false;
	}

	// [RH] set color translations for player sprites
	p->mo->Translation = TRANSLATION(TRANSLATION_Players,playernum);
	// [NightFang] - can be a different angle sometimes
	p->mo->angle = angle;
	p->mo->pitch = p->mo->roll = 0;
	p->mo->health = p->health;

	//Added by MC: Identification (number in the players[MAXPLAYERS] array)
    p->mo->id = playernum;

	// [RH] Set player sprite based on skin
	p->skin = &skins[p->userinfo.actual_skin];
	p->mo->sprite = p->skin->sprite;

	p->DesiredFOV = p->FOV = 90.f;
	// [NightFang] - from p->mo
	p->camera = p->mo;
	p->playerstate = PST_LIVE;
	p->refire = 0;
	p->damagecount = 0;
	p->bonuscount = 0;
	p->morphTics = 0;
	p->rain1 = NULL;
	p->rain2 = NULL;
	p->extralight = 0;
	p->fixedcolormap = 0;
	p->viewheight = VIEWHEIGHT;
	p->inconsistant = 0;
	p->attacker = NULL;
	p->BlendR = p->BlendG = p->BlendB = p->BlendA = 0.f;

	// [NightFang] - Kill any cheats
	if (playernum != consoleplayer)								p->cheats = 0;
	else if (consoleplayer==displayplayer && !net_demoplayback)	p->cheats = 0;
	else if (chaseview)											p->cheats = CF_CHASECAM;
	else														p->cheats = 0;

	p->momx = p->momy = 0;		// killough 10/98: initialize bobbing to 0.
	
	// setup gun psprite
	P_SetupPsprites (p);

	// give all cards in death match mode
	if (deathmatch)
	{
		for (i = 0; i < NUMKEYS; i++)
			p->keys[i] = true;
	}

	if (displayplayer == playernum)
	{
		StatusBar->AttachToPlayer (p);
	}

	// [NightFang] - dont kill if we're in spectator
	if (!p->spectator)
		P_TeleportMove (p->mo, p->mo->x, p->mo->y, p->mo->z, true);

	p->spectator = false;
	
	p->viewheight = VIEWHEIGHT;

	p->FOV = 90.f;

	// [NightFang] - When we spawn, get out of any camera mode
	// Kilgore: fix various issues with the camera
	if (playernum == consoleplayer)
	{
		if (!net_demoplayback)	G_ChangeSpy(consoleplayer);
		else					G_ChangeSpy(displayplayer);
	}
	else if (playernum==displayplayer)
	{
		G_ChangeSpy(playernum);
	}

	update_rank_spread_info();
}


//
// ZD_SpawnBot
//

static void ZD_SpawnBot()
{
	int			playernum;
	player_t	*p;
	APlayerPawn	*mobj;
	fixed_t		x, y, z;
	int			id;
	angle_t		angle;
	int			i;
	byte		state = PST_REBORN;
	int			doreborn;

	doreborn = ZD_ReadByte();
	playernum = ZD_ReadByte();
	id = ZD_ReadShort();
	angle = ZD_ReadLong();
	x = ZD_ReadLong();
	y = ZD_ReadLong();
	z = ZD_ReadLong();

	if (playernum >= MAXPLAYERS || gamestate != GS_LEVEL)
		return;

	playeringame[playernum] = true;
	p = &players[playernum];

	// Thats my final answer!
	p->DesiredFOV = 90.f;

	p->needreborn = (doreborn > 0);
	p->spectator = false;
	p->isbot = true;

	p->cls = TypeInfo::FindType(	(gameinfo.gametype == GAME_Doom) ?		"DoomPlayer"	:
									(gameinfo.gametype == GAME_Heretic) ?	"HereticPlayer"	:
																			"FighterPlayer"	);
	if (p->mo)
	{
		if (p->mo->health || p->playerstate != PST_DEAD)
		{ 
			//p->mo->SetState(p->mo->DeathState); 
			FState	*deadstate;

			A_NoBlocking (p->mo);
			deadstate = p->mo->DeathState;
			if (deadstate != NULL)
			{
				while (deadstate->GetNextState() != NULL)
				{
					deadstate = deadstate->GetNextState();
					p->mo->SetStateNF (deadstate);
				}
			}
		}
	}

	// first disassociate the corpse
	if (p->mo != NULL && p->needreborn)
	{

		if (!p->spectator)
		{
			G_QueueBody (p->mo);
			p->mo->player = NULL;
			p->mo->id = -1;
		}
		else
		{
			p->mo->Destroy();
			p->mo->player = NULL;
		}
		
	}

// [NightFang] - modified x and y coords
	mobj = static_cast<APlayerPawn *>
			(Spawn (p->cls, x, y, ONFLOORZ));

	p->mo = mobj;
	mobj->player = p;
	p->playerstate = state;
	
	// Set netid
	p->netid = id;
	p->mo->netid = id;

	if (state == PST_REBORN || state == PST_ENTER || p->needreborn)
	{
		G_PlayerReborn (playernum);
		p->needreborn = false;
	}

	// [RH] set color translations for player sprites
	mobj->Translation = TRANSLATION(TRANSLATION_Players,playernum);
	// [NightFang] - can be a different angle sometimes
	mobj->angle = angle;
	mobj->pitch = mobj->roll = 0;
	mobj->health = p->health;

	//Added by MC: Identification (number in the players[MAXPLAYERS] array)
    mobj->id = playernum;

	// [RH] Set player sprite based on skin
	p->skin = &skins[p->userinfo.actual_skin];
	mobj->sprite = p->skin->sprite;

	p->DesiredFOV = p->FOV = 90.f;
	// [NightFang] - from p->mo
	p->camera = mobj;
	p->playerstate = PST_LIVE;
	p->refire = 0;
	p->damagecount = 0;
	p->bonuscount = 0;
	p->morphTics = 0;
	p->rain1 = NULL;
	p->rain2 = NULL;
	p->extralight = 0;
	p->fixedcolormap = 0;
	p->viewheight = VIEWHEIGHT;
	p->inconsistant = 0;
	p->attacker = NULL;
	p->BlendR = p->BlendG = p->BlendB = p->BlendA = 0.f;
	// [NightFang] - Kill any cheats
	p->cheats = 0;

	p->momx = p->momy = 0;		// killough 10/98: initialize bobbing to 0.
	
	P_SetupPsprites (p);

	// give all cards in death match mode
	if (deathmatch)
	{
		for (i = 0; i < NUMKEYS; i++)
			p->keys[i] = true;
	}

	if (displayplayer == playernum)
	{
		StatusBar->AttachToPlayer (p);
	}

	p->viewheight = VIEWHEIGHT;
	
	// [NightFang] - dont kill if we're in spectator
	P_TeleportMove (mobj, mobj->x, mobj->y, mobj->z, true);

	// [NightFang] - Yet more spectator stuff
	p->playerstate = PST_LIVE;
	
	p->needreborn = false;

	p->FOV = 90.f;

	// [NightFang] - When we spawn, get out of any camera mode
	// Kilgore: fix various issues with the camera
	if (playernum == consoleplayer)
	{
		if (!net_demoplayback)	G_ChangeSpy(consoleplayer);
		else					G_ChangeSpy(displayplayer);
	}
	else if (playernum==displayplayer)
	{
		G_ChangeSpy(playernum);
	}
	
	update_rank_spread_info();
}



//
// ZD_SaveCmd
//

//ticcmd_t localcmds[MAXSAVETICS]; 

void ZD_SaveCmd(void)
{
	int		buf;

	buf = gametic%MAXSAVETICS;

	if (net_demoplayback)
		buf = zd_demolasttic%MAXSAVETICS;

	if (!players[consoleplayer].mo)
		return;

	memcpy (&zd_localcmds[buf], &players[consoleplayer].cmd, sizeof(ticcmd_t));
}
	

//
// ZD_UpdateConsolePlayer 
//

static void ZD_UpdateConsolePlayer(void)
{
	player_t*	p;
	int			oldstate, state;
	int			tic;
	fixed_t		x,y,z,momx,momy,momz;

	p = &players[consoleplayer];
	
	tic = ZD_ReadLong();
	state = ZD_ReadByte();

	//difftics = gametic - p->zd_tic;
	difftics=0;
	//difftics = p->zd_tic;

	// Get (XYZ)
	x =		ZD_ReadLong();
	y =		ZD_ReadLong();
	z =		ZD_ReadLong();
	momx =	ZD_ReadLong();
	momy =	ZD_ReadLong();
	momz =	ZD_ReadLong();

	oldstate = p->playerstate;

	if (!p->mo) 
		return;

	if (tic < p->zd_tic)
		return;

	zd_lasttic = tic;

//Printf("svr: z = %d\n",z);		//HSDEBUGA

	p->realorgin[0] = x;
	p->realorgin[1] = y;
	p->realorgin[2] = z;
	p->realvelocity[0] = momx;
	p->realvelocity[1] = momy;
	p->realvelocity[2] = momz;

	// Something must have changed, see if the client
	// can figure it out
	if (oldstate != state)
	{
		// Player has died
		if (state == PST_DEAD)
		{
			p->mo->Die(NULL, NULL);
		}
		else if (oldstate == PST_WATCHING)
		{
			p->spectator = false;
			p->playerstate = state;
			ZD_ReReSpawn(consoleplayer, state, -10, 10);
		}
		else if (oldstate == PST_DEAD)		// do a reborn
		{
			ZD_ReReSpawn(consoleplayer, state, -10, 10);
		}
		
		//Printf("State change! %d to %d\n", oldstate, state); 
	}
	p->playerstate = state;

}


//
// ZD_UpdateThing
//
void ZD_UpdateThing(void)
{			
	int       id = ZD_ReadShort();		// player #
	//int		  state;
	fixed_t   x, y, z;
	byte      bits;
	AActor		*mo;

	mo = ZD_FindThingById(id);
	bits = ZD_ReadByte();

	if (!mo || gamestate != GS_LEVEL)
	{
		// only complain if the level is here
		//if (gamestate == GS_LEVEL)
		//	Printf("Problem updating thing! %d\n", id);
		
		// skip the message
		if (bits & CM_X) ZD_ReadShort();
		if (bits & CM_Y) ZD_ReadShort();
		if (bits & CM_Z) ZD_ReadShort();
		if (bits & CM_ANGLE) ZD_ReadLong();
		if (bits & CM_MOMX) ZD_ReadShort();
		if (bits & CM_MOMY) ZD_ReadShort();
		if (bits & CM_MOMZ) ZD_ReadShort();

		// Okay, in a effort to keep client/server in sync with each other
		// the client sends a request to the server asking to spawn the missing
		// mobj for us.
		// Only request data if our level has been loaded sucessfully
		if (gamestate == GS_LEVEL)
		{
			ZD_WriteByte(&localbuf, cl_querything);
			ZD_WriteShort(&localbuf, id);
		}

		return;
	}

	//Printf("%d updates %d\n", id, bits);

	x = mo->x;
	y = mo->y;
	z = mo->z;
	
	if (bits & CM_X)
		x = ZD_ReadShort() << FRACBITS;
	if (bits & CM_Y)
		y = ZD_ReadShort() << FRACBITS;
	if (bits & CM_Z)
		z = ZD_ReadShort() << FRACBITS;

	ZD_MoveThing(mo, x, y, z);
	//mo->z = z;
	
	if (bits & CM_ANGLE)
		mo->angle = ZD_ReadLong();

	if (bits & CM_MOMX)
		mo->momx = ZD_ReadShort() << FRACBITS;
	if (bits & CM_MOMY)
		mo->momy = ZD_ReadShort() << FRACBITS;
	if (bits & CM_MOMZ)
		mo->momz = ZD_ReadShort() << FRACBITS;
}

//
// CL_SpawnMissile
// 

static void CL_SpawnMissile(int version)
{
	AActor				*mo;
	const	TypeInfo	*type;
	char				*name;
	int					netid;
	fixed_t				x, y, z, momx, momy, momz, angle;

	name  = ZD_ReadString();
	netid = ZD_ReadShort();
	x = ZD_ReadShort() << FRACBITS;
	y = ZD_ReadShort() << FRACBITS;
	z = ZD_ReadShort() << FRACBITS;
	if (version<107)
	{
		momx = ZD_ReadShort() << FRACBITS;
		momy = ZD_ReadShort() << FRACBITS;
	}
	else
	{
		// this change should go in.  It resolves an inaccuracy in the direction
		// rockets (from cybies and such) fly in, which would cause the client
		// to make them explode even though the server thinks they're still alive.
		// (thus, invisible rockets without this.)
		momx = ZD_ReadLong();
		momy = ZD_ReadLong();
	}
	momz = ZD_ReadLong();
	angle = ZD_ReadLong();

	if (gamestate != GS_LEVEL)
		return;

	type = TypeInfo::IFindType(name);

	mo = Spawn(type, x, y, z);

	if (!mo || type == NULL)
	{
		//Printf("CL_SpawnMissile: Failed to spawn missile: %s\n", name);
		return;
	}

	if (mo->SeeSound)
		S_SoundID (mo, CHAN_VOICE, mo->SeeSound, 1, ATTN_NORM);

	ZD_MoveThing(mo, x,y,z);

	mo->netid = netid;
	mo->momx = momx;
	mo->momy = momy;
	mo->momz = momz;
	mo->angle = angle;

	// Move a bit forward
	mo->x += mo->momx>>1;
	mo->y += mo->momy>>1;
	mo->z += mo->momz>>1;
}

//
// CL_ExplodeMissile
//

EXTERN_CVAR (Bool, addrocketexplosion)

static void	CL_ExplodeMissile(void)
{
	AActor		*mo;
	int			id;
	fixed_t		x,y,z;

	id = ZD_ReadShort();
	x = ZD_ReadShort() << FRACBITS;
	y = ZD_ReadShort() << FRACBITS;
	z = ZD_ReadShort() << FRACBITS;

	mo = ZD_FindThingById(id);

	//Printf("DEBUG: Killed missle (%d)\n", id);

	if (!mo)
	{
		//Printf("CL_ExplodeMissile: Could not find %d\n", id);
		return;
	}

	ZD_MoveThing(mo, x, y, z);

	P_ExplodeMissile(mo, NULL);
}

//
// CL_PlayerFireWeapon
// 

static void CL_PlayerFireWeapon(void)
{
	int				currammo = ZD_ReadShort();
	//int				weapon = ZD_ReadByte();
	player_t		*player = &players[consoleplayer];
	//weapontype_t	wep = (weapontype_t) weapon;
	FWeaponInfo		*info;

	//if (wep != player->readyweapon && wep != wp_nochange)
	//	player->readyweapon = wep;

	if (gamestate != GS_LEVEL || !player->mo || player->mo->health <= 0)
		return;

	if (deathmatch || !player->powers[pw_weaponlevel2])
	{ info = wpnlev1info[player->readyweapon]; }
	else
	{ info = wpnlev2info[player->readyweapon]; }

	// [Danni] Bug Fix
	if (!info) 
		return;
	player->ammo[info->ammo] = currammo;

	/*if (!net_demoplayback)
		A_ReFire(player,&player->psprites[ps_weapon]);*/


}

//
// ZD_PlayerFireWeaponState - Just sets the state off
//

void ZD_PlayerFireWeaponState(int pl)
{
	//player_t		*player = &players[pl];
	//FWeaponInfo		*info;

	/*if (pl == consoleplayer)
		return;

	if (gamestate != GS_LEVEL || !player->mo || player->mo->health <= 0)
		return;

	if (deathmatch || !player->powers[pw_weaponlevel2])
	{ info = wpnlev1info[player->readyweapon]; }
	else
	{ info = wpnlev2info[player->readyweapon]; }

	A_ReFire(player,&player->psprites[ps_weapon]);*/
}


//
// CL_TouchSpecialThing
//

static void CL_TouchSpecialThing(void)
{
	AActor		*special, *toucher;
	int			sid, tid;

	sid = ZD_ReadShort();
	tid = ZD_ReadShort();

	// Level not loaded, ingore then
	if (gamestate != GS_LEVEL)
		return;

	if (!playeringame[tid])
		return;

	special = ZD_FindThingById(sid);
	toucher = players[tid].mo;

	if (!special || !toucher)
	{
		if (!special)
		{
			//Printf("CL_TouchSpecialThing: Unknown special %d\n", sid);
			// Okay, in a effort to keep client/server in sync with each other
			// the client sends a request to the server asking to spawn the missing
			// mobj for us.
			ZD_WriteByte(&localbuf, cl_querything);
			ZD_WriteShort(&localbuf, sid);

		}
		//if (!toucher)
		//	Printf("CL_TouchSpecialThing: Unknown special %d\n", tid);
		return;
	}

	
	if (special->IsKindOf (RUNTIME_CLASS (AInventory)) || special->IsKindOf (RUNTIME_CLASS (AArtifact)))
	//if (special->flags & MF_PICKUP)
	{
		//static_cast<AInventory *>(special)->Touch (toucher);
		P_TouchSpecialThing(special, toucher);
	}
	else
	{
		//Printf ("CL_TouchSpecialThing: Unknown gettable thing (%s)  Requesting...\n", RUNTIME_TYPE (special)->Name);
		special->flags &= ~MF_SPECIAL;

		// Send request to update this item
		ZD_WriteByte(&localbuf, cl_querything);
		ZD_WriteShort(&localbuf, sid);
	}
}


//
// ZD_GetPing - you know, PING - PONG (or is that *ding* dong?)
// 

static void ZD_GetPing(void)
{
	int		svgametic = ZD_ReadLong();

	ZD_WriteByte(&localbuf, cl_pong);
	ZD_WriteLong(&localbuf, svgametic);
}


//
// ZD_RespawnItem - Respawns a item that was previously picked up
//

static void ZD_RespawnItem(void)
{
	AActor	*mo;
	int		id = ZD_ReadShort();

	// Level not loaded, ingore then
	if (gamestate != GS_LEVEL)
		return;

	mo = ZD_FindThingById(id);

	if (!mo)
	{ //Printf("ZD_RespawnItem: Unknown item %d\n", id);
	  return; 
	}

	A_RestoreSpecialPosition (mo);
	A_RestoreSpecialDoomThing(mo);
}


//
// ZD_DamageMobj
//

static void ZD_DamageMobj(void)
{
	AActor	*target, *inflictor, *source;
	int		id = ZD_ReadShort();
	int		damage;

	target = ZD_FindThingById(id);
	inflictor = ZD_FindThingById(ZD_ReadShort());
	source = ZD_FindThingById(ZD_ReadShort());
	damage = ZD_ReadShort();

	// Level not loaded, ingore then
	if (gamestate != GS_LEVEL)
		return;

	//if (!target)
	//{ Printf("ZD_DamageMobj: %d is nothing to damage\n", id); return; }

	P_DamageMobj(target, inflictor, source, damage, 0,0,true);
}

//
// ZD_DamagePlayer
//

static void ZD_DamagePlayer(void)
{
	int		pl = ZD_ReadByte();
	int		health = ZD_ReadShort();
	int		damage;
	int		temp;

	// Level not loaded, ingore then
	if (gamestate != GS_LEVEL)
		return;

	damage = players[pl].health - health;

	if (!players[pl].mo)
	{ /*Printf("ZD_DamagePlayer: %d is not an active player netid\n", pl);*/ return; }

	P_DamageMobj(players[pl].mo, NULL, NULL, damage, 0, 0,true);

	players[pl].mo->health = players[pl].health = health;

	players[pl].damagecount += damage;

	if (players[pl].damagecount > 100)
		players[pl].damagecount = 100;

	if (pl == consoleplayer)
	{
		temp = damage < 100 ? damage : 100;
        I_Tactile (40,10,40+temp*2);
	}
}


//
// ZD_KillMobj
//

static void ZD_KillMobj(void)
{
	AActor	*mo;
	int		id, health, flags2;

	id = ZD_ReadShort();
	health = ZD_ReadShort();
	flags2 = ZD_ReadLong();
	
	// Level not loaded, ingore then
	if (gamestate != GS_LEVEL)
		return;

	mo = ZD_FindThingById(id);
	// [Danni] Bug Fix
	if (!mo)
	{ Printf("ZD_KillMobj: Cannont find actor %d\n", id); return; }

	mo->health = health;
	mo->flags2 = flags2;

	mo->Die(NULL, NULL);
}

//
// ZD_KillPlayer
//

static void ZD_KillPlayer(void)
{
	int		id = ZD_ReadByte();
	int		health = ZD_ReadShort();

	// [Danni] Bug Fix
	if (!playeringame[id])
		return;
	// We're already dead, oh yeah, and make sure this is called when
	// we're in a level
	if (players[id].playerstate == PST_DEAD || gamestate != GS_LEVEL)
		return;

	if (!players[id].mo)
	{ /*Printf("ZD_KillPlayer: Player netid %d has no object\n", id);*/ return; }

	//players[id].mo->flags2 = flags2;
	players[id].health = players[id].mo->health = health;
	players[id].mo->Die(NULL, NULL);
	players[id].mo->netid = -1;
}

//
// ZD_PlayerNoWay
//

static void ZD_PlayerNoWay(void)
{
	int			pl = ZD_ReadByte();
	player_t	*player;

	// [Danni] Bug Fix
	if (!playeringame[pl]) 
		return;

	player = &players[pl];

	if (!player->mo || gamestate != GS_LEVEL)
		return;

	S_Sound (player->mo, CHAN_VOICE, "*usefail", 1, ATTN_IDLE);
}


//
// ZD_TriggerLine - This just gets the line from the server and changes the texture
// We dont actually process the lines function over the client in remote mode
//

static void ZD_TriggerLine(void)
{
	line_t*				line;
	bool				repeat;
	int					id		= ZD_ReadLong();
	int					dorepeat= ZD_ReadByte();
	// [Danni] Bug Fix
	if (gamestate != GS_LEVEL || id > numlines)
		return;

	if (dorepeat > 0)
		repeat = true;
	else
		repeat = false;

	line = &lines[id];
	
	//if (!line)
	//{ Printf("ZD_TriggerLine: Cannot find line %d\n", id); return; }

	// Change the line texture
	P_ChangeSwitchTexture (&sides[line->sidenum[0]], repeat, line->special);
}

//
// ZD_DoDoor
//

static void ZD_DoDoor(void)
{
	sector_t	*sec;
	int			secnum = ZD_ReadLong();
	int			direction = ZD_ReadLong();
	int			time = ZD_ReadLong();
	int			type = ZD_ReadByte();
	fixed_t		speed= ZD_ReadLong();
	
	if (gamestate != GS_LEVEL)
		return;
	
	// [Danni] Bug Fix
	sec = ZD_FindSectorById(secnum);
	if (!sec)
	{ return; }

	if (sec->ceilingdata && sec->ceilingdata->IsKindOf (RUNTIME_CLASS(DDoor)))
	{
		DDoor *door = static_cast<DDoor *>(sec->ceilingdata);

		door->m_Direction = direction;
		door->m_TopCountdown = time;
		door->m_Type = (DDoor::EVlDoor)type;
		door->m_Speed = speed;
	}
	else
	{
		new DDoor (sec, (DDoor::EVlDoor)type, speed, time);
	}
}


static void ZD_DoPlat(void)
{
	int			secnum = ZD_ReadLong();
	int			type   = ZD_ReadLong();
	fixed_t		speed  = ZD_ReadLong();
	int			status = ZD_ReadByte();
	int			wait   = ZD_ReadShort();
	fixed_t		high   = ZD_ReadLong();
	fixed_t		low    = ZD_ReadLong();
	sector_t*	sec;
	DPlat		*plat;

	if (gamestate != GS_LEVEL)
		return;

	
	sec = ZD_FindSectorById(secnum);
	if (!sec)
	{
		//Printf("ZD_DoPlat: Dont know sector %d\n", secnum); 
		return; 
	}
	
	if (sec->floordata && sec->floordata->IsKindOf (RUNTIME_CLASS(DPlat)))
	{
		plat = static_cast<DPlat *>(sec->floordata);

		plat->m_Sector = sec;
		plat->m_Type = (DPlat::EPlatType)type;
		plat->m_Speed = speed;
		plat->m_Status = (DPlat::EPlatState)status;
		plat->m_Wait = wait;
		plat->m_High = high;
		plat->m_Low = low;
	}
	else
	{
		plat = new DPlat (sec);

		plat->m_Sector = sec;
		plat->m_Type = (DPlat::EPlatType)type;
		plat->m_Speed = speed;
		plat->m_Status = (DPlat::EPlatState)status;
		plat->m_Wait = wait;
		plat->m_High = high;
		plat->m_Low = low;
	}

}

static void ZD_MovePlane (void)
{
	sector_t	*m_Sector;
	int			secnum = ZD_ReadShort();
	fixed_t		height = ZD_ReadShort() << FRACBITS;
	fixed_t		dest = ZD_ReadShort() << FRACBITS;
	int			crush = ZD_ReadByte();
	int			floorOrCeiling = ZD_ReadByte();
	int			direction = ZD_ReadByte();

	bool	 	flag;
	fixed_t 	lastpos, speed;

	if (gamestate != GS_LEVEL)
		return;

	// Extra parsing stuff to save bandwidth
	if (crush == 0)
		crush = -1;
	else
		crush = 1;

	if (direction == 0)
		direction = -1;
	else
		direction = 1;
	/////////////////////////////////////////

	m_Sector = ZD_FindSectorById(secnum);
	if (!m_Sector)
		return; 

	if (floorOrCeiling == 0)
		speed = abs(m_Sector->floorplane.d - height);
	else
		speed = abs(m_Sector->ceilingplane.d - height);

	switch (floorOrCeiling)
	{
	case 0:
		// FLOOR
		lastpos = m_Sector->floorplane.d;
		switch (direction)
		{
		case -1:
			{
				// DOWN
				m_Sector->floorplane.ChangeHeight (-speed);
				if (m_Sector->floorplane.d >= dest)
				{
					m_Sector->floorplane.d = dest;
					flag = P_ChangeSector (m_Sector, crush,
						m_Sector->floorplane.HeightDiff (lastpos), 0);
					if (flag)
					{
						m_Sector->floorplane.d = lastpos;
						P_ChangeSector (m_Sector, crush,
							m_Sector->floorplane.HeightDiff (dest), 0);
					}
					m_Sector->floortexz += m_Sector->floorplane.HeightDiff (lastpos);
					return;
				}
				else
				{
					flag = P_ChangeSector (m_Sector, crush, -speed, 0);
					if (flag)
					{
						m_Sector->floorplane.d = lastpos;
						P_ChangeSector (m_Sector, crush, speed, 0);
						return;
					}
					m_Sector->floortexz += m_Sector->floorplane.HeightDiff (lastpos);
			
				}
				break;
			}
												
		case 1:
			// UP
			// jff 02/04/98 keep floor from moving thru ceilings
			// [RH] not so easy with arbitrary planes
			//destheight = (dest < m_Sector->ceilingheight) ? dest : m_Sector->ceilingheight;
			
			if ((m_Sector->ceilingplane.a | m_Sector->ceilingplane.b |
				 m_Sector->floorplane.a | m_Sector->floorplane.b) == 0 &&
				-dest > m_Sector->ceilingplane.d)
			{
				dest = -m_Sector->ceilingplane.d;
			}
			m_Sector->floorplane.ChangeHeight (speed);
			if (m_Sector->floorplane.d < dest)
			{
				m_Sector->floorplane.d = dest;
				flag = P_ChangeSector (m_Sector, crush,
					m_Sector->floorplane.HeightDiff (lastpos), 0);
				if (flag)
				{
					m_Sector->floorplane.d = lastpos;
					P_ChangeSector (m_Sector, crush,
						m_Sector->floorplane.HeightDiff (dest), 0);
				}
				m_Sector->floortexz += m_Sector->floorplane.HeightDiff (lastpos);
				return;
			}
			else
			{
				// COULD GET CRUSHED
				flag = P_ChangeSector (m_Sector, crush, speed, 0);
				if (flag)
				{
					if (crush >= 0)
					{
						m_Sector->floortexz += m_Sector->floorplane.HeightDiff (lastpos);
						return;
					}
					m_Sector->floorplane.d = lastpos;
					P_ChangeSector (m_Sector, crush, -speed, 0);
					return;
				}
				m_Sector->floortexz += m_Sector->floorplane.HeightDiff (lastpos);
			}
			break;
		}
		break;
																		
	  case 1:
		// CEILING
		lastpos = m_Sector->ceilingplane.d;
		switch (direction)
		{
		case -1:
			// DOWN
			// jff 02/04/98 keep ceiling from moving thru floors
			// [RH] not so easy with arbitrary planes
			//destheight = (dest > m_Sector->floorheight) ? dest : m_Sector->floorheight;
			if ((m_Sector->ceilingplane.a | m_Sector->ceilingplane.b |
				 m_Sector->floorplane.a | m_Sector->floorplane.b) == 0 &&
				dest < -m_Sector->floorplane.d)
			{
				dest = -m_Sector->floorplane.d;
			}
			m_Sector->ceilingplane.ChangeHeight (-speed);
			if (m_Sector->ceilingplane.d < dest)
			{
				m_Sector->ceilingplane.d = dest;
				flag = P_ChangeSector (m_Sector, crush,
					m_Sector->ceilingplane.HeightDiff (lastpos), 1);

				if (flag)
				{
					m_Sector->ceilingplane.d = lastpos;
					P_ChangeSector (m_Sector, crush,
						m_Sector->ceilingplane.HeightDiff (dest), 1);
				}
				m_Sector->ceilingtexz += m_Sector->ceilingplane.HeightDiff (lastpos);
				return;
			}
			else
			{
				// COULD GET CRUSHED
				flag = P_ChangeSector (m_Sector, crush, -speed, 1);
				if (flag)
				{
					if (crush >= 0)
					{
						m_Sector->ceilingtexz += m_Sector->ceilingplane.HeightDiff (lastpos);
						return;
					}
					m_Sector->ceilingplane.d = lastpos;
					P_ChangeSector (m_Sector, crush, speed, 1);
					return;
				}
				m_Sector->ceilingtexz += m_Sector->ceilingplane.HeightDiff (lastpos);
			}
			break;
												
		case 1:
			// UP
			m_Sector->ceilingplane.ChangeHeight (speed);
			if (m_Sector->ceilingplane.d > dest)
			{
				m_Sector->ceilingplane.d = dest;
				flag = P_ChangeSector (m_Sector, crush,
					m_Sector->ceilingplane.HeightDiff (lastpos), 1);
				if (flag)
				{
					m_Sector->ceilingplane.d = lastpos;
					P_ChangeSector (m_Sector, crush,
						m_Sector->ceilingplane.HeightDiff (dest), 1);
				}
				m_Sector->ceilingtexz += m_Sector->ceilingplane.HeightDiff (lastpos);
				return;
			}
			else
			{
				flag = P_ChangeSector (m_Sector, crush, speed, 1);
// UNUSED
#if 0
				if (flag)
				{
					m_Sector->ceilingplane.d = lastpos;
					P_ChangeSector (m_Sector, crush, -speed, 1);
					return;
				}
#endif
				m_Sector->ceilingtexz += m_Sector->ceilingplane.HeightDiff (lastpos);
			}
			break;
		}
		break;
				
	}
	return;
}


//
// ZD_UpdateSector - For everything else
//

static void ZD_UpdateSector(void)
{
	sector_t		*sec;
	int				secnum = ZD_ReadShort();
	char			*floor = ZD_ReadString();
	//char			*ceiling = ZD_ReadString();
	int				fflatlump;//, cflatlump;

	if (gamestate != GS_LEVEL)
		return;

	sec = ZD_FindSectorById(secnum);

	if (!sec)
	{ 
		//Printf("ZD_UpdateSector: Cannot find %d\n", secnum); 
		return; 
	}

	fflatlump = R_FlatNumForName(floor);
	sec->floorpic = fflatlump;

	//cflatlump = R_FlatNumForName(ceiling);
	//sec->ceilingpic = cflatlump;
}

//
// ZD_StartSequenceID
//
static void ZD_StartSequenceID(void)
{
	int i;
	sector_t*	sec;
	int	secnum = ZD_ReadShort();
	int sound  = ZD_ReadByte();

	if (gamestate != GS_LEVEL)
		return;


		// Find the sector
	for (i=0; i<numsectors; i++)
	{
		sec = &sectors[i];

		if (sec->netid == secnum)
			goto doit;
	}
	//Printf("ZD_StartSequenceID: Dont know sector %d\n", secnum); 
	return; 

doit:

	i=0;
	//SN_StartSequence (sec, sec->seqType, stype);
}

//
// ZD_StartSequence
//
static void ZD_StartSequence(void)
{
	int i;
	sector_t*	sec;
	int	secnum = ZD_ReadShort();
	char *sound  = ZD_ReadString();
	//seqtype_t	stype = sound;
	

		// Find the sector
	for (i=0; i<numsectors; i++)
	{
		sec = &sectors[i];

		if (sec->netid == secnum)
			goto doit;
	}
	//Printf("ZD_StartSequence: Dont know sector %d\n", secnum); 
	return; 

doit:

	SN_StartSequence (sec, sound);
}

//
// ZD_StopSectorSequence
//

static void ZD_StopSectorSequence(void)
{
	int i;
	sector_t*	sec;
	int	secnum = ZD_ReadShort();

	// Find the sector
	for (i=0; i<numsectors; i++)
	{
		sec = &sectors[i];

		if (sec->netid == secnum)
			goto doit;
	}
	//Printf("ZD_StartSequence: Dont know sector %d\n", secnum); 
	return; 

doit:

	i=0;
	SN_StopSequence(sec);
}





//
// ZD_DestroyMobj
//

static void ZD_DestroyMobj(void)
{
	int				id = ZD_ReadShort();
	AActor			*mo = ZD_FindThingById(id);

	// Dont complain
	if (!mo)
	{ /*Printf("ZD_DestroyMobj: Unable to find thing %d\n", id);*/ return; }

	mo->Destroy();

}

//
// ZD_ExitLevel - Quits a level & starts intermission
//
void goOn (int position);
static void ZD_ExitLevel(void)
{
	int		pos = ZD_ReadByte();

	// Never loaded a level
	if (gamestate == GS_FULLCONSOLE)
		return;

	// Ingore if we get this twice (could happen)
	if (gamestate != GS_INTERMISSION)
	{ goOn(pos); }
}

//
// ZD_ConnectNewMap - Reconnects to the server when a map changes
//
static void ZD_ConnectNewMap(void)
{
	char	*map = ZD_ReadString();

	SZ_Clear(&localbuf);

	// Full console
	gameaction = ga_fullconsole;

	// First, game is no longer a local game
	Printf("Connecting to %s\n%s\n", NET_AdrToString(&remoteaddr), map);

	zd_localplay = false;

	// Attempt message
	ZD_AttemptConnection();

	// Finally set the timeout
	addr_timeout = 15*TICRATE;

	// Set our network state
	zd_netstate = ZD_TRYCONNECTION;
}


//
// ZD_UpdateFlat - Updates changing flats
//

static void ZD_UpdateFlat(void)
{
	int			FloorOrCeil = ZD_ReadByte();
	int			secnum = ZD_ReadShort();
	char*		texname = ZD_ReadString();
	sector_t*	sec;
	int			flatlump;

	sec = ZD_FindSectorById(secnum);
	if (!sec)
	{ 
		Printf("ZD_UpdateFlat: Cannot find sector %d\n", secnum); 
		//return; 
	}

	flatlump = R_FlatNumForName(texname);

	if (FloorOrCeil == 0)
		sec->floorpic = flatlump;
	else
		sec->ceilingpic = flatlump;
}

//
// ZD_DropItem
//

static void ZD_DropItem(void)
{
	int		id = ZD_ReadShort();
	fixed_t momx = ZD_ReadShort() << FRACBITS;
	fixed_t momy = ZD_ReadShort() << FRACBITS;
	fixed_t momz = ZD_ReadShort() << FRACBITS;
	AActor* mo;

	mo = ZD_FindThingById(id);

	if (!mo)
	{ 
		//Printf("ZD_DropItem: Cannot find parent item %d\n", id); 
		return; 
	}

	mo->momx = momx;
	mo->momy = momy;
	mo->momz = momz;
	mo->flags |= MF_DROPPED;
}

//
// ZD_TeleMove - Teleports a player to a new orgin. For those who dont want
// to wait for ZD_UpdateConsolePlayer (like me!)
//

//extern bool resetpitch;
static void ZD_TeleMove(void)
{
	int		pl = ZD_ReadByte();
	fixed_t	x = ZD_ReadShort() << FRACBITS;
	fixed_t	y = ZD_ReadShort() << FRACBITS;
	fixed_t	z = ZD_ReadShort() << FRACBITS;
	fixed_t	a = ZD_ReadLong();
	player_t*	player;

	if (!playeringame[pl] || !players[pl].mo)
	{ 
		//Printf("ZD_TeleMove: Player %d does not have mobj!\n", pl); 
		return; 
	}

	player = &players[pl];

	
	P_TeleportMove (player->mo, x, y, z, false);
	ZD_MoveThing(player->mo, x, y, z);
	//P_Teleport(player->mo, x,y,z, a,  false);

	player->mo->angle = a;

	player->FOV = MIN (175.f, player->DesiredFOV + 45.f);

	player->mo->reactiontime = 18;
	player->cmd.ucmd.forwardmove = player->cmd.ucmd.sidemove = 0;
	player->momx = player->momy = player->mo->momx = player->mo->momy = 0;
}

/************************************************************
 * Kilgore: Chat blocking
 ************************************************************/
#define MAX_CHATBLOCKS	128

class chat_block_pt
{
private:
	bool		block_all_flg;
	bool		block_spectators_flg;
	bool		block_bots_flg;
	int			nblocks_byid;
	int			blocked_ids[MAX_CHATBLOCKS];
	int			nblocks_byip;
	netadr_t	blocked_addresses[MAX_CHATBLOCKS];
	int			nblocks_byname;
	char		*blocked_names[MAX_CHATBLOCKS];

	void		init();
	bool		is_id_blocked(int id);
	bool		is_ip_blocked(netadr_t *ip);
	bool		is_name_blocked(char *name);

public:
				chat_block_pt();
				~chat_block_pt();
	bool		is_blocked(int pl);
	void		flush();

	void		block_byid(int id);
	void		block_byip(int pl);
	void		block_byname(char *name);
	void		block_all();
	void		block_spectators();
	void		block_bots();

	void		unblock_byid(int id);
	void		unblock_byip(int pl);
	void		unblock_byname(char *name);
	void		unblock_all();
	void		unblock_spectators();
	void		unblock_bots();

	void		toggle_byid(int id);
	void		toggle_byip(int pl);
	void		toggle_byname(char *name);
	void		toggle_all();
	void		toggle_spectators();
	void		toggle_bots();
};

void chat_block_pt::init()
{
	block_all_flg = block_spectators_flg = block_bots_flg = false;
	nblocks_byid = nblocks_byip = nblocks_byname = 0;
	memset(blocked_ids,0,sizeof(blocked_ids));
	memset(blocked_addresses,0,sizeof(blocked_addresses));
	memset(blocked_names,0,sizeof(blocked_names));
}

void chat_block_pt::flush()
{
	int i;
	for (i=0; i<nblocks_byname; i++)
		if (blocked_names[i])	free(blocked_names[i]);
	init();
}

chat_block_pt::chat_block_pt()
{
	init();
}

chat_block_pt::~chat_block_pt()
{
	flush();
}

/*****************************************************/

bool chat_block_pt::is_id_blocked(int id)
{
	int i;

	for (i=nblocks_byid-1; i>=0; i--)
	{
		if (id==blocked_ids[i]) return true;
	}
	return false;
}

bool chat_block_pt::is_ip_blocked(netadr_t *ip)
{
	int i;

	for (i=nblocks_byip-1; i>=0; i--)
	{
		if (NET_CompareAdr(ip,blocked_addresses+i)) return true;
	}
	return false;
}

bool chat_block_pt::is_name_blocked(char *name)
{
	int i;

	for (i=nblocks_byname-1; i>=0; i--)
	{
		if (!stricmp(name,blocked_names[i])) return true;
	}
	return false;
}

bool chat_block_pt::is_blocked(int pl)
{
	if (block_all_flg)										return true;
	if (block_spectators_flg && players[pl].spectator)		return true;
	if (block_bots_flg && players[pl].isbot)				return true;
	if (is_id_blocked(pl))									return true;
	if (is_ip_blocked(&players[pl].net_address))			return true;
	if (is_name_blocked(players[pl].userinfo.netname))		return true;
	return false;
}

/*****************************************************/

void chat_block_pt::block_byid(int id)
{
	if (is_id_blocked(id)) return;
	if (nblocks_byid>=MAX_CHATBLOCKS) return;
	blocked_ids[nblocks_byid] = id;
	nblocks_byid++;
	Printf("Messages from player #%d are now blocked\n",id);
}

void chat_block_pt::block_byip(int pl)
{
	netadr_t *ip = &(players[pl].net_address);
	if (is_ip_blocked(ip)) return;
	if (nblocks_byip>=MAX_CHATBLOCKS) return;
	memcpy(blocked_addresses+nblocks_byip,ip,sizeof(netadr_t));
	nblocks_byip++;
	Printf("Messages from player's #%d net address are now blocked\n",pl);
}

void chat_block_pt::block_byname(char *name)
{
	char *s;

	if (is_name_blocked(name)) return;
	if (nblocks_byname>=MAX_CHATBLOCKS) return;
	if ( (s=strdup(name)) == NULL ) return;
	blocked_names[nblocks_byname] = s;
	nblocks_byname++;
	Printf("Messages from player %s are now blocked\n",name);
}

void chat_block_pt::block_all()
{
	if (block_all_flg) return;
	block_all_flg = true;
	Printf("General chat messages are now blocked\n");
}

void chat_block_pt::block_spectators()
{
	if (block_spectators_flg) return;
	block_spectators_flg = true;
	Printf("General spectator messages are now blocked\n");
}

void chat_block_pt::block_bots()
{
	if (block_bots_flg) return;
	block_bots_flg = true;
	Printf("Bot messages are now blocked\n");
}

/*****************************************************/

void chat_block_pt::unblock_byid(int id)
{
	int i;

	for (i=nblocks_byid-1; i>=0; i--)
	{
		if (id==blocked_ids[i])
		{
			if (i<nblocks_byid-1)
				blocked_ids[i] = blocked_ids[nblocks_byid-1];
			nblocks_byid--;
			Printf("Messages from player #%d are now unblocked\n",id);
			break;
		}
	}
}

void chat_block_pt::unblock_byip(int pl)
{
	int i;
	netadr_t *ip;
	
	ip = &(players[pl].net_address);
	for (i=nblocks_byip-1; i>=0; i--)
	{
		if (NET_CompareAdr(ip,blocked_addresses+i))
		{
			if (i<nblocks_byip-1)
				memcpy(blocked_addresses+i,blocked_addresses+nblocks_byip-1,sizeof(netadr_t));
			nblocks_byip--;
			Printf("Messages from player's #%d net address are now unblocked\n",pl);
			break;
		}
	}

}

void chat_block_pt::unblock_byname(char *name)
{
	int i;

	for (i=nblocks_byname-1; i>=0; i--)
	{
		if (!stricmp(name,blocked_names[i]))
		{
			char *s = blocked_names[i];
			if (i<nblocks_byname-1)
				blocked_names[i] = blocked_names[nblocks_byname-1];
			nblocks_byname--;
			free(s);
			Printf("Messages from player %s are now unblocked\n",name);
			break;
		}
	}
}

void chat_block_pt::unblock_all()
{
	if (!block_all_flg) return;
	block_all_flg = false;
	Printf("General chat messages are now unblocked\n");
}

void chat_block_pt::unblock_spectators()
{
	if (!block_spectators_flg) return;
	block_spectators_flg = false;
	Printf("General spectator messages are now unblocked\n");
}

void chat_block_pt::unblock_bots()
{
	if (!block_bots_flg) return;
	block_bots_flg = false;
	Printf("Bot messages are now unblocked\n");
}

/*****************************************************/

void chat_block_pt::toggle_byid(int id)
{
	if (is_id_blocked(id))		unblock_byid(id);
	else						block_byid(id);
}

void chat_block_pt::toggle_byip(int pl)
{
	netadr_t *ip = &(players[pl].net_address);
	if (is_ip_blocked(ip))		unblock_byip(pl);
	else						block_byip(pl);
}

void chat_block_pt::toggle_byname(char *name)
{
	if (is_name_blocked(name))	unblock_byname(name);
	else						block_byname(name);
}

void chat_block_pt::toggle_all()
{
	if (block_all_flg)			unblock_all();
	else						block_all();
}

void chat_block_pt::toggle_spectators()
{
	if (block_spectators_flg)	unblock_spectators();
	else						block_spectators();
}

void chat_block_pt::toggle_bots()
{
	if (block_bots_flg)	unblock_bots();
	else				block_bots();
}

/************************************************************/

static chat_block_pt chat_block_parms;

/************************************************************/

static void chat_block_usage(char *s)
{
	Printf(	"Usage:\n"
		    "   %s all            or\n"
			"   %s spec           or\n"
			"   %s bots           or\n"
			"   %s $player_name   or\n"
			"   %s #player_id     or\n"
			"   %s @player_id\n",
			s, s, s, s, s, s);
}

CCMD (chat_block)
{
	int		i;
	char	*p;

	if (argv.argc() != 2) 
	{
		USAGE:
		chat_block_usage("chat_block");
		return;
	}
	p = argv[1];
	if (!stricmp(p,"all"))
	{
		chat_block_parms.block_all();
	}
	else if (!stricmp(p,"spec") || !stricmp(p,"spectators"))
	{
		chat_block_parms.block_spectators();
	}
	else if (!stricmp(p,"bots"))
	{
		chat_block_parms.block_bots();
	}
	else if (*p=='#')
	{
		p++;
		if (sscanf(p,"%d",&i)!=1 || i<0 || i>=MAXPLAYERS || !playeringame[i])
			goto USAGE;
		else
			chat_block_parms.block_byid(i);
	}
	else if (*p=='@')
	{
		p++;
		if (sscanf(p,"%d",&i)!=1 || i<0 || i>=MAXPLAYERS || !playeringame[i])
			goto USAGE;
		else
			chat_block_parms.block_byip(i);
	}
	else if (*p=='$')
	{
		p++;
		if (*p=='\0')
			goto USAGE;
		else
			chat_block_parms.block_byname(p);
	}
	else
	{
		goto USAGE;
	}
}

/************************************************************/

CCMD (chat_unblock)
{
	int		i;
	char	*p;

	if (argv.argc() != 2) 
	{
		USAGE:
		chat_block_usage("chat_unblock");
		return;
	}
	p = argv[1];
	if (!stricmp(p,"all"))
	{
		chat_block_parms.unblock_all();
	}
	else if (!stricmp(p,"spec") || !stricmp(p,"spectators"))
	{
		chat_block_parms.unblock_spectators();
	}
	else if (!stricmp(p,"bots"))
	{
		chat_block_parms.unblock_bots();
	}
	else if (*p=='#')
	{
		p++;
		if (sscanf(p,"%d",&i)!=1 || i<0 || i>=MAXPLAYERS || !playeringame[i])
			goto USAGE;
		else
			chat_block_parms.unblock_byid(i);
	}
	else if (*p=='@')
	{
		p++;
		if (sscanf(p,"%d",&i)!=1 || i<0 || i>=MAXPLAYERS || !playeringame[i])
			goto USAGE;
		else
			chat_block_parms.unblock_byip(i);
	}
	else if (*p=='$')
	{
		p++;
		if (*p=='\0')
			goto USAGE;
		else
			chat_block_parms.unblock_byname(p);
	}
	else
	{
		goto USAGE;
	}
}

/************************************************************/

CCMD (chat_toggle)
{
	int		i;
	char	*p;

	if (argv.argc() != 2) 
	{
		USAGE:
		chat_block_usage("chat_toggle");
		return;
	}
	p = argv[1];
	if (!stricmp(p,"all"))
	{
		chat_block_parms.toggle_all();
	}
	else if (!stricmp(p,"spec") || !stricmp(p,"spectators"))
	{
		chat_block_parms.toggle_spectators();
	}
	else if (!stricmp(p,"bots"))
	{
		chat_block_parms.toggle_bots();
	}
	else if (*p=='#')
	{
		p++;
		if (sscanf(p,"%d",&i)!=1 || i<0 || i>=MAXPLAYERS || !playeringame[i])
			goto USAGE;
		else
			chat_block_parms.toggle_byid(i);
	}
	else if (*p=='@')
	{
		p++;
		if (sscanf(p,"%d",&i)!=1 || i<0 || i>=MAXPLAYERS || !playeringame[i])
			goto USAGE;
		else
			chat_block_parms.toggle_byip(i);
	}
	else if (*p=='$')
	{
		p++;
		if (*p=='\0')
			goto USAGE;
		else
			chat_block_parms.toggle_byname(p);
	}
	else
	{
		goto USAGE;
	}
}

/************************************************************/

CCMD (chat_reset)
{
	chat_block_parms.flush();
	Printf("All chat blocks have been cleared\n");
}

/************************************************************/

CCMD(chatlog)
{
	chatlog_control("zdchat");
}

/************************************************************/

EXTERN_CVAR (Int,  msglevel)
EXTERN_CVAR (Bool, show_messages)

//
// ZD_Chat - chat_kind: 0 = normal, 1 = team, 2 = private
//
static void ZD_Chat(int chat_kind)
{
	int		pl;
	char	*s, *plname;

	pl = ZD_ReadByte();
	s = ZD_ReadString();

	// [Danni] Bug Fix
	if (!playeringame[pl])
		return;

	if (chat_block_parms.is_blocked(pl))	return;

	plname = players[pl].userinfo.netname;
	switch (chat_kind)
	{
		case 0:			// Normal Chat
			Printf (PRINT_CHAT, "%s: %s\n", plname, s);
			chatlog_add(plname,s);
			//If the msg. doesn't show, the sound should not play either
			if (show_messages && msglevel<=PRINT_CHAT)
				S_Sound (CHAN_VOICE, gameinfo.chatSound, 1, ATTN_NONE);
			break;
		case 1:			// Team Chat
			Printf (PRINT_TEAMCHAT, "%s: %s\n", plname, s);
			chatlog_add(plname,s);
			//If the msg. doesn't show, the sound should not play either
			if (show_messages && msglevel<=PRINT_TEAMCHAT)
				S_Sound (CHAN_VOICE, "misc/admin", 1, ATTN_NONE);
			break;
		case 2:			// Private Chat
			Printf (PRINT_PRIVCHAT, "%s: %s\n", plname, s);
			chatlog_add(plname,s);
			//If the msg. doesn't show, the sound should not play either
			if (show_messages && msglevel<=PRINT_PRIVCHAT)
				S_Sound (CHAN_VOICE, "misc/admin", 1, ATTN_NONE);
			break;
	}
}

//
// ZD_AdminChat - Server admins are special, so you should ph33r!
//

static void ZD_AdminChat(void)
{
	char*	s = ZD_ReadString();

	Printf (PRINT_TEAMCHAT, "%s", s);
	chatlog_add(NULL,s);
	S_Sound (CHAN_VOICE, "misc/admin", 1, ATTN_NONE);
}


//
// ZD_FirePistol 
// 

static void ZD_FirePistol(void)
{
	int			pnum = ZD_ReadByte();
	player_t	*player = &players[pnum];

	if (!playeringame[pnum] || players[pnum].playerstate == PST_DEAD || !players[pnum].mo)
		return;

	S_Sound (player->mo, CHAN_WEAPON, "weapons/pistol", 1, ATTN_NORM);
	player->mo->PlayAttacking2 ();

	ZD_PlayerFireWeaponState(pnum);
}

//
// ZD_FireShotgun 
// 

static void ZD_FireShotgun(void)
{
	int			pnum = ZD_ReadByte();
	player_t	*player = &players[pnum];

	if (!playeringame[pnum] || !player->mo || player->playerstate == PST_DEAD)
		return;

	S_Sound (player->mo, CHAN_WEAPON, "weapons/shotgf", 1, ATTN_NORM);
	player->mo->PlayAttacking2 ();

	ZD_PlayerFireWeaponState(pnum);
}

//
// ZD_FireShotgun2
// 

static void ZD_FireShotgun2(int cmd)
{
	int			pnum = ZD_ReadByte();
	player_t	*player = &players[pnum];

	if (!playeringame[pnum]  || !player->mo || players[pnum].playerstate == PST_DEAD)
		return;

	if (cmd == sv_fireshotgun2)
	{
		S_Sound (player->mo, CHAN_WEAPON, "weapons/sshotf", 1, ATTN_NORM);
		player->mo->PlayAttacking2 ();
		ZD_PlayerFireWeaponState(pnum);
	}
	else if (cmd == sv_openshotgun2)
	{
		S_Sound (player->mo, CHAN_WEAPON, "weapons/sshoto", 1, ATTN_NORM);
	}
	else if (cmd == sv_loadshotgun2)
	{
		S_Sound (player->mo, CHAN_WEAPON, "weapons/sshotl", 1, ATTN_NORM);
	}
	else if (cmd == sv_closeshotgun2)
	{
		S_Sound (player->mo, CHAN_WEAPON, "weapons/sshotc", 1, ATTN_NORM);
	}
}

//
// ZD_FireChaingun
// 

static void ZD_FireChaingun(void)
{
	int			pnum = ZD_ReadByte();
	player_t	*player = &players[pnum];

	if (!playeringame[pnum] || players[pnum].playerstate == PST_DEAD || !players[pnum].mo)
		return;

	S_Sound (player->mo, CHAN_WEAPON, "weapons/chngun", 1, ATTN_NORM);
	player->mo->PlayAttacking2 ();

	ZD_PlayerFireWeaponState(pnum);
}

//
// ZD_FireBFG
//

static void ZD_FireBFG(void)
{
	int		pl = ZD_ReadByte();

	if (!playeringame[pl] || !players[pl].mo)
		return;

	S_Sound (players[pl].mo, CHAN_WEAPON, "weapons/bfgf", 1, ATTN_NORM);

	ZD_PlayerFireWeaponState(pl);
}


//
// ZD_FireRailgun
//
extern	int		RailOffset;
static void ZD_FireRailgun(void)
{
	int		pl			= ZD_ReadByte();
	RailOffset	= ZD_ReadShort();
	player_t*	player;

	if (!playeringame[pl] || !players[pl].mo) return;

	player = &players[pl];

	P_RailAttack (player->mo, 0, RailOffset);
	RailOffset = 0;

	ZD_PlayerFireWeaponState(pl);

}


//
// ZD_UpdateFrags - Updates the fragcount
//

static void ZD_UpdateFrags(void)
{
	int		pl = ZD_ReadByte();
	int		frags = ZD_ReadShort();

	if (!playeringame[pl])	// should NEVER happen
		return;

	players[pl].fragcount = frags;
	update_rank_spread_info();
}

// Lyfe - Dec 15.
// allow server to notify us that 
static void ZD_UpdateKills(void)
{
	int	playernum = ZD_ReadByte();
	int	kills  = ZD_ReadShort();
	
	if (!playeringame[playernum])	// should NEVER happen
		return;
	
	// Lyfe (30Dec2004) - apparently this increments in p_mobj.cpp:AActor::Die()
	//level.killed_monsters += (kills - players[playernum].killcount);
	players[playernum].killcount = kills;
}

//Kilgore
static void ZD_UpdateTeamScore(void)
{
	int		tm = ZD_ReadByte();
	int		score = ZD_ReadShort();

	if (tm>=0 && tm<NUM_TEAMS)
	{
		TeamInfo[tm].score = score;
		update_rank_spread_info();
	}
}

//
// ZD_UpdateExperience - Update our experience (HUD use only)
//

static void ZD_UpdateExperience(void)
{
	players[consoleplayer].experience = ZD_ReadShort();
}

//
// ZD_UpdateWeapon
//

static void ZD_UpdateWeapon(void)
{
	int				weap = ZD_ReadByte();
	weapontype_t	newweap = (weapontype_t)weap;

	// We now have the weapon
	players[consoleplayer].weaponowned[weap] = true;

	// Make sure it is up
	if (players[consoleplayer].readyweapon != newweap)
		players[consoleplayer].pendingweapon = newweap;


}

//
// ZD_GetNextLevel
//
static void ZD_GetNextLevel(int version)
{
	ZD_SetupLevel(version,gamestate==GS_LEVEL);
}


static void disconnect_client_aux(int i)
{
	if (i==displayplayer  &&  i!=consoleplayer)
		G_ChangeSpy(consoleplayer);

	P_DisconnectEffect(players[i].mo);

	// Remove the AActor first
	if (players[i].mo)
	{
		players[i].mo->Destroy();
		players[i].mo = NULL;
	}

	//Kilgore: remove any chat blocks from this player ID
	chat_block_parms.unblock_byid(i);

	playeringame[i] = false;
	memset( &players[i], 0, sizeof(players[i]) );
	update_rank_spread_info();
}


//
// ZD_DisconnectClient
// 

static void ZD_DisconnectClient(void)
{
	int i = ZD_ReadByte();

	if (!playeringame[i])
	{
		Printf("ZD_DisconnectClient: %d error in player array!\n", i);
		return;
	}
	if (players[i].isbot)
	{
		Printf("ZD_DisconnectClient: Error: %d is a bot\n", i);
		return;
	}
	disconnect_client_aux(i);
}


//
// ZD_DisconnectBot - Removes a bot from the playeringame array
// 

static void ZD_DisconnectBot(void)
{
	int i = ZD_ReadByte();

	if (!playeringame[i])
	{
		Printf("ZD_DisconnectBot: %d error in player array!\n", i);
		return;
	}
	if (!players[i].isbot)
	{
		Printf("ZD_DisconnectBot: Error: %d is not a bot!\n", i);
		return;
	}
	disconnect_client_aux(i);
}


//
// ZD_UpdateInventory - always is consoleplayer
// 

static void ZD_UpdateInventory(void)
{
	int		which = ZD_ReadByte();
	players[consoleplayer].inventory[which] = ZD_ReadByte();
}


//
// ZD_UseInventory - A player has used an item
//

static void ZD_UseInventory(void)
{
	int			pl = ZD_ReadByte();
	int			which = ZD_ReadByte();
	int			numleft;
	artitype_t	arti = (artitype_t)which;

	// [Danni] Bug Fix
	if (!playeringame[pl])
		return;

	// Hey! Thats us!
	if (pl == consoleplayer)
	{
		numleft = ZD_ReadByte();
		P_UseArtifact(&players[consoleplayer], arti);
		players[consoleplayer].inventory[which] = numleft;
	}
	else if (players[pl].mo)
	{
		S_Sound (players[pl].mo, CHAN_ITEM,
			arti < arti_firstpuzzitem ? "misc/invuse" : "PuzzleSuccess",
			1, ATTN_NORM);
	}

	
	
}


//
// ZD_GiveArti - Give em an artifact
// 

static void ZD_GiveArti(void)
{
	int		which = ZD_ReadByte();
	int		num	  = ZD_ReadByte();
	// [Danni] Bug Fix
	if (which > NUMARTIFACTS) 
		return;
	P_GiveArtifact(&players[consoleplayer], (artitype_t)which);

	//Printf("Got %d of %d\n", num, which);
}


//
// ZD_SpawnRain - Special for Heretic
//	

static void ZD_SpawnRain(void)
{
	AActor		*mo;
	int			pl			= ZD_ReadByte();
	fixed_t		x			= ZD_ReadShort() << FRACBITS;
	fixed_t		y			= ZD_ReadShort() << FRACBITS;
	fixed_t		momz		= ZD_ReadShort() << FRACBITS;

	// [Danni] Bug Fix
	if (!playeringame[pl])
		return;
	mo = Spawn<ARainPillar> (x, y, ONCEILINGZ);
	mo->Translation = TRANSLATION(TRANSLATION_PlayersExtra,pl);
	mo->momx = 1; // Force collision detection
	mo->momz = -mo->Speed;
	mo->special2 = pl; // Transfer player number

	P_CheckMissileSpawn(mo);
}

// Helper function
void stringupr(char *s)
{
	while (*s)
	*s++ = toupper (*s);
}

//
// ZD_SetMOTD - Sets the message of the day and tics to display it
//

static void ZD_SetMOTD(char *text)
{
	char	MOTD_message[1024];
	int		i;

	zd_motdtics = 15;		// seconds
	
	stringupr(text);

	strcpy(MOTD_message, text);

	for (i=0; i<1024; i++)
	{
		if (!memcmp(MOTD_message+i,"<BR>",4))	//Kilgore: simplify
			memcpy(MOTD_message+i,"   \n",4);
	}

	zd_motd = new DHUDMessage (MOTD_message, 1.5f, 0.375f, CR_WHITE, zd_motdtics);
	StatusBar->AttachMessage (zd_motd, 'CNTR');

}

static void	ZD_ClientWeaponSlot(void)
{
	byte slot = ZD_ReadByte();
	int	 player = consoleplayer;

	/*if (slot < NUM_WEAPON_SLOTS)
	{
		weapontype_t newweap = WeaponSlots[slot].PickWeapon (&players[player]);
		if (newweap < NUMWEAPONS && newweap != players[player].readyweapon)
		{
			players[player].pendingweapon = newweap;
		}
	}*/

	if ((weapontype_t)slot != players[player].readyweapon)
	{ 
		players[player].pendingweapon = (weapontype_t)slot; 
		//Printf("New weapon %d\n", slot);
	}

	
}

//
// ZD_LocalDemoTic - Processes the localclients cmd as if it were our own
// 
static void ZD_LocalDemoTic(void)
{
	player_t*	pl = &players[consoleplayer];
	fixed_t		x,y,z,momx,momy,momz;

	if (!net_demoplayback || !pl->mo || gamestate != GS_LEVEL)
	{
		ZD_ReadByte();
		ZD_ReadByte();
		ZD_ReadWord();
		ZD_ReadWord();
		ZD_ReadWord();
		ZD_ReadWord();
		ZD_ReadWord();
		ZD_ReadWord();

		ZD_ReadLong();
		ZD_ReadLong();
		ZD_ReadLong();
		ZD_ReadLong();
		ZD_ReadLong();
		ZD_ReadLong();
		return;
	}

	zd_demolasttic = ZD_ReadLong();
	pl->cmd.ucmd.buttons =		ZD_ReadByte();
	pl->cmd.ucmd.pitch =		ZD_ReadWord();
	pl->cmd.ucmd.yaw =			ZD_ReadWord();
	pl->cmd.ucmd.forwardmove =	ZD_ReadWord();
	pl->cmd.ucmd.sidemove =		ZD_ReadWord();
	pl->cmd.ucmd.upmove =		ZD_ReadWord();
	pl->cmd.ucmd.roll =			ZD_ReadWord();

	x = ZD_ReadLong();
	y = ZD_ReadLong();
	z = ZD_ReadLong();
	momx = ZD_ReadLong();
	momy = ZD_ReadLong();
	momz = ZD_ReadLong();

	if (pl->mo)
	{
		pl->mo->x = x;
		pl->mo->y = y;
		pl->mo->z = z;
		pl->mo->momx = momx;
		pl->mo->momy = momy;
		pl->mo->momz = momz;
	}


	P_PlayerThink(pl);
	//zd_lasttic = gametic;
	//ZD_PlayerPredict();
}

//
// ZD_FireDemoGun
//

static void ZD_FireDemoGun(void)
{
	player_t*	player = &players[consoleplayer];
	int			refire = ZD_ReadByte();
	
	//A_ReFire(player,&player->psprites[ps_weapon]);

	player->refire = refire;
}


void ZD_GetLocalUserInfo(void)
{
	player_t	*p;
	char		*str;
	
    p = &players[consoleplayer];

	// Players name
	str = ZD_ReadString();
	if (strlen(str) > MAXPLAYERNAME)
		str[MAXPLAYERNAME] = '\0';
	//stringupr(str);
	strcpy(p->userinfo.netname, str);
	
    // Other info
	p->userinfo.gender = ZD_ReadByte();
    p->userinfo.color = ZD_ReadLong();

	// Build translation tables, always gotta do this
	R_BuildPlayerTranslation (consoleplayer, p->userinfo.color);
    
	// Make sure the skin is valid
	p->userinfo.requested_skin = R_FindSkin(ZD_ReadString());

#if 1	//HSDEBUGB
	p->userinfo.actual_skin =	(zd_useskins) ?		p->userinfo.requested_skin :
								(p->isbot) ?		R_FindSkin("zbot") :
													R_FindSkin("base") ;
#else
	p->userinfo.actual_skin = p->userinfo.requested_skin;
#endif
}

static void	ZD_RCONAccess(void)
{
	int		okay = ZD_ReadByte();

	if (okay==1)
	{ Printf("RCON access has been GRANTED!\n"); rcon_access = true; }
	else if (okay==0)
	{ Printf("RCON access has been DENIED!\n"); rcon_access = false; }
}


static void	ZD_CantJoin(void)
{
	DHUDMessage	*msg;

	msg = new DHUDMessage ("Unable to join\n\nPlayer limit has been reached.", 1.5f, 0.375f, CR_WHITE, 5);
	StatusBar->AttachMessage (msg, 'CNTR');

}

static void	ZD_BadTeam(void)
{
	DHUDMessage	*msg;

	msg = new DHUDMessage ("You cannot join the game on this team", 1.5f, 0.375f, CR_GOLD, 5);
	StatusBar->AttachMessage (msg, 'CNTR');

}


//Kilgore: support for audio announcements
typedef struct
{
	char	*msg;
	char	*audio_name;
	bool	queued;
	bool	player_specific;
} spec_evt_attr;


void ZD_SpecialEvent(int ref_player, int evt_id, int parm)
{
	float		vol;
	char		*s,jnk[64];
	static spec_evt_attr sea[NUM_SPEC_EVENTS] =
	{
		{	"DOUBLE KILL",				"ann/double_kill",		false,	true	},
		{	"MULTI KILL",				"ann/multi_kill",		false,	true	},
		{	"ULTRA KILL",				"ann/ultra_kill",		false,	true	},
		{	"MONSTER KILL",				"ann/monster_kill",		false,	true	},
		{	"KILLING SPREE",			"ann/spree",			false,	true	},
		{	"RAMPAGE",					"ann/rampage",			false,	true	},
		{	"DOMINATING",				"ann/dominating",		false,	true	},
		{	"UNSTOPPABLE",				"ann/unstoppable",		false,	true	},
		{	"GODLIKE",					"ann/godlike",			false,	true	},
		{	"1 MINUTE LEFT",			"ann/min1",				false,	false	},
		{	"5 MINUTES LEFT",			"ann/min5",				false,	false	},
		{	"1 FRAG LEFT",				"ann/frag1",			false,	false	},
		{	"2 FRAGS LEFT",				"ann/frag2",			false,	false	},
		{	"3 FRAGS LEFT",				"ann/frag3",			false,	false	},
		{	"FRATRICIDE",				"ann/frat",				false,	true	},
		{	"SUICIDE",					"ann/sui",				false,	true	},
		{	"PREPARE TO FIGHT",			"ann/prep",				false,	false	},
		{	"FIGHT",					"ann/fight",			false,	false	},
		{	"YOU'VE TAKEN THE LEAD",	"ann/lead_taken",		false,	true	},
		{	"YOU'VE LOST THE LEAD",		"ann/lead_lost",		false,	true	},
		{	"YOU ARE TIED FOR THE LEAD","ann/lead_tied",		false,	true	},
		{	"YOU WIN",					"ann/win",				true,	true	},
		{	"YOU LOSE",					"ann/lose",				true,	true	},
		{	"IT'S A TIE",				"ann/tie",				true,	true	},
		{	"IMPRESSIVE",				"ann/impressive",		true,	false	},
		{	"HUMILIATION",				"ann/humiliation",		true,	false	},
		{	"HOLY SHIT",				"ann/holy_shit",		true,	false	},
		{	"WICKED SICK",				"ann/wicked",			false,	true	},
		{	"ASSIST",					"ann/assist",			false,	true	},
		{	"RED FLAG TAKEN",			"ann/red_taken",		false,	false	},
		{	"RED FLAG DROPPED",			"ann/red_dropped",		false,	false	},
		{	"RED FLAG RETURNED",		"ann/red_returned",		false,	false	},
		{	"RED TEAM SCORES",			"ann/red_score",		false,	false	},
		{	"BLUE FLAG TAKEN",			"ann/blue_taken",		false,	false	},
		{	"BLUE FLAG DROPPED",		"ann/blue_dropped",		false,	false	},
		{	"BLUE FLAG RETURNED",		"ann/blue_returned",	false,	false	},
		{	"BLUE TEAM SCORES",			"ann/blue_score",		false,	false	},
		{	"GREEN FLAG TAKEN",			"ann/green_taken",		false,	false	},
		{	"GREEN FLAG DROPPED",		"ann/green_dropped",	false,	false	},
		{	"GREEN FLAG RETURNED",		"ann/green_returned",	false,	false	},
		{	"GREEN TEAM SCORES",		"ann/green_score",		false,	false	},
		{	"WHITE FLAG TAKEN",			"ann/white_taken",		false,	false	},
		{	"WHITE FLAG DROPPED",		"ann/white_dropped",	false,	false	},
		{	"WHITE FLAG RETURNED",		"ann/white_returned",	false,	false	},
		{	"WHITE TEAM SCORES",		"ann/white_score",		false,	false	}
	};

	if (evt_id<0 || evt_id>=NUM_SPEC_EVENTS)
	{
		Printf("BAD SPECIAL EVENT\n");
		return;
	}

	vol = snd_annvolume;
	if ( vol < 0.04999f ) return;

	if (evt_id==SE_SUICIDE || evt_id==SE_TEAMMATE_KILL)
	{
		sprintf(jnk,"%s_%s",sea[evt_id].audio_name, (parm==0) ? "m": (parm==1) ? "f": "c");
		s = jnk;
	}
	else
	{
		s = sea[evt_id].audio_name;
	}

	// Make sure the player-specific sounds are played only when 
	// you're not watching somebody else.
	if (sea[evt_id].player_specific && displayplayer!=ref_player) return;

	if (sea[evt_id].queued)	S_QueuedSound(s);
	else					S_Sound(CHAN_VOICE,s,vol,ATTN_SURROUND);
}


static void ZD_KillMsg(void)
{
	DHUDMessage	*mmsg;
	EColorRange	color;
	const char	*killmsg;
	int			spec_evt_id;

	color = CR_WHITE;
	spec_evt_id = NUM_SPEC_EVENTS;
	switch (ZD_ReadByte())
	{
		case 1:
			killmsg = ""; color = CR_WHITE;
			break;
		case 2:
			killmsg = "double kill!"; color = CR_WHITE; spec_evt_id = SE_DOUBLE;
			break;
		case 3:
			killmsg = "multi kill!";color = CR_GREEN; spec_evt_id = SE_MULTI;
			break;
		case 4:
			killmsg = "ultra kill!";color = CR_GOLD; spec_evt_id = SE_ULTRA;
			break;
		default:
			killmsg = "monster kill!!!";color = CR_YELLOW; spec_evt_id = SE_MONSTER;
			break;
	}
	if (displayplayer!=consoleplayer || !cl_showmultikills)
		return;
	screen->SetFont(BigFont);
	mmsg = new DHUDMessageFadeOut(killmsg, 1.5f, 0.8f, color, 3.f, 0.5f);
	StatusBar->AttachMessage (mmsg, 'MKIL');
	if (spec_evt_id != NUM_SPEC_EVENTS) ZD_SpecialEvent(consoleplayer,spec_evt_id,0);
}

static void ZD_SpreeMsg(void)
{
	int				pl, level, spec_evt_id;
	EColorRange		color;
	DHUDMessage		*mmsg;
	const char		*spreemsg;

	pl			= ZD_ReadByte();
	level		= ZD_ReadByte();
	spreemsg	= ZD_ReadString();
	if (!cl_showsprees)
		return;
	color		= CR_WHITE;
	spec_evt_id	= NUM_SPEC_EVENTS;
	switch (level)
	{
		case 0:
			color = CR_WHITE;
			break;
		case 5:
			if (pl == displayplayer)
			{
				spreemsg = "killing spree";
				spec_evt_id = SE_SPREE;
			}
			color = CR_WHITE;
			break;
		case 10:
			if (pl == displayplayer)
			{
				spreemsg = "rampage!";
				spec_evt_id = SE_RAMPAGE;
			}
			color = CR_BLUE;
			break;
		case 15:
			if (pl == displayplayer)
			{
				spreemsg = "dominating!";
				spec_evt_id = SE_DOMINATING;
			}
			color = CR_GREEN;
			break;
		case 20:
			if (pl == displayplayer)
			{
				spreemsg = "unstoppable!";
				spec_evt_id = SE_UNSTOPPABLE;
			}
			color = CR_GOLD;
			break;
		case 25:
			if (pl == displayplayer)
			{
				spreemsg = "god like!";
				spec_evt_id = SE_GODLIKE;
			}
			color = CR_YELLOW;
			break;
		case 30:
			if (pl == displayplayer)
			{
				spreemsg = "Wicked Sick!";
				spec_evt_id = SE_WICKED_SICK;
			}
			color = CR_BRICK;
			break;
		default:
			spreemsg = NULL;
			break;
	}
	
	if (pl==displayplayer && level!=0)
		screen->SetFont(BigFont);
	mmsg = new DHUDMessageFadeOut(spreemsg, 1.5f, 0.2f, color, 3.f, 0.5f);
	StatusBar->AttachMessage (mmsg, 'KSPR');
	if (spec_evt_id != NUM_SPEC_EVENTS) ZD_SpecialEvent(pl,spec_evt_id,0);
}

//
// ZD_UpdatePlayerTime - Updates player time
//

static void ZD_UpdatePlayerTime(void)
{
	int			pl = ZD_ReadByte();
	int			time = ZD_ReadShort();

	if (playeringame[pl])
		players[pl].minutesingame = time;
}

//
// ZD_PlayerSawup - Chainsaw fix (hack)
//
static void ZD_PlayerSawup(void)
{
	int			pl = ZD_ReadByte();
	int			d = ZD_ReadByte();

	if (!playeringame[pl] || !players[pl].mo)
	{
		Printf("ZD_PlayerSawup: Dont know player %d\n", pl);
		return;
	}
	S_Sound (players[pl].mo, CHAN_WEAPON, (d==0) ? "weapons/sawfull" : "weapons/sawhit", 1, ATTN_NORM);
}

//
// ZD_ParsePacket - Reads and parses everything
//
EXTERN_CVAR (Int, fraglimit)
EXTERN_CVAR (Int, teamscorelimit)
EXTERN_CVAR (Int, spam_window)
EXTERN_CVAR (Int, spam_limit)

int		lastcmd;

void ZD_ParsePacket(void)
{
	int		cmd;
	UCVarValue num;

	while (1)
	{
		cmd = ZD_ReadByte();

		// End.
		if (cmd <= 0)
			break;

		//Printf("cmd: %d\n",cmd);

		switch(cmd)
		{
			// Server has responded!
			case CONNECT_READY:
			{
				zd_netstate = ZD_CONNECTING;
				Printf("Connected!\n");

				if (fabs(R_GetVisibility()-8.0)>1.0e-4)
					R_SetVisibility(8.0f);

				// Set a new timer
				addr_timeout = 15*TICRATE;
				ZD_AttemptConnection();
				break;
			}

			case	NETWORK_ERROR:
				{
					ZD_Error(ZD_ReadString());
					break;
				}

			case sv_consoleplayer:
				displayplayer = consoleplayer = ZD_ReadByte();
				Printf("Consoleplayer is: %d\n", consoleplayer);
				D_SetupUserInfo();
				if (net_demorecording)
					demo_localinfo = true;
				break;

			case sv_dmflags:
				{
					int	d1,d2;

					d1 = ZD_ReadLong();
					num.Int = d1;
					dmflags.ForceSet(num, CVAR_Int);
					d2 = ZD_ReadLong();
					num.Int = d2;
					dmflags2.ForceSet(num, CVAR_Int);
					Printf("SERVER: Dmflags=%d Dmflags2=%d\n", d1, d2);
				}
				break;

			case sv_skill:
				num.Int = ZD_ReadLong();
				gameskill.ForceSet(num, CVAR_Int);
				break;

			case sv_gametype:
				num.Int = 0;
				deathmatch.ForceSet(num,CVAR_Int);
				teamplay.ForceSet(num,CVAR_Int);
				fraglimit.ForceSet(num, CVAR_Int);
				teamscorelimit.ForceSet(num, CVAR_Int);
				spam_window.ForceSet(num, CVAR_Int);
				spam_limit.ForceSet(num, CVAR_Int);
				num.Float = 0.0f;
				teamdamage.ForceSet(num,CVAR_Float);
				num.Int = 4;
				maxteams.ForceSet(num, CVAR_Int);
				#if __CTF__
				//duke
				//==
				{
					memset(ctf_state,0,sizeof(ctf_state));
					memset(ctf_flag_mo,0,sizeof(ctf_flag_mo));
					for (int i=0; i<NUM_TEAMS; i++)
						ctf_carrier_id[i] = -1;
					num.Int = 0;
					ctf.ForceSet(num,CVAR_Int);
				}
				//== end
				#endif

				if (net_demoplayback && demo_version==100)	//Kilgore: handle older demos
				{
					num.Int = ZD_ReadLong();
					deathmatch.ForceSet(num, CVAR_Int);
					if (deathmatch)	Printf("Deathmatch Game\n");
					else			Printf("Cooperative Game\n");
				}
				else if (net_demoplayback && demo_version==105)	//Kilgore: handle older demos
				{
					num.Int = ZD_ReadByte();		deathmatch.ForceSet(num, CVAR_Int);
					num.Int = ZD_ReadByte();		teamplay.ForceSet(num, CVAR_Int);
					if (teamplay)			Printf("Team Deathmatch Game\n");
					else if (deathmatch)	Printf("Deathmatch Game\n");
					else					Printf("Cooperative Game\n");
					num.Float = ZD_ReadFloat();		teamdamage.ForceSet(num,CVAR_Float);
					if (teamplay)	Printf("Team Damage Factor: %d%%\n",(int)(0.5 + 100.0 *(double) num.Float));
					num.Int = ZD_ReadShort();		fraglimit.ForceSet(num, CVAR_Int);
					Printf("Frag Limit: %d\n",num.Int);
					num.Int = ZD_ReadShort();		teamscorelimit.ForceSet(num, CVAR_Int);
					if (teamplay)	Printf("Teamscore Limit: %d\n",num.Int);
					num.Int = ZD_ReadShort();		spam_window.ForceSet(num, CVAR_Int);
					num.Int = ZD_ReadShort();		spam_limit.ForceSet(num, CVAR_Int);
				}
				else
				{
					switch (ZD_ReadByte())
					{
						case 0:
							num.Int = 1;
							deathmatch.ForceSet(num,CVAR_Int);
							Printf("Deathmatch Game\n");
							break;

						case 1:
							num.Int = 1;
							teamplay.ForceSet(num,CVAR_Int);
							deathmatch.ForceSet(num,CVAR_Int);
							Printf("Team Deathmatch Game\n");
							break;

						#if __CTF__
						case 3:
							num.Int = 1;
							ctf.ForceSet(num,CVAR_Int);
							teamplay.ForceSet(num,CVAR_Int);
							deathmatch.ForceSet(num,CVAR_Int);
							num.Int = 2;
							maxteams.ForceSet(num, CVAR_Int);
							Printf("Capture The Flag Game\n");
							break;
						#endif

						default:		// case 2
							Printf("Cooperative Game\n");
							break;
					}
					num.Float = ZD_ReadFloat();
					teamdamage.ForceSet(num,CVAR_Float);
					if (teamplay)
						Printf("Team Damage Factor: %d%%\n",(int)(0.5 + 100.0 *(double) num.Float));

					num.Int = ZD_ReadShort();
					fraglimit.ForceSet(num, CVAR_Int);
					if (fraglimit)
						Printf("Frag Limit: %d\n",num.Int);

					num.Int = ZD_ReadShort();
					teamscorelimit.ForceSet(num, CVAR_Int);
					if (teamplay)
						Printf("Teamscore Limit: %d\n",num.Int);

					num.Int = ZD_ReadShort();
					timelimit.ForceSet(num, CVAR_Int);
					if (timelimit)
						Printf("Time Limit: %d\n",num.Int);

					num.Int = ZD_ReadShort();
					spam_window.ForceSet(num, CVAR_Int);

					num.Int = ZD_ReadShort();
					spam_limit.ForceSet(num, CVAR_Int);

					num.Float = ZD_ReadFloat();
					sv_gravity.ForceSet(num,CVAR_Float);
					Printf("Gravity: %d%%\n",(int)(0.5 + 100.0*num.Float/800.0));

					num.Float = ZD_ReadFloat();
					sv_aircontrol.ForceSet(num,CVAR_Float);
					Printf("Air Control: %d%%\n",(int)(0.5+100.0*num.Float));

					#if VER107
					if (net_demoplayback && demo_version==106)	//Kilgore: handle older demos
					{
						/* do nothing: maxteams is already set above */ ;
					}
					else
					{
						num.Int = ZD_ReadShort();
						if (num.Int>=2 && num.Int<=NUM_TEAMS)
						{
							maxteams.ForceSet(num,CVAR_Int);
							if (teamplay)
								Printf("%d teams\n",(int)maxteams);
						}
					}
					#endif
				}
				break;

			case sv_timeleft:
				timeleft = ZD_ReadLong();
				if (timeleft<0) timeleft = 0;
				break;

			case sv_loadmap:
				need_reborn = 10;
				ZD_SetupLevel(106,false);
				break;

			case sv_loadmap2:
				need_reborn = 10;
				ZD_SetupLevel(107,false);
				break;

			case sv_spawnmobj:
				ZD_SpawnThing();
				break;

			case sv_mobjangle:
				ZD_ThingAngle();
				break;

			case sv_corpse:
				ZD_ThingCorpse();
				break;

			case sv_moveplayer:
				ZD_UpdatePlayer();
				break;

			case sv_mobjstate:
				ZD_SetMobjState();
				break;

			case sv_setspecificstate:
				ZD_SetSpecificState();
				break;

			case sv_movething:
				ZD_UpdateThing();
				break;

			case sv_spawnplayer:
				ZD_SpawnPlayer(106);
				break;

			case sv_spawnplayer2:
				ZD_SpawnPlayer(107);
				break;

			case sv_updatelocalplayer:
				ZD_UpdateConsolePlayer();
				break;

			case sv_spawnmissile:
				CL_SpawnMissile(106);
				break;

			case sv_spawnmissile2:
				CL_SpawnMissile(107);
				break;

			case sv_explodemissile:
				CL_ExplodeMissile();
				break;

			case sv_fireweapon:
				CL_PlayerFireWeapon();
				break;

			case sv_touchthing:
				CL_TouchSpecialThing();
				break;

			case sv_ping:
				ZD_GetPing();
				break;

			case sv_respawnitem:
				ZD_RespawnItem();
				break;

			case sv_updateping:
				{
					int	plyr = ZD_ReadByte();
					players[plyr].ping = ZD_ReadShort();
					break;
				}

			case sv_damagemobj:
				ZD_DamageMobj();
				break;

			case sv_damageplayer:
				ZD_DamagePlayer();
				break;

			case sv_killmobj:
				ZD_KillMobj();
				break;

			case sv_killplayer:
				ZD_KillPlayer();
				break;

			case sv_playernoway:
				ZD_PlayerNoWay();
				break;

			case sv_toggleline:
				ZD_TriggerLine();
				break;

			case sv_dodoor:
				ZD_DoDoor();
				break;

			case sv_doplat:
				ZD_DoPlat();
				break;

			case sv_updatesector:
				ZD_UpdateSector();
				break;

			case sv_destroymobj:
				ZD_DestroyMobj();
				break;

			case sv_secsoundid:
				ZD_StartSequenceID();
				break;

			case sv_secsound:
				ZD_StartSequence();
				break;

			case sv_stopsecseq:
				ZD_StopSectorSequence();
				break;

			case sv_exitlevel:
				ZD_ExitLevel();
				break;

			case sv_doreborn:
				{
					//if (gamestate == GS_LEVEL)
					//	G_PlayerReborn(ZD_ReadByte());
					//else
					ZD_ReadByte();
					break;
				}

			case sv_newmap:
				ZD_ConnectNewMap();
				break;

			case sv_moveplane:
				ZD_MovePlane();
				break;

			case sv_flattexture:
				ZD_UpdateFlat();
				break;

			case sv_dropitem:
				ZD_DropItem();
				break;

			case sv_telemove:
				ZD_TeleMove();
				break;

			case sv_chat:
				ZD_Chat(0);
				break;

			case sv_teamchat:
				ZD_Chat(1);
				break;

			case sv_privchat:
				ZD_Chat(2);
				break;

			case sv_spawnbot:
				ZD_SpawnBot();
				break;

			case sv_playerstate:
				ZD_SetPlayerState();
				break;

			case sv_firepistol:
				ZD_FirePistol();
				break;

			case sv_fireshotgun:
				ZD_FireShotgun();
				break;

			case sv_fireshotgun2:
			case sv_openshotgun2:
			case sv_loadshotgun2:
			case sv_closeshotgun2:
				ZD_FireShotgun2(cmd);
				break;

			case sv_firechaingun:
				ZD_FireChaingun();
				break;

			case sv_firebfg:
				ZD_FireBFG();
				break;

			case sv_fireplasma:
			case sv_firerocket:
				{
					int	p = ZD_ReadByte();

					// [NightFang]- This HAS happened!
					if (p<0 || p>=MAXPLAYERS)	//Kilgore: better check
						break;

					if (playeringame[p] && 
						players[p].playerstate != PST_DEAD && 
						players[p].mo) 
						{ players[p].mo->PlayAttacking(); }
					break;
				}

			case sv_firerailgun:
				ZD_FireRailgun();
				break;

			case sv_userinfo:
				ZD_GetUserInfo();
				break;

			case sv_updatefrags:
				ZD_UpdateFrags();
				break;

			case sv_updateteamscore:
				ZD_UpdateTeamScore();
				break;

			case sv_updatekills:
				ZD_UpdateKills();
				break;

			case sv_special_event:
			{
				int evt_id = ZD_ReadByte();
				int parm = ZD_ReadByte();
				ZD_SpecialEvent(consoleplayer,evt_id,parm);
				break;
			}

			case sv_wepchange:
				ZD_UpdateWeapon();
				break;

			case sv_newmap2:
				ZD_GetNextLevel(106);
				break;

			case sv_newmap3:
				ZD_GetNextLevel(107);
				break;

			case sv_adminchat:
				ZD_AdminChat();
				break;

			case sv_disconnectclient:
				ZD_DisconnectClient();
				break;

			case sv_printf:
				Printf("%s",ZD_ReadString());
				break;

			case sv_disconnectbot:
				ZD_DisconnectBot();
				break;

			case sv_updateinv:
				ZD_UpdateInventory();
				break;

			case sv_useinv:
				ZD_UseInventory();
				break;

			case sv_givearti:
				ZD_GiveArti();
				break;

			case sv_spawnrain:
				ZD_SpawnRain();
				break;

			case sv_motd:
				ZD_SetMOTD(ZD_ReadString());
				break;

			case sv_rconaccess:
				ZD_RCONAccess();
				break;

			case sv_cantjoin:
				ZD_CantJoin();
				break;

			case sv_badteam:
				ZD_BadTeam();
				break;

			case sv_killmsg:
				ZD_KillMsg();
				break;

			case sv_spreemsg:
				ZD_SpreeMsg();
				break;

			case sv_playertimer:
				ZD_UpdatePlayerTime();
				break;

			case sv_sawhit:
				ZD_PlayerSawup();
				break;

			case sv_missedpacket:
				ZD_CheckMissedPacket();
				break;

			case sv_kick:
				ZD_Kicked();
				return;

			case sv_experience:
				ZD_UpdateExperience();
				break;

			case sv_header:
				ZD_ReadLong();
				break;

			case zddemo_capture:
				ZD_LocalDemoTic();
				break;

			case zddemo_switchweapon:
				ZD_ClientWeaponSlot();
				break;

			case zddemo_fireweapon:
				ZD_FireDemoGun();
				break;
			
			case zddemo_endcapture:				// Demos, return the function and run another tic
				demofinishread = true;
				return;

			case zddemo_localuserinfo:
				ZD_GetLocalUserInfo();
				break;

			case zddemo_enddemo:
				{
					if (!demofile)
						break;
					fclose(demofile);
					demofile = NULL;
					demofinishread = true;
					net_demoplayback = false;
					zd_localplay = true;
					ZD_DemoEndMessage();
					return;
				}

			#if __CTF__
			//duke
			//==
			case sv_ctf_event:
				ZD_ctf_event();
				break;

			case sv_ctf_state:
				ZD_ctf_state();
				break;
			//== end
			#endif

			default:
				Printf("Unknown server msg: %d (last: %d)\n", cmd, lastcmd);
				return;
		}

		// Debugging purposes mainly
		lastcmd=cmd;
	}

	

	// If recording a net demo, capture the packet
	if (net_demorecording)
		ZD_CapturePacket(msg_read);

}
