#include "doomtype.h"
#include "doomstat.h"
#include "d_player.h"
#include "g_game.h"
#include "d_net.h"
#include "p_local.h"
#include "gi.h"
#include "i_system.h"
#include "c_dispatch.h"
#include "st_stuff.h"
#include "m_argv.h"
#include "p_effect.h"
#include "c_console.h"
#include "cl_main.h"
#if __CTF__
//duke
//==
#include "actor.h"
#include "ctf.h"
//== end
#endif

void P_MovePlayer (player_t *player);
void P_CalcHeight (player_t *player);
void P_DeathThink (player_t *player);
void ZD_MoveThing(AActor *mobj, fixed_t x, fixed_t y, fixed_t z);

extern		int		zd_demolasttic;

angle_t cl_angle[MAXSAVETICS];
fixed_t cl_viewheight[MAXSAVETICS];
fixed_t cl_deltaviewheight[MAXSAVETICS];
fixed_t cl_jumpTics[MAXSAVETICS];
ticcmd_t	*cl_cmd;
int     reactiontime[MAXSAVETICS];

fixed_t	cl_x[MAXSAVETICS];
fixed_t	cl_y[MAXSAVETICS];
fixed_t	cl_z[MAXSAVETICS];
fixed_t	cl_momx[MAXSAVETICS];
fixed_t	cl_momy[MAXSAVETICS];
fixed_t	cl_momz[MAXSAVETICS];

bool zd_predicting;

// [NightFang] - we gotta have these here for player prediction
void		P_XYMovement (AActor *mo, bool bForceSlide);
void		P_ZMovement (AActor *mo);
void		G_BuildTiccmd (ticcmd_t *cmd);

//
// CL_PredicMove
//
void ZD_PlayerPredict (void)
{
	player_t *p = &players[consoleplayer];
	int       tic=0;//, runtics;
	fixed_t   pitch;

	// Ya never know
	if (!p->mo)
		return;

	if (p->spectator)
	{ P_PlayerThink(p); return; }

	// Save player angle, viewheight,deltaviewheight and jumpTics.
	// Will use it later to predict movements
	cl_angle[gametic%MAXSAVETICS] = p->mo->angle;
	cl_viewheight[gametic%MAXSAVETICS] = p->viewheight;
	cl_deltaviewheight[gametic%MAXSAVETICS] = p->deltaviewheight;
	cl_jumpTics[gametic%MAXSAVETICS] = p->jumpTics;
	reactiontime[gametic%MAXSAVETICS] = p->mo->reactiontime;
	pitch = p->mo->pitch;

	// set the position
	ZD_MoveThing (p->mo, p->realorgin[0], p->realorgin[1], p->realorgin[2]);
	
	// set the velocity
	p->mo->momx = p->realvelocity[0];
	p->mo->momy = p->realvelocity[1];
	p->mo->momz = p->realvelocity[2];
	
	tic = zd_lasttic+1;

	if (p->playerstate == PST_DEAD)
	{
		// predict forward until tic <= gametic
		while (tic <= gametic)
		{
			zd_predicting = true; // disable bobbing, sounds
			p->mo->Tick();
			tic++;
		}

		zd_predicting = false;
		P_DeathThink (p);
		p->mo->Tick();
		return;
	}

	p->mo->angle = cl_angle[tic%MAXSAVETICS];
	p->viewheight = cl_viewheight[tic%MAXSAVETICS];
	p->deltaviewheight = cl_deltaviewheight[tic%MAXSAVETICS];
	p->jumpTics = cl_jumpTics[tic%MAXSAVETICS];
	p->mo->reactiontime = reactiontime[tic%MAXSAVETICS];

	// predict forward until tic <= gametic
	if (!net_demoplayback)
	{
		while (tic <= gametic)
		{
			int buf = tic%MAXSAVETICS;
			memcpy (&players[consoleplayer].cmd, &zd_localcmds[buf], sizeof(ticcmd_t));
	
			if (tic < gametic)
			{
				zd_predicting = true; // disable bobbing, sounds
				P_PlayerZDPredThink(p);
				p->mo->Tick();
			}
			tic++;
		}
	}
	else
	{
		while (tic <= zd_demolasttic)
		{
			int buf = tic%MAXSAVETICS;
			memcpy (&players[consoleplayer].cmd, &zd_localcmds[buf], sizeof(ticcmd_t));
	
			if (tic < gametic)
			{
				zd_predicting = true; // disable bobbing, sounds
				P_PlayerZDPredThink(p);
				p->mo->Tick();		
			}
			tic++;
		}
	}

	if (!p->mo->reactiontime)
		p->mo->angle = cl_angle[gametic%MAXSAVETICS];
	p->mo->pitch = pitch;
	zd_predicting = false; // allow bobbing, sounds

	P_PlayerThink(p);

	difftics++;

	#if __CTF__
	if (ctf)
	{
		for (int i=maxteams-1; i>=0; i--)
		{
			if (consoleplayer==ctf_carrier_id[i])
				CTF_Update_Flag_Pos(i);
		}
	}
	#endif
}