#ifdef		USEGUI


// Dmflags.cpp : implementation file
//

#include "stdafx.h"
#include "zserv.h"
#include "Dmflags.h"

#include "errors.h"
//#include "hardware.h"

#include "doomtype.h"
#include "m_argv.h"
#include "d_main.h"
#include "i_system.h"
#include "c_console.h"
#include "c_dispatch.h"
#include "z_zone.h"
#include "version.h"
#include "i_video.h"
//#include "i_sound.h"
#include "stats.h"

#include "sv_main.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

dmflag_t	c_dmflags[NUM_DMFLAGS] = {
	{ DF_FORCE_FALLINGZD,	"Falling Damage (ZDOOM)",	false },
	{ DF_FORCE_FALLINGHX,	"Falling Damage (HEXEN)",	false },
	
	{ DF_WEAPONS_STAY,		"Weapons Stay",				false },
	{ DF_NO_ITEMS,			"Spawn Items",				true },
	{ DF_NO_HEALTH,			"Spawn Health",				true },
	{ DF_NO_ARMOR,			"Spawn Armor",				true },

	{ DF_SPAWN_FARTHEST,	"Spawn Farthest",			false },
	{ DF_SAME_LEVEL,		"Same Level",				false },
	{ DF_FORCE_RESPAWN,		"Force Respawn",			false },
	{ DF_NO_EXIT,			"Allow Level Exit",			true },
	{ DF_INFINITE_AMMO,		"Infinite Ammo",			false },

	{ DF_NO_MONSTERS,		"No Monsters",				false },
	{ DF_MONSTERS_RESPAWN,	"Monsters Respawn",			false },
	{ DF_ITEMS_RESPAWN,		"Items Respawn",			false },
	{ DF_FAST_MONSTERS,		"Fast Monsters",			false },
	{ DF_NO_JUMP,			"Allow Jumping",			true },
	{ DF_NO_FREELOOK,		"Allow Freelook",			true }
};

dmflag_t	c_dmflags2[NUM_DMFLAGS2] = {
	{ DF2_SAME_SPAWN_SPOT,	"Spawn same spot as death",	false },
	{ DF2_YES_WEAPONDROP,	"Players drop weapons",		false },
	{ DF2_BARRELS_RESPAWN,	"Respawn Barrels",			false },
	{ DF2_YES_INVUL,		"Respawn Protection",		false },
	{ DF2_NICE_WEAPONS,		"Nice Weapons (coop)",		false },
	{ DF2_KEEP_KEYS,		"Keep keys (coop)",			false },
	{ DF2_OLDWEPSOUND,		"Old School Weapon Sounds", false },
	{ DF2_STRONG_MONSTERS,	"Monsters 2x strong",		false },
	{ DF2_POWERFUL_MONSTERS,"Monsters 2x powerful",		false },
	{ DF2_IHATESOUNDS,		"Oldschool Sounds",			false }
	
};


/////////////////////////////////////////////////////////////////////////////
// CDmflags dialog


CDmflags::CDmflags(CWnd* pParent /*=NULL*/)
	: CDialog(CDmflags::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDmflags)
	m_Stat = _T("");
	m_Stat2 = _T("");
	//}}AFX_DATA_INIT
}


void CDmflags::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDmflags)
	DDX_Control(pDX, IDC_DMFLAGS2, m_Dmflags2);
	DDX_Control(pDX, IDC_DMFLAGS, m_Dmflags);
	DDX_Text(pDX, IDC_STAT, m_Stat);
	DDX_Text(pDX, IDC_STAT2, m_Stat2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDmflags, CDialog)
	//{{AFX_MSG_MAP(CDmflags)
	ON_BN_CLICKED(ID_TOGGLEDMFLAGS, OnToggledmflags)
	ON_BN_CLICKED(ID_TOGGLEDMFLAGS2, OnToggledmflags2)
	ON_NOTIFY(NM_DBLCLK, IDC_DMFLAGS, OnDblclkDmflags)
	ON_NOTIFY(NM_RCLICK, IDC_DMFLAGS, OnRclickDmflags)
	ON_NOTIFY(NM_DBLCLK, IDC_DMFLAGS2, OnDblclkDmflags2)
	ON_NOTIFY(NM_RCLICK, IDC_DMFLAGS2, OnRclickDmflags2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDmflags message handlers

BOOL CDmflags::OnInitDialog() 
{
	CDialog::OnInitDialog();
	int					i, item;
	UCVarValue			num;
	
	m_Dmflags.InsertColumn(COL_FLAG, "Flag", LVCFMT_LEFT, 275);
	m_Dmflags.InsertColumn(COL_VALUE, "Value", LVCFMT_LEFT, 50);

	m_Dmflags2.InsertColumn(COL_FLAG, "Flag", LVCFMT_LEFT, 275);
	m_Dmflags2.InsertColumn(COL_VALUE, "Value", LVCFMT_LEFT, 50);

	// Populate the dmflags list
	for (i=NUM_DMFLAGS-1; i>=0; i--)
	{
		item = m_Dmflags.InsertItem(0, "");
		m_Dmflags.SetItemData(item, i);
		m_Dmflags.SetItemText(item, COL_FLAG, c_dmflags[i].desc);

		c_dmflags[i].value = c_dmflags[i].defaultvalue;

		// The default flag is YES, so inverse these values
		if (c_dmflags[i].defaultvalue)
		{
			if (dmflags & c_dmflags[i].flag)
			{
				m_Dmflags.SetItemText(item, COL_VALUE, "false");
				c_dmflags[i].value = false;
			}
			else
			{
				m_Dmflags.SetItemText(item, COL_VALUE, "true");
				c_dmflags[i].value = true;
			}
		}
		else
		{
			if (dmflags & c_dmflags[i].flag)
			{
				m_Dmflags.SetItemText(item, COL_VALUE, "true");
				c_dmflags[i].value = true;
			}
			else
			{
				m_Dmflags.SetItemText(item, COL_VALUE, "false");
				c_dmflags[i].value = false;
			}
		}

		
	}

	// Populate the dmflags2 list
	for (i=NUM_DMFLAGS2-1; i>=0; i--)
	{
		item = m_Dmflags2.InsertItem(0, "");
		m_Dmflags2.SetItemData(item, i);
		m_Dmflags2.SetItemText(item, COL_FLAG, c_dmflags2[i].desc);

		c_dmflags2[i].value = c_dmflags2[i].defaultvalue;

		// The default flag is YES, so inverse these values
		if (c_dmflags2[i].defaultvalue)
		{
			if (dmflags2 & c_dmflags2[i].flag)
			{
				m_Dmflags2.SetItemText(item, COL_VALUE, "false");
				c_dmflags2[i].value = false;
			}
			else
			{
				m_Dmflags2.SetItemText(item, COL_VALUE, "true");
				c_dmflags2[i].value = true;
			}
		}
		else
		{
			if (dmflags2 & c_dmflags2[i].flag)
			{
				m_Dmflags2.SetItemText(item, COL_VALUE, "true");
				c_dmflags2[i].value = true;
			}
			else
			{
				m_Dmflags2.SetItemText(item, COL_VALUE, "false");
				c_dmflags2[i].value = false;
			}
		}

	}

	// Update the number output
	num = dmflags2.GetGenericRep (CVAR_Int);
	m_Stat2.Format("%d", num.Int);

	num = dmflags.GetGenericRep (CVAR_Int);
	m_Stat.Format("%d", num.Int);

	UpdateData(FALSE);

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDmflags::OnToggledmflags() 
{
	int data, index, set=0, clear=0;
	UCVarValue			num;

	index = m_Dmflags.GetNextItem(-1, LVIS_SELECTED | LVIS_FOCUSED);

	// Okay, thats fine, its error time
    if (index == -1)
	{
		MessageBox("Gotta select something first", "Err0r0rz", MB_OK);
		return;
	}
	else
	{
		// Cool! Lets toggle with dmflags
		data = m_Dmflags.GetItemData(index);
		if (dmflags & c_dmflags[data].flag)
			clear = c_dmflags[data].flag;
		else
			set = c_dmflags[data].flag;

		dmflags = (dmflags & ~clear) | set;

		ZD_BroadcastDMFlags(&dmflags);

		c_dmflags[data].value = !c_dmflags[data].value;

		if (c_dmflags[data].value)
			m_Dmflags.SetItemText(data, COL_VALUE, "true");
		else
			m_Dmflags.SetItemText(data, COL_VALUE, "false");

		// Update the number output
		num = dmflags.GetGenericRep (CVAR_Int);
		m_Stat.Format("%d", num.Int);

		UpdateData(FALSE);


		return;

	}

	
}

void CDmflags::OnToggledmflags2() 
{
	int data, index, set=0, clear=0;
	UCVarValue			num2;

	index = m_Dmflags2.GetNextItem(-1, LVIS_SELECTED | LVIS_FOCUSED);

	// Okay, thats fine, its error time
    if (index == -1)
	{
		MessageBox("Gotta select something first", "Err0r0rz (2)", MB_OK);
		return;
	}
	else
	{
		// Cool! Lets toggle with dmflags
		data = m_Dmflags2.GetItemData(index);
		if (dmflags2 & c_dmflags2[data].flag)
			clear = c_dmflags2[data].flag;
		else
			set = c_dmflags2[data].flag;

		dmflags2 = (dmflags2 & ~clear) | set;

		ZD_BroadcastDMFlags(&dmflags2);

		c_dmflags2[data].value = !c_dmflags2[data].value;

		if (c_dmflags2[data].value)
			m_Dmflags2.SetItemText(data, COL_VALUE, "true");
		else
			m_Dmflags2.SetItemText(data, COL_VALUE, "false");

		// Update the number output
		num2 = dmflags2.GetGenericRep (CVAR_Int);
		m_Stat2.Format("%d", num2.Int);

		UpdateData(FALSE);


		return;

	}
	
}

// Double click support
void CDmflags::OnDblclkDmflags(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnToggledmflags();
	
	*pResult = 0;
}


// Right click support
void CDmflags::OnRclickDmflags(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnToggledmflags	();
	*pResult = 0;
}

// Double click support
void CDmflags::OnDblclkDmflags2(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnToggledmflags2	();
	*pResult = 0;
}

// Right click support
void CDmflags::OnRclickDmflags2(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnToggledmflags2	();
	*pResult = 0;
}
#endif