/*     -- i_instfunc.c --
** 
** Written by: Chris Laverdure <dashevil@sympatico.ca>
**
** This file belongs to the public domain.
**
*/

#ifdef EMBDEBUG
#include <stdlib.h>
#include "i_instfunc.h"

static char first = 1;
static unsigned long func_index = 0;

void __add_function_call(void *function, void *call_site, char call_type)
{
   if (bt++ > BTLIMIT - 1) // We've hit the top
   {
        bt = 0;
   } func_index++;

   btfunc[bt] = function;
   btsite[bt] = call_site;
   btcall[bt] = call_type;
   btindex[bt] = func_index;
}

void __cyg_profile_func_enter(void *this_fn, void *call_site)
{
   char x;

   if (first) // First execution.
   {
     for (x = 0; x < BTLIMIT; x++)     
     {
        btfunc[bt] = btsite[bt] = NULL;
	btcall[bt] = btindex[bt] = 0;
     }
     first = bt = 0;
   }

   __add_function_call(this_fn, call_site, CALL_ENTER);

}

void __cyg_profile_func_exit(void *this_fn, void *call_site)
{

   __add_function_call(this_fn, call_site, CALL_EXIT);

}
#endif
