/*******************************************
* B_game.h                                 *
* Description:                             *
* Misc things that has to do with the bot, *
* like it's spawning etc.                  *
* Makes the bot fit into game              *
*                                          *
*******************************************/
/*The files which are modified for Cajun Purpose
D_player.h (v0.85: added some variables)
D_netcmd.c (v0.71)
D_netcmd.h (v0.71)
D_main.c   (v0.71)
D_ticcmd.h (v0.71)
G_game.c   (v0.95: Too make demorecording work somewhat)
G_input.c  (v0.95: added some keycommands)
G_input.h  (v0.95)
P_mobj.c   (v0.95: changed much in the P_MobjThinker(), a little in P_SpawnPlayerMissile(), maybee something else )
P_mobj.h   (v0.95: Removed some unnecessary variables)
P_user.c   (v0.95: It's only one change maybee it already was there in 0.71)
P_inter.c  (v0.95: lot of changes)
P_pspr.c   (v0.71)
P_map.c    (v0.95: Test missile for bots)
P_tick.c   (v0.95: Freeze mode things only)
P_local.h  (v0.95: added> extern int tmsectortype)
Info.c     (v0.95: maybee same as 0.71)
Info.h     (v0.95: maybee same as 0.71)
M_menu.c   (v0.95: an extra menu in the key setup with the new commands)
R_main.c   (v0.95: Fix for bot's view)
wi_stuff.c (v0.97: To remove bots correct)

(v0.85) Removed all my code from: P_enemy.c
New file: b_move.c

******************************************
What I know has to be done. in near future.

- Do some hunting/fleeing functions.
- Make the roaming 100% flawfree.
- Fix all SIGSEVS (Below is known SIGSEVS)
      -Nada (but they might be there)
******************************************
Everything that is changed is marked (maybe commented) with "Added by MC"
*/

#include <time.h>
#include "doomdef.h"
#include "p_local.h"
#include "b_bot.h"
#include "g_game.h"
#include "m_random.h"
#include "z_zone.h"
#include "r_things.h"
#include "doomstat.h"
#include "cmdlib.h"
#include "sc_man.h"
#include "stats.h"
#include "m_misc.h"
#include "sbar.h"
#include "sv_main.h"
#include "log.h"
#include "wi_stuff.h"

//Externs
DCajunMaster bglobal;
cycle_t BotThinkCycles, BotSupportCycles;

EXTERN_CVAR (Int,	maxteams)				//Kilgore
EXTERN_CVAR (Int,	minplayers)				//Kilgore
EXTERN_CVAR (Int,   removebotswhenhumans)	//Kilgore

static const char *BotConfigStrings[] =
{
	"name",
	"aiming",
	"perfection",
	"reaction",
	"isp",
	NULL
};

enum
{
	BOTCFG_NAME,
	BOTCFG_AIMING,
	BOTCFG_PERFECTION,
	BOTCFG_REACTION,
	BOTCFG_ISP
};


void G_DoReborn (int playernum, bool freshbot);

//This function is called every tick (from g_game.c),
//send bots into thinking (+more).
void DCajunMaster::Main (int buf)
{
	BotThinkCycles = 0;

	Process_Bot_Chat();

	if (gamestate != GS_LEVEL)	return;

	m_Thinking = true;

	//Think for bots.
	if (botnum)
	{
		clock(BotThinkCycles);
		for (int i=top_client; i>=0; i--)
		{
			if (playeringame[i] && players[i].isbot && players[i].mo && !freeze)
				Think (players[i].mo, &players[i].cmd); 
		}
		unclock (BotThinkCycles);
	}

	//Add new bots?
	if (wanted_botnum > botnum && !freeze)
	{
		if ( ++bot_spawn_timer >= SPAWN_DELAY )
		{
			const char * const botname = (getspawned) ? getspawned->GetArg(spawn_tries) : NULL;
            if (!SpawnBot(botname))	wanted_botnum--;
            spawn_tries++;
			bot_spawn_timer = 0;
		}
	}

	m_Thinking = false;
}

void DCajunMaster::Init ()
{
	botnum = 0;
	firstthing = NULL;
	spawn_tries = 0;
	freeze = false;
	observer = false;
	body1 = NULL;
	body2 = NULL;
	bot_spawn_timer = 0;
	botchat_head = NULL;

	//Determine Combat distance for each weapon.
	if (deathmatch)
	{
		combatdst[wp_pistol]       = 25000000;
		combatdst[wp_shotgun]      = 24000000;
		combatdst[wp_chaingun]     = 27000000;
		combatdst[wp_missile]      = (SAFE_SELF_MISDIST*2);
		combatdst[wp_plasma]       = 27000000;
		combatdst[wp_bfg]          = 10000000;
		combatdst[wp_supershotgun] = 15000000;

		combatdst[wp_goldwand]     = 25000000;
		combatdst[wp_crossbow]     = 24000000;
		combatdst[wp_blaster]      = 27000000;
		combatdst[wp_skullrod]     = 27000000;
		combatdst[wp_phoenixrod]   = (SAFE_SELF_MISDIST*2);
		combatdst[wp_mace]         = 10000000;
	}
	else
	{
		combatdst[wp_pistol]       = 15000000;
		combatdst[wp_shotgun]      = 14000000;
		combatdst[wp_chaingun]     = 17000000;
		combatdst[wp_missile]      = (SAFE_SELF_MISDIST*3/2);
		combatdst[wp_plasma]       = 17000000;
		combatdst[wp_bfg]          = 6000000;
		combatdst[wp_supershotgun] = 10000000;

		combatdst[wp_goldwand]     = 15000000;
		combatdst[wp_crossbow]     = 14000000;
		combatdst[wp_blaster]      = 17000000;
		combatdst[wp_skullrod]     = 17000000;
		combatdst[wp_phoenixrod]   = (SAFE_SELF_MISDIST*3/2);
		combatdst[wp_mace]         = 60000000;
	}
	combatdst[wp_fist]         = 1;
	combatdst[wp_chainsaw]     = 1;
	combatdst[wp_staff]        = 1;
	combatdst[wp_gauntlets]    = 1;
	combatdst[wp_beak]         = 1;
	combatdst[wp_snout]        = 1;
	combatdst[wp_ffist]        = 1;
	combatdst[wp_cmace]        = 1;

	if (!botinfo)
	{
		LoadBots();
	}
	else
	{
		for (botinfo_t *b=botinfo;  b;  b=b->next)
			b->inuse = false;
	}
}

//Called on each level exit (from g_game.c).
void DCajunMaster::End ()
{
	int i;

	//Arrange wanted botnum and their names, so they can be spawned next level.
	if (getspawned)
		getspawned->FlushArgs ();
	else
		getspawned = new DArgs;
	for (i = 0; i < MAXPLAYERS; i++)
	{
		if (playeringame[i] && players[i].isbot)
		{
			if (deathmatch)
			{
				getspawned->AppendArg (players[i].userinfo.netname);
			}
			CleanBotstuff (&players[i]);
		}
	}
	if (deathmatch)
	{
		wanted_botnum = botnum;
	}
}



//Name can be optional, if = NULL
//then a random bot is spawned.
//If no bot with name = name found
//the function will CONS print an
//error message and will not spawn
//anything.
//The color parameter can be either a
//color (range from 0-10), or = NOCOLOR.
//The color parameter overides bots
//induvidual colors if not = NOCOLOR.

bool DCajunMaster::SpawnBot (const char *name, int color)
{
	int playernumber;

	//COLORS
	static const char colors[11][17] =
	{
		"\\color\\40 cf 00",	//0  = Green
		"\\color\\b0 b0 b0",	//1  = Gray
		"\\color\\50 50 60",	//2  = Indigo
		"\\color\\8f 00 00",	//3  = Deep Red
		"\\color\\ff ff ff",	//4  = White
		"\\color\\ff af 3f",	//5  = Bright Brown
		"\\color\\bf 00 00",	//6  = Red
		"\\color\\00 00 ff",	//7  = Blue
		"\\color\\00 00 7f",	//8  = Dark Blue
		"\\color\\ff ff 00",	//9  = Yellow
		"\\color\\cf df 90"		//10 = Bleached Bone
	};

	for (playernumber = 0; playernumber < MAXPLAYERS; playernumber++)
	{
		if (!playeringame[playernumber] && !waitingforspawn[playernumber])
		{
			break;
		}
	}

	if (playernumber == MAXPLAYERS)
	{
		Printf ("The maximum of %d players/bots has been reached\n", MAXPLAYERS);
		return false;
	}

	botinfo_t *thebot;

	if (name)
	{
		thebot = botinfo;

		// Check if exist or already in the game.
		while (thebot && stricmp (name, thebot->name))
			thebot = thebot->next;

		if (thebot == NULL)
		{
   		 	Printf ("couldn't find %s in %s\n", name, BOTFILENAME);
			return false;
		}
		else if (thebot->inuse)
		{
   		 	Printf ("%s is already in the thick\n", name);
			return false;
		}
	}
	else if (botnum < loaded_bots)
	{
		bool vacant = false;  //Spawn a random bot from bots.cfg if no name given.
		while (!vacant)
		{
			int rnum = (pr_botspawn() % loaded_bots);
			thebot = botinfo;
			while (rnum)
				--rnum, thebot = thebot->next;
			if (!thebot->inuse)
				vacant = true;
		}
	}
	else
	{
		Printf ("Couldn't spawn bot; no bot left in %s\n", BOTFILENAME);
		return false;
	}

	waitingforspawn[playernumber] = true;

	Net_WriteByte (DEM_ADDBOT);
	Net_WriteByte (playernumber);
	{
		//Set color.
		char concat[512];
		strcpy (concat, thebot->info);
		if (color == NOCOLOR && bot_next_color < NOCOLOR && bot_next_color >= 0)
		{
			strcat (concat, colors[bot_next_color]);
		}
		if (thebot->lastteam < NUM_TEAMS)
		{ // Keep the bot on the same team when switching levels
			sprintf (concat+strlen(concat), "\\team\\%d\n", thebot->lastteam);
		}
		Net_WriteString (concat);
	}

	players[playernumber].skill = thebot->skill;

	thebot->inuse = true;

	//Increment this.
	botnum++;

	return true;
}

void DCajunMaster::DoAddBot (int bnum, char *info)
{
	D_ReadUserInfoStrings (bnum, (byte **)&info, false);
	if (!deathmatch && playerstarts[bnum].type == 0)
	{
		Printf ("%s tried to join, but there was no player %d start\n",
			players[bnum].userinfo.netname, bnum+1);
		ClearPlayer (bnum, false);	// Make the bot inactive again
		botnum--;
	}
	else
	{
		multiplayer = true; //Prevents cheating and so on; emulates real netgame (almost).
		players[bnum].isbot = true;
		playeringame[bnum] = true;
		players[bnum].mo = NULL;
		players[bnum].playerstate = PST_ENTER;
		botingame[bnum] = true;
		Printf ("%s joined the game\n", players[bnum].userinfo.netname);

		G_DoReborn (bnum, true);
		if (StatusBar != NULL)
		{
			StatusBar->MultiplayerChanged ();
		}
	}
	waitingforspawn[bnum] = false;
}

void DCajunMaster::RemoveAllBots (bool fromlist)
{
	int i, j;

	for (i = 0; i < MAXPLAYERS; ++i)
	{
		if (playeringame[i] && botingame[i])
		{
			// If a player is looking through this bot's eyes, make him
			// look through his own eyes instead.
			for (j = 0; j < MAXPLAYERS; ++j)
			{
				if (i != j && playeringame[j] && !botingame[j])
				{
					if (players[j].camera == players[i].mo)
					{
						players[j].camera = players[j].mo;
						if (j == consoleplayer)
						{
							StatusBar->AttachToPlayer (players + j);
						}
					}
				}
			}
			ClearPlayer (i, !fromlist);
		}
	}

	if (fromlist)
	{
		wanted_botnum = 0;
		for (i = 0; i < MAXPLAYERS; i++)
			waitingforspawn[i] = false;
	}
	botnum = 0;
}

//Clean the bot part of the player_t
//Used when bots are respawned or at level starts.
void DCajunMaster::CleanBotstuff (player_t *p)
{
	p->angle = ANG45;
	p->dest = NULL;
	p->enemy = NULL; //The dead meat.
	p->missile = NULL; //A threatening missile that needs to be avoided.
	p->mate = NULL;    //Friend (used for grouping in templay or coop.
	p->last_mate = NULL; //If bot's mate dissapeared (not if died) that mate is pointed to by this. Allows bot to roam to it if necessary.
	//Tickers
	p->t_active = 0; //Open door, lower lift stuff, door must open and lift must go down before bot does anything radical like try a stuckmove
	p->t_respawn = 0;
	p->t_strafe = 0;
	p->t_react = 0;
	//Misc bools
	p->isbot = true; //Important.
	p->first_shot = true; //Used for reaction skill.
	p->sleft = false; //If false, strafe is right.
	p->allround = false;
	p->redteam = false; //in ctf, if true this bot is on red team, else on blue..
}


//------------------
//Reads data for bot from
//a .bot file.
//The skills and other data should
//be arranged as follows in the bot file:
//
//{
// Name			bot's name
// Aiming		0-100
// Perfection	0-100
// Reaction		0-100
// Isp			0-100 (Instincts of Self Preservation)
// ???			any other valid userinfo strings can go here
//}

static void appendinfo (char *&front, const char *back)
{
	char *newstr;

	if (front)
	{
		size_t newlen = strlen (front) + strlen (back) + 2;
		newstr = new char[newlen];
		strcpy (newstr, front);
		delete[] front;
	}
	else
	{
		size_t newlen = strlen (back) + 2;
		newstr = new char[newlen];
	}
	strcat (newstr, "\\");
	strcat (newstr, back);
	front = newstr;
}

void DCajunMaster::ForgetBots ()
{
	botinfo_t *thebot = botinfo;

	while (thebot)
	{
		botinfo_t *next = thebot->next;
		delete[] thebot->name;
		delete[] thebot->info;
		delete thebot;
		thebot = next;
	}

	botinfo = NULL;
	loaded_bots = 0;
}

bool DCajunMaster::LoadBots ()
{
	char *tmp;
	bool gotteam;

	bglobal.ForgetBots ();
#ifndef unix
	tmp = new char[8 + strlen(BOTFILENAME) + strlen(progdir)];
	sprintf (tmp, "%szcajun/" BOTFILENAME, progdir);
	if (!FileExists (tmp))
	{
		DPrintf ("No " BOTFILENAME ", so no bots\n");
		return false;
	}
#else
	tmp = GetUserFile (BOTFILENAME);
	if (!FileExists (tmp))
	{
		if (!FileExists (SHARE_DIR BOTFILENAME))
		{
			DPrintf ("No " BOTFILENAME ", so no bots\n");
			return false;
		}
		else
			SC_OpenFile (SHARE_DIR BOTFILENAME);
	}
#endif
	else
	{
		SC_OpenFile (tmp);
	}
	if (tmp)
	{
		delete[] tmp;
	}

	while (SC_GetString ())
	{
		if (!SC_Compare ("{"))
		{
			SC_ScriptError ("Unexpected token '%s'\n", (const char **)&sc_String);
		}

		botinfo_t *newinfo = new botinfo_t;
		bool gotclass = false;

		memset (newinfo, 0, sizeof(*newinfo));

		newinfo->info = copystring ("\\autoaim\\0\\movebob\\.25");

		for (;;)
		{
			SC_MustGetString ();
			if (SC_Compare ("}"))
				break;

			switch (SC_MatchString (BotConfigStrings))
			{
			case BOTCFG_NAME:
				SC_MustGetString ();
				appendinfo (newinfo->info, "name");
				appendinfo (newinfo->info, sc_String);
				newinfo->name = copystring (sc_String);
				break;

			case BOTCFG_AIMING:
				SC_MustGetNumber ();
				newinfo->skill.aiming = sc_Number;
				break;

			case BOTCFG_PERFECTION:
				SC_MustGetNumber ();
				newinfo->skill.perfection = sc_Number;
				break;

			case BOTCFG_REACTION:
				SC_MustGetNumber ();
				newinfo->skill.reaction = sc_Number;
				break;

			case BOTCFG_ISP:
				SC_MustGetNumber ();
				newinfo->skill.isp = sc_Number;
				break;

			case BOTCFG_TEAM:
				{
					char teamstr[4];
					unsigned int teamnum;

					SC_MustGetString ();
					if (IsNum (sc_String))
					{
						teamnum = atoi (sc_String);
						if (teamnum >= NUM_TEAMS)
						{
							teamnum = TEAM_None;
						}
					}
					else
					{
						teamnum = TEAM_None;
						for (int i = 0; i < NUM_TEAMS; ++i)
						{
							if (stricmp (TeamNames[i], sc_String) == 0)
							{
								teamnum = i;
								break;
							}
						}
					}
					appendinfo (newinfo->info, "team");
					sprintf (teamstr, "%u", teamnum);
					appendinfo (newinfo->info, teamstr);
					gotteam = true;
					break;
				}

			default:
				if (stricmp (sc_String, "playerclass") == 0)
				{
					gotclass = true;
				}
				appendinfo (newinfo->info, sc_String);
				SC_MustGetString ();
				appendinfo (newinfo->info, sc_String);
				break;
			}
		}
		if (!gotclass)
		{ // Bots that don't specify a class get a random one
			appendinfo (newinfo->info, "playerclass");
			appendinfo (newinfo->info, "random");
		}
		if (!gotteam)
		{ // Same for bot teams
			appendinfo (newinfo->info, "team");
			appendinfo (newinfo->info, "255");
		}
		newinfo->next = bglobal.botinfo;
		newinfo->lastteam = TEAM_None;
		bglobal.botinfo = newinfo;
		bglobal.loaded_bots++;
	}
	SC_Close ();

	Printf ("%d bots read from %s\n", bglobal.loaded_bots, BOTFILENAME);

	return true;
}

ADD_STAT (bots, out)
{
	sprintf (out, "think = %04.1f ms  support = %04.1f ms  wtg = %lu",
		(double)BotThinkCycles * 1000 * SecondsPerCycle,
		(double)BotSupportCycles * 1000 * SecondsPerCycle,
		BotWTG);
}

////////////////////////////////////////////////////////////////

void DCajunMaster::Clear_Bot_Chat(int bnum)
{
	botchatstr_t	*p, *next, *last;

	last = NULL;
	for (p=botchat_head;  p;   )
	{
		if (p->bnum==bnum)
		{
			next = p->next;
			if (last)	last->next = next;
			else		botchat_head = next;
			free(p);
			p = next;
		}
		else
		{
			last = p;
			p = p->next;
		}
	}
}

////////////////////////////////////////////////////////////////

void DCajunMaster::Add_Bot_Chat(int bnum, const char *s, int ndelay)
{
	botchatstr_t	*p;

	if ( (p=(botchatstr_t *)malloc(sizeof(botchatstr_t)+strlen(s))) == NULL )
		return;
	p->next = botchat_head;
	p->bnum = bnum;
	p->time_counter = ndelay;
	strcpy(p->s,s);
	botchat_head = p;
}

////////////////////////////////////////////////////////////////

void DCajunMaster::Process_Bot_Chat()
{
	botchatstr_t	*p, *next, *last;

	last = NULL;
	for (p=botchat_head;  p;   )
	{
		if (--(p->time_counter) <= 0)
		{
			ZD_ChatSend(0,p->s,p->bnum,-1);
			next = p->next;
			if (last)	last->next = next;
			else		botchat_head = next;
			free(p);
			p = next;
		}
		else
		{
			last = p;
			p = p->next;
		}
	}
}

////////////////////////////////////////////////////////////////

static int bounded_random(int minsecs, int maxsecs)
{
	int interval;

	interval = (maxsecs - minsecs)*TICRATE;
	return minsecs*TICRATE + (rand() % interval);
}

////////////////////////////////////////////////////////////////

static const char *
player_name_by_score(int v, int self_id)
{
	int			i;
	player_t	*p;

	if (gamestate == GS_INTERMISSION)
		for (i=top_client; i>=0; i--)
		{
			if (i==self_id) continue;
			if (!wminfo.plyr[i].in) continue;
			if (wminfo.plyr[i].spectator) continue;
			if (wminfo.plyr[i].fragcount==v)
				return players[i].userinfo.netname;
		}
	else
		for (i=top_client; i>=0; i--)
		{
			if (i==self_id) continue;
			if (!playeringame[i]) continue;
			p = players + i;
			if (p->spectator) continue;
			if (p->fragcount==v)
				return p->userinfo.netname;
		}

	return "***";
}

////////////////////////////////////////////////////////////////

// %b -> bottom
// %t -> top
// %s -> self
// %v -> victim (for kills only)
static const char *
translate_bot_chat(const char *s, int minv, int maxv,
				   int self_id, int victim_id)
{
	char		*pout, c;
	const char	*name;
	static char	buf[1024];

	pout = buf;
	while ( (c = *s++) != '\0')
	{
		if (c != '%')
		{
			*pout++ = c;
			continue;
		}
		c = *s++;
		if (c == '\0')
			break;
		else if (c == 't')
		{
			name = player_name_by_score(maxv, self_id);
			strcpy(pout,name);
			pout += strlen(name);
		}
		else if (c == 'b')
		{
			name = player_name_by_score(minv, self_id);
			strcpy(pout,name);
			pout += strlen(name);
		}
		else if (c == 's')
		{
			name = (self_id>=0) ? players[self_id].userinfo.netname : "***";
			strcpy(pout,name);
			pout += strlen(name);
		}
		else if (c == 'v')
		{
			name = (victim_id>=0) ? players[victim_id].userinfo.netname : "***";
			strcpy(pout,name);
			pout += strlen(name);
		}
		else
		{
			*pout++ = c;
		}
	}
	*pout = '\0';
	return buf;
}

////////////////////////////////////////////////////////////////

static const char *bc_end_top_msg(int minv,int maxv,int self_id)
{
	int					i;
	static const int	prob_talk = 100;
	static int			nmsgs = 0, ntotal = 0;
	static const char	*msgs[] =
	{
		"Groovy",
		"gg",
		"My house!",
		"Don't mess with the best!",
		"Yesssssss!!!",
		"Holey Moley!",
		"Wow",
		"Game Over! Insert Coin",
		":-D",
		"heh",
		"Bring 'em on, I'm hot today!!",
		"I'm new and improved. Can't you tell?",
		"gg",
		":-)",
		"gg",
		"gg",
		"gg",
		"gg",
		"Oh, Yesssssss!",
		"You're slowing down %b. That was far too easy.",
		"%b maybe you ought to take up chess.",
		"You do a great 'roadkill' impression, %b",
		"My how the mighty have fallen. And fallen. And fallen.",
		"A million customers served ;-)",
		"Are you normally this bad, %b?",
		"Cooperate and we'll all be done much sooner.",
		"Maybe you're just in the wrong line of business.",
		"Your body and head will need separate maintainance",
		"p0wned",
		"lol",
		"Yabadabadooo!!",
		"Your mother died of sadness from seeing you %b; did she not?",
		"Just stand still and I'll make it quick",
		"l33t",
		"ph33r",
		NULL
	};

	if (nmsgs==0)
	{
		for (i=0; msgs[i];  i++)
			;
		nmsgs = i;
		ntotal = nmsgs * 100;
		ntotal /= prob_talk;
	}
	i = rand() % ntotal;
	return (i<nmsgs) ? translate_bot_chat(msgs[i],minv,maxv,self_id,-1) : NULL;
}

////////////////////////////////////////////////////////////////

static const char *bc_end_middle_msg(int minv,int maxv,int self_id)
{
	int					i;
	static const int	prob_talk = 80;
	static int			nmsgs = 0, ntotal = 0;
	static const char	*msgs[] =
	{
		"gg",
		":)",
		"good match",
		"That was definitely fun ... let's do it again sometime",
		"hehehe",
		"Challenging",
		"Nice!",
		"Owww. Way to go %t. That definitely hurt.",
		":-(",
		":)",
		"Nice one, %t",
		"Nice! How you'd do that %t?",
		"Impressive!",
		"Excellent!!",
		"That rocked %t!",
		"I never saw that one coming %t",
		"Smooo-oooth",
		"Nice shootin' %t!",
		"Some mighty fine shooting there, %t",
		"That was bellisimo, baby!",
		"This will not go unavenged",
		"Good match ... better if I win.",
		"Definitely fun ... let's do it again sometime.",
		"You just try that again, %t",
		"Accidents happen",
		"Be afraid, %t. Be very afraid.",
		"I'm learning your tricks, %t.",
		"gg",
		"gg",
		"gg",
		"gg",
		"gg",
		"gg",
		"gg",
		"gg",
		"gg",
		"gg",
		"gg",
		"gg",
		"Bunch of losers",
		"Ay de mi'! It smells like purgatory. Huele malo.",
		NULL
	};

	if (nmsgs==0)
	{
		for (i=0; msgs[i];  i++)
			;
		nmsgs = i;
		ntotal = nmsgs * 100;
		ntotal /= prob_talk;
	}
	i = rand() % ntotal;
	return (i<nmsgs) ? translate_bot_chat(msgs[i],minv,maxv,self_id,-1) : NULL;
}

////////////////////////////////////////////////////////////////

static const char *bc_end_bottom_msg(int minv,int maxv,int self_id)
{
	int					i;
	static const int	prob_talk = 80;
	static int			nmsgs = 0, ntotal = 0;
	static const char	*msgs[] =
	{
		"Heh ... I had the safety on ...",
		"I'm taking off the kid gloves now, %t!",
		"Okay, now I start fighting for real!",
		"Enjoy that one. Your luck is about to run out, %t.",
		"Now the match gets serious.",
		"%t you're a stinking camper!",
		"camper!!!!!",
		"I see laming is back in fashion",
		"I'm definitely out of my league here.",
		"Figures, Mr. Camper on top",
		"That was the biggest waste of time ever.",
		"This has been tragic.",
		"It saddens me to see tactics brought to such a low estate.",
		"I will accept this as yet another learning experience.",
		":-(",
		"That was lame and you know it, %t",
		"This has been truly tragic",
		"What a world ... what a world",
		"I vote %t as happy camper of the day!",
		"You're allowed one lucky shot a day, %t",
		"I'm not impressed, %t",
		"gg",
		"gg",
		"gg",
		"gg",
		"gg",
		"gg",
		"grrrr",
		"grrrr",
		"boolshit fighta",
		"Caramba! When did hell freeze over?",
		"Madre de Dios!",
		"I bet you don't get invited to many parties, %t",
		"Ouch. That hurt",	
		"ouch",	
		"ouch",	
		"The pain... the pain",
		NULL
	};

	if (nmsgs==0)
	{
		for (i=0; msgs[i];  i++)
			;
		nmsgs = i;
		ntotal = nmsgs * 100;
		ntotal /= prob_talk;
	}

	i = rand() % ntotal;
	return (i<nmsgs) ? translate_bot_chat(msgs[i],minv,maxv,self_id,-1) : NULL;
}

////////////////////////////////////////////////////////////////

void DCajunMaster::Bot_Chatter_At_End(void)
{
	int			i, minv, maxv, v, nplayers;
	const char	*s;
	player_t	*p;

	if (botnum<=0) return;

	minv = 100000;
	maxv = -minv;
	nplayers = 0;
	for (i=top_client; i>=0; i--)
	{
		if (!wminfo.plyr[i].in) continue;
		if (wminfo.plyr[i].spectator) continue;
		v = wminfo.plyr[i].fragcount;
		if (v>maxv) maxv = v;
		if (v<minv) minv = v;
		nplayers++;
	}

	if (nplayers<2) return;

	for (i=top_client;  i>=0;  i--)
	{
		if (!wminfo.plyr[i].in)	continue;
		p = players + i;
		if (!p->isbot) continue;
		v = wminfo.plyr[i].fragcount;
		s = (maxv==minv) ?	bc_end_middle_msg(minv,maxv,i) :
			(v==minv)	 ?	bc_end_bottom_msg(minv,maxv,i) :
			(v==maxv)	 ?	bc_end_top_msg(minv,maxv,i) :
							bc_end_middle_msg(minv,maxv,i);
		if (s)
			Add_Bot_Chat(i, s, bounded_random(1,7));
	}
}

////////////////////////////////////////////////////////////////

static const char *bc_entry_msg(int minv,int maxv,int self_id)
{
	int					i;
	static const int	prob_talk = 90;
	static int			nmsgs = 0, ntotal = 0;
	static const char	*msgs[] =
	{
		"It's pay-back time!",
		"Run for cover %t! I'm back!",
		"Hello",
		"I bet you missed me",
		"G'day",
		"Yo! %s is in the house!",
		"wassup!",
		"Hey",
		"Hi",
		"Run in fear, %s is here!",
		"Let's get it on!",
		"Crap. Losers in here again!",
		"Yessss! New victims everywhere!",
		"I'm back!",
		"Showtime!",
		"Let's rock and roll",
		"Let's rock",
		"Great! Nothing but easy frags here today.",
		"It's party time!",
		"Let's kick it",
		"Let's get rollin'",
		"Time for some fireworks",
		"Today, I am death incarnate! Fear the name of %s",
		"Yo, %t I've got a rocket with your name on it!",
		"%s is here. There will be no survivors!",
		"Yo! I'm back in da House!",
		"WOW! Is the circus in town or something?",
		"So, %t we meet again",
		"Where are you hiding little rabbit?",
		"Let the Tears begin!",
		"Guess its time to mow the grass",
		"I am so ready for this",
		"It's time for 'Bowling for Morons'",
		"I'm like a kid in a candy store!",
		"Fresh meat",
		"Howdy!",
		"Let's get it ON!",
		"Let's do it!",
		"No Prisoners!",
		"It's time for %s to lay down the law here.",
		NULL
	};

	if (nmsgs==0)
	{
		for (i=0; msgs[i];  i++)
			;
		nmsgs = i;
		ntotal = nmsgs * 100;
		ntotal /= prob_talk;
	}

	i = rand() % ntotal;
	return (i<nmsgs) ? translate_bot_chat(msgs[i],minv,maxv,self_id,-1) : NULL;
}

////////////////////////////////////////////////////////////////

void DCajunMaster::Bot_Chatter_At_Entry(int bnum)
{
	int			i, minv, maxv, v, nclients, nplayers;
	const char	*s;
	player_t	*p;

	minv = 100000;
	maxv = -minv;
	nclients = nplayers = 0;
	for (i=top_client; i>=0; i--)
	{
		if (i==bnum) continue;
		if (!playeringame[i]) continue;
		nclients++;
		p = players + i;
		if (p->spectator) continue;
		nplayers++;
		v = p->fragcount;
		if (v>maxv) maxv = v;
		if (v<minv) minv = v;
	}
	if (nclients==0) return;
	if (nplayers==0)	//Get a random spectator for the top / bottom names
		maxv = minv = 0;
	s = bc_entry_msg(minv,maxv,bnum);
	if (s)
		Add_Bot_Chat(bnum, s, bounded_random(0,2));
}

////////////////////////////////////////////////////////////////

static const char *bc_frag_msg(int self_id, int victim_id)
{
	int					i;
	static const int	prob_talk = 30;
	static int			nmsgs = 0, ntotal = 0;
	static const char	*msgs[] =
	{
		"Nice catch, %v!",
		"Somebody stop me!",
		"Watch yer back next time %v",
		"Sorry, %v; this is a NO BREATHING zone.",
		"Burn baby, burn",
		"He's dead, Jim!",
		"Someone get a mop.",
		"What we have here, is a failure to communicate",
		"Bag 'em and tag 'em!",
		"Do you to practice to be that bad, %v?",
		"There oughtta be a law against me.",
		"Get down and stay down!",
		"Mess with the best, %v; die like the rest!",
		"You fought the law and the law won.",
		"Clean up your mess before you go %v",
		"Whack 'em and Stack 'em!",
		"Somebody wanna clean this mess up?",
		"Let's see ... you were 'on the phone', right?",
		"lol",
		"My mama taught me that move ... just before I fragged her.",
		"That was quick.",
		"Asi' se hace!",
		"You liked that, si?",
		"Who's your Mommy?",
		"It's never too late for a change of career, %v",
		"Is that your face, %v, or are you mooning me?",
		NULL
	};

	if (nmsgs==0)
	{
		for (i=0; msgs[i];  i++)
			;
		nmsgs = i;
		ntotal = nmsgs * 100;
		ntotal /= prob_talk;
	}

	i = rand() % ntotal;
	return (i<nmsgs) ? translate_bot_chat(msgs[i],-1000,-1000,self_id,victim_id) : NULL;
}

////////////////////////////////////////////////////////////////

void DCajunMaster::Bot_Chatter_At_Frag(int bnum, int victim)
{
	const char *s;

	if (bnum==victim) return;
	s = bc_frag_msg(bnum,victim);
	if (s)
		Add_Bot_Chat(bnum, s, bounded_random(0,1));
}
